2004-12-30  Quentin Mathe <qmathe@club-internet.fr>

        * Source/GSToolbarView.m: Modified to be more compliant with GNUstep 
        coding standards.
        (-draggingEntered:):
        (-draggingUpdated:): Prevents the user to customize the toolbar when 
        -allowsUserCustomization returns NO (bug #11393).
        * Source/NSToolbarItem.m: Modified to be more compliant with GNUstep 
        coding standards.
        (-mouseDown:): Prevents the user to customize the toolbar when 
        -allowsUserCustomization returns NO (bug #11393).

2004-12-23 05:38 Gregory John Casamento <greg_casamento@yahoo.com>

        * Images/MagnifyGlass.tiff: Added.  The NSColorPanel class uses 
        this image.
	
2004-12-13  Quentin Mathe <qmathe@club-internet.fr>

        * Source/NSComboBoxCell.m: Modified the code to be clearer
        Renamed internal class GSFirstMouseTableView to GSComboBoxTableView
        Removed GSComboWindow _localSelection ivar which is not needed, because 
        the user selection is now handled in -clickItem and not in 
        -tableViewSelectionDidChange: which is now reserved to the internal (aka
        local) selection support.
        (-[GSComboWindow selectItem:]): Renamed the method name to -clickItem:
        (-[GSComboWindow clickItem:]): Reworked to the method to be used by the 
        NSTableView (or NSBrowser) action to track the user clicks.
        (-[GSComboWindow validateSelection:]): Rewritten the method to handle
        itself the selection, the method updates now the cell object value and 
        sends the action bound to the cell.
        (-selectItemAtIndex:): Updated the method to match the Cocoa 
        specification which states that this method should adjust the selection 
        in the combo box list but not simulate a user click.

2004-12-09  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSCursor.m (getStandardCursor()): If not standard cursor
	is available, try an image cursor with an image of the same name.
	* Images/common_OpenHandCursor.tiff
	* Images/common_ClosedHandCursor.tiff: New cursor image files by
	Fabien Vallon <fabien@sonappart.net>.
	* Images/GNUmakefile: Install the new files.
	* Images/nsmapping.strings: Register the new cursor files for the
	names used in NSCursor.m.

2004-11-11  Adam Fedor  <fedor@gnu.org>

	* Source/GSDragView.m ([GSDragView -_setCursor]): Initialize variable.
	* Source/NSMatrix.m: Rename vaguely-named macro.
	(Based on Patch #3499 from Patrick Middleton).

2004-11-11  Adam Fedor  <fedor@gnu.org>

	* Version: Add numeric value for runtime versioning.
	* Souce/GNUmakeifle: Add resource set install.
	* Source/GNUmakefile.postamble (Info-gnustep.plist): New target.

2004-11-11  Adam Fedor  <fedor@gnu.org>

	* Model/GMAppKit.m ([NSPopUpButton -encodeWithModelArchiver:]): 
	More robust method for getting title (works on OPENSTEP, from
	George Fleischmann).

2004-11-11  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSMenu.h
	* Source/NSMenu.m (-setMain:): New internal method to set the main
	menu of an application. Uses code from [NSApplication
	setMainMenu:] plus a display call for the new main menu.
	* Source/NSApplication.m (-setMainMenu:): Use the new method on
	NSMenu to flag a menu as main and cleaned up the logic.

2004-11-11 15:08  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSCell.m (-_setupTextWithFrame:inView:editor:): Reduce the
	maximum size. Explicitly set the size of the text view, and make it
	not resizable.
	* Source/NSLayoutManager.m (-rectArrayForGlyphRange:
	withinSelectedGlyphRange:inTextContainer:rectCount:): Fix check for
	whether the starting index is inside a line frag rect.
	* Source/NSTextView.m (-sizeToFit): Don't increase the size if we
	have no inset.
	(-updateInsertionPointStateAndRestartTimer:): Force the insertion
	point rect to be inside the text view.
	(-scrollRangeToVisible:): If we are a non-rich-text field editor,
	adjust the scrolling to make the auto-scrolling more useful.

	Fixes bug #9279.

2004-11-10  Matt Rice <ratmice@yahoo.com>

	* Headers/Additions/GNUstepGUI/GSDisplayServer.h (-iconSize): New method
	declaration.
	(-iconTileImage): Ditto. 
	* Source/GSDisplayServer.m (-resolutionForScreen:): Fix Typo in Docs.
	(-boundsForScreen:): Ditto.
	(-windowBounds:): Ditto.
	(-iconSize): Implement new method.
	(-iconTileImage): Ditto.
	* Source/NSApplication.m (NSAppIconView): Remove 
	useWindowmakerIconBackground variable.
	(scaledIconSizeForSize): New function.
	([NSAppIconView +initialize]): Dont set a default image here. Remove
	usage of GSUseWindowmakerIconBackground default. Use backend tile and
	scale it to the backend icon size.
	([NSAppIconView -drawRect:]): Remove usage of 
	useWindowmakerIconBackground. Draw cells with the backend icon size.
	([NSAppIconView -setImage:]): Set the image to a scaled copy. 
	setNeedsDisplay instead	of drawing directly.
	([NSApplication -_appIconInit]): Use backend icon size.
	* Source/NSWindow.m: Remove useWindowmakerIconBackground variable.
	(scaledIconSizeForSize): New function.
	([NSMiniWindowView +initialize]): Remove usage of 
	GSUseWindowmakerIconBackground default.	Use backend tile image and scale
	it to the backend icon size.
	([NSMiniWindowView -drawRect:]): Remove usage of 
	useWindowmakerIconBackground. Draw cells with the backend iconSize.
	([NSMiniWindowView -setImage:]): Set the image to a scaled copy. 
	setNeedsDisplay instead	of drawing directly.
	([NSMiniWindowView -setTitle:]): setNeedsDisplay instead of drawing 
	directly.
	([NSWindow -miniaturize:]): Use backend icon size.
	* Documentation/GuiUser/DefaultsSummary.gsdoc: Remove docs for 
	GSUseWindowmakerIconBackground.

2004-11-09 Adrian Robert <arobert@cogsci.ucsd.edu>

	* Source/NSTabView.m (-insertTabViewItem:): Update display.
	(-removeTabViewItem:): Same.
	(-selectTabViewItem:): Fix erroneous comment.
	(-selectTabViewItemAtIndex:) Check index in range.
	(-drawRect:) Don't try to select first tab if there are no tabs.
	* Source/NSColorList.m (-initWithNameFromFile:) Treat filename
	given as full path, not directory (but support this previous
	behavior in case apps are relying on it).  Also, if fail to read
	file as an archive, try text format.
	(+loadAvavailableColorLists:) Adjust code for change to
	-initWithName:fromFile:.
	(-_readTextColorFile:) New utility method to support
	-initWithNameFromFile:.
	* Headers/AppKit/NSColorList.h: Document above changes.

2004-11-09 22:36  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSInfoPanel.m (_value_from_info_plist_for_key): Rename to
	value_from_info_plist_for_key.
	(_nil_or_not_of_class): Rename to nil_or_not_of_class.
	Update callers.
	(-initWithDictionary:): Fix comment typo.
	* Source/NSAlert.m: Whitespace cleanups.
	* Source/NSPrinter.m: Whitespace cleanups.

2004-11-09 22:08  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:):
	Implement NSLineBreakByClipping. Set outside_line_frag and dont_show
	attributes for every glyph.

2004-11-09 18:55  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSPasteboard.m (+_pbs): Give gpbs a --GSStartupNotification
	argument. Listen for the notification and connect immediately if it
	arrives. Clarify the user message. Fixes bug #10876.

2004-11-08  Quentin Mathe <qmathe@club-internet.fr>
        
	* Source/NSButtonCell.m (-setImage:): Added overriden NSCell method in 
	order to have the cell switched to an image cell (with the NSImageOnly
	position) when you call -setImage:. With the previous commit, when the
	cell is a text cell and you call -setImagePosition: after -setImage:,
	the cell image is released.
	
2004-11-07  Quentin Mathe <qmathe@club-internet.fr>
        
	* Source/NSCell.m (-type): Now returns NSNullCellType when the image
	value is nil and the cell type is NSImageCellType, in order to match the
	documented Cocoa behavior.
	* Source/NSButtonCell.m (-setImagePosition:): Finished to commit the
	patch (not fully applied) associated with the revision 1.90, the bug
	#10595 is now corrected.

2004-11-07  Quentin Mathe <qmathe@club-internet.fr>

        * Source/NSWindow.m (-constrainFrameRect:toScreen:): Modified the method
	to match the specification and the constraints used when the user
	moves/resizes the window with the cursor. That makes possible to have
	resizable windows which extends below the bottom of the screen as long
	as you can move them up to take back the resize control on the screen.
	(-setFrame:display:): Modified the method to remove the possibility to
	have the window title bar positioned over the top of the screen when
	using -gui window decorations.

2004-11-06 08:34 Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Removed nibInstantiate.  This method
	should only be defined and used inside the GUI builder application
	according to specs.
	
2004-11-04 Adrian Robert <arobert@cogsci.ucsd.edu>

	* Documentation/GuiUser/KeyboardSetup.gsdoc: Describe the new
	"GSModifiersAreKeys" default.
	
2004-10-31 12:04 Gregory John Casamento <greg_casamento@yahoo.com>

	* GNUmakefile.postamble: Removed the after-clean clean section
	which is attempting to remove directories which existed prior to
	the change which moved all of the headers.  While this is not
	causing an issue on Linux, some other environments fail when 
	attempting to "make distclean".

2004-10-30  Alex Perez  <aperez@student.santarosa.edu>

	* Headers/AppKit/NSImage.h (+_standardImageWithName:): New method.
	* Source/NSImage.m (+_standardImageWithName:): New method.
	* Source/NSWorkspace.m (_getImageForName:alternate:): Remove. Update
	callers to use +_standardImageWithName: instead.

2004-10-25  Quentin Mathe <qmathe@club-internet.fr>

        * Source/NSWorkspace.m: Moved the code which looks for the application
	icons in the method -iconForFile: to the method -appIconForApp:. As
	a side effect, it fix the bug introduced by my last commit which caused
	a nil exception when the application info.plist contains no NSIcon
	entry.

2004-10-24  Quentin Mathe <qmathe@club-internet.fr>
        
	* Source/NSWorkspace.m (-appIconForApp:): Fixed code to be more
	generic by using -[NSBundle pathForImageResource:]. Now the method
	works with NSIcon value not path based like "MyApplication.tiff".

2004-10-22 08:26 Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSStepperCell.m: Corrected issue with [NSStepperCell
	initWithCoder:] for encoding issue with gcc 3.4.
	* Header/AppKit/NSStepperCell.h: Took out defines which use
	the bitfields in NSCell.h.   These now are BOOL variables.
	
2004-10-21  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSResponder.m (-initWithCoder:): Set missing default
	value for menu to nil.
	* Source/NSButtonCell.m (-initWithCoder:): Hack around Apple NIB
	bug and decode some of the flags.

2004-10-17 Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSCell.m: Added code to [NSCell initWithCoder:] which 
	properly retains the formatter and menu.
	* Source/GSNibCompatibility.m: Changed comment.
	* Source/NSResponder.m: Added keyed archiving implementation in
	initWithCoder:
	* Source/NSTextView.m: Improved implementation of keyed coding
	for NSTextView.  Also preparing to add details discovered about
	the flag settings.
	* Source/NSView.m: Improved NSView keyed decoding.  Also made
	sure that [super initWithCoder:] is called in that method for both
	the keyed and non-keyed archiving (as it should be).
	* Source/NSWindow.m: Added implementation of undo: and redo: to 
	NSWindow.m.  

2004-10-17 Adrian Robert <arobert@cogsci.ucsd.edu>

	* Source/Functions.m (NSBestDepth): Check outarg exactMatch is
	non-null before setting.
	* Source/NSFont.m (getNSFont): Use defaultSize for 'fontSize'
	args of <0 as well as ==0; documented.

2004-10-11  Georg Fleischmann
	
	* Model/GMAppKit.m [-encodeWithModelArchiver:] remove title
	  bar and resize bar from 'minSize'.

2004-10-15 07:33  Matt Rice <ratmice@yahoo.com>

	* Source/NSApplication.m ([NSAppIconView -mouseDown:]): order front
	possibly obscured windows if not hidden.
	
2004-10-11  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSActionCell.m (-initWithCoder:):
	* Source/NSBitmapImageRep.m (-initWithCoder:):
	* Source/NSImage.m (-initWithCoder:): Implemented keyed decoding.
	* Source/NSMatrix.m (-initWithCoder:): Don't use methods to set
	the cell size and intercell spase, as this will change the frame.
	* Source/NSFormCell.m (-initWithCoder:): Set the string value
	later, as the decoding is super gets used for the title.
	* Source/NSButtonCell.m (-initWithCoder:): Set fields only when
	value is provided and fake NSImageLeft until flag decoding is there.
	
2004-10-08 22:08  Chad Hardin  <cehardin@mac.com>

	* Printing/GNUmakefile:  Now goes in and build GSCUPS (Work in progress!)
	* Printing/GSCUPS/GNUmakefile: Added
	* Printing/GSCUPS/GNUmakefile.postamble: Added
	* Printing/GSCUPS/GNUmakefile.preamble: Added
	* Printing/GSCUPS/GSCUPSPageLayout.h: Added
	* Printing/GSCUPS/GSCUPSPageLayout.m: Added
	* Printing/GSCUPS/GSCUPSPrincipalClass.h: Added
	* Printing/GSCUPS/GSCUPSPrincipalClass.m: Added
	* Printing/GSCUPS/GSCUPSPrintInfo.h: Added
	* Printing/GSCUPS/GSCUPSPrintInfo.m: Added
	* Printing/GSCUPS/GSCUPSPrintOperation.h: Added
	* Printing/GSCUPS/GSCUPSPrintOperation.m: Added
	* Printing/GSCUPS/GSCUPSPrintPanel.h: Added
	* Printing/GSCUPS/GSCUPSPrintPanel.m: Added
	* Printing/GSCUPS/GSCUPSPrinter.h: Added
	* Printing/GSCUPS/GSCUPSPrinter.m: Added.  GSCUPS is a work in 
	progress.  Some changes still need to be made to NSPrinter, 
	NSPrinterInfo.   Additionally, NSPrintPanel needs to be improved
	to take advantage of the new features that GSCUPS will provide.

2004-10-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSFormCell.m: (-initWithCoder:):
	* Source/NSMatrix.m: (-initWithCoder:): Implemented keyed decoding.
	* Source/NSColor.m: (-initWithCoder:): Corrected handling of alpha
	values (use 1 instead of 0)
	* Source/NSCell.m: (-initWithCoder:): Added some more flag
	handling and rearranged code.

2004-10-08 09:17  Chad Hardin  <cehardin@mac.com>

	* Printing/GSLPR/GSLPRPageLayout.m: Fixed a #define
	* Printing/GSLPR/GSLPRPrintInfo.m: Made it so the code calls 
	NSPrinter's printerWithName rather than GSLPR's, because the former
	caches NSPrinter objects.
	* Printing/GSLPR/GSLPRPrinter.h: Moved a method out of a (Private) 
	catagory and place it into the header file, directly into the class.
	* Printing/GSLPR/GSLPRPrinter.m: Simplified the class by taking out
	an unnecesary initializer.

2004-10-08  Chad Hardin  <cehardin@mac.com>

	* Printing/GSLPR/GSLPRPrintOperation: Removed useless #defines and
	did a minor format cleanup. 
	* Printing/GSLPR/GSLPRPrinter.m: Took out a few PS specific methods so 
	that they can be put into the parent class, NSPrinter.
	* Source/NSPrinter: Received PS specific methods from GSLPRPrinter so
	that they can be used by GSCUPS as well.  Also removed some useless
	NSDebugs.

2004-10-05  Adam Fedor  <fedor@gnu.org>

	* Source/GNUmakefile.postamble (libgnustep-gui.def): Search for both
	T and R symbols to work with multiple mingw/cygwin flavors.

2004-10-01  Adam Fedor  <fedor@gnu.org>

	* Documentation/ReleaseNotes.gsdoc: Format fixes.
	* Source/DocMakefile (before-clean, after-clean): Move obj out of the
	way so it isn't removed when cleaning docs.

2004-10-01  Adam Fedor  <fedor@gnu.org>

	* Source/GNUmakefile.preamble: Add filter out flags for
	compilation of some files on Solaris.

2004-09-27 17:49  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSServicesManager.m (NSPerformService): Check whether the
	service provider is remote by checking the class of the object.

2004-09-26 22:18  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTabViewItem.m (-drawLabel:inRect:): Adjust the label
	position to match the text height change (of 2004-09-21).

2004-09-25  Matt Rice <ratmice@yahoo.com>
	
	* Source/NSScrollView.m: Remove corner view when we have one, but no 
	vertical scroller. (Fixes #10501).

2004-09-24  Adam Fedor  <fedor@gnu.org>

	* Documentation/GNUmakefile.postamble: Clean up files properly
	* Source/DocMakefile: Fix up for moved files
	* Documentation/Gui/Gui.gsdoc,
	Documentation/GuiAdditions/GuiAdditions.gsdoc: Move up one level.

2004-09-24  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSControl.h
	Added new MacOSX delegate methods.
	* Source/NSControl.m (-validateEditing, -currentEditor,
	-abortEditing, -calcSize): Implemented these methods.
	(-mouseDown:): Use method to check if mouse is inside cell.

2004-09-24  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenuView.m (-setMenu:): Only call update when the new
	menu is not nil.
	* Source/NSMenu.m (-setMenuRepresentation:): Unset the menu of the
	old view. 
	(-dealloc): Unset the menu of the view. 
	(-initWithTitle:): Use setMenuRepresentation: to set the view.
	
2004-09-24  Adam Fedor  <fedor@gnu.org>

	* Version 0.9.4

	* Documentation/General/OpenStepCompliance.gsdoc: Updates
	* Documentation/ReleaseNotes.gsdoc, Documentation/news.texi: Idem.

2004-09-24  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSView.m (-initWithCoder:): Added keyed decoding of
	 "hidden" flag.	
	* Source/NSCell.m (-initWithCoder:): Added the first bit of
	keyed flags decoding. Values provided by Adrian Robert
	<arobert@cogsci.ucsd.edu>. 	 
	
2004-09-23 22:33  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTableView.m (-mouseDown:): Fix the check that detects
	when an unselected row is being dragged.

2004-09-23 18:01  Alexander Malmberg <alexander@malmberg.org>

	* Printing/GSLPR/GSLPRPrintOperation.m (-createContext): Always use
	the path from the info dictionary if it's set.

2004-09-21 23:57  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSCursor.m (_getStandardCursor): Rename to
	getStandardCursor and make static and non-inlined. Update callers.
	* Source/NSTableView.m (computePeriod): Make static.

2004-09-21 18:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSFontInfo.m (-defaultLineHeightForFont): Adjust line
	height calculation.
	* Source/NSButtonCell.m (-drawInteriorWithFrame:inView:): Always
	initialize imageRect and titleRect. Adjust the calculations to match
	the new line height.
	(-cellSize): Always initialize imageRect and titleRect.
	* Headers/AppKit/NSCell.h (-_drawImage:inFrame:isFlipped:): Remove.
	* Source/NSCell.m (-_drawImage:inFrame:isFlipped:): Remove. Move code
	back ...
	(-drawInteriorWithFrame:inView:): ... here.
	* Source/NSToolbarItem.m (+initialize): Remove.
	(+cellClass): Add.

2004-09-18 15:15  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSServicesManager.m (_serviceFromAnyLocalizedTitle): Rename
	to serviceFromAnyLocalizedTitle and make static.
	* Source/tiff.m (NSTiffWarning): Log tiff warnings using NSDebugLLog
	instead of NSLog.

2004-09-17  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTextFieldCell.m (-initWithCoder:): Moved special
	handling of action mask into non-keyed decoder branch.

2004-09-16  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSCell.m (-setStringValue:, -setFont:, -setImage:):  Use
	method call to change cell type. (Readded this change)
	* Source/NSButtonCell.m (-setType:):  Overwrite super method with
	empty implementation. Patch by Quentin Mathe <qmathe@club-internet.fr>.
	* Source/NSView.m (-initWithCoder:):  Added the first bit of
	keyed flags decoding.	
		
2004-09-16  Matt Rice <ratmice@yahoo.com>
	* Source/NSTextFieldCell.m (+initialize): Bump class version.
	(-initWithCoder:): When decoding the previous version of NSTextFieldCell
	replace the old default _action_mask with the new default value. 
	(Fixes #9609 for .gorm files)

2004-08-02  Adrian Robert <arobert@cogsci.ucsd.edu>

	* Documentation/Gui/Gui.gsdoc: Update to reflect slight rearrangement
	of material to initiate a GUI programming manual.  This partially
	reverts a change that was accidentally undone earlier.

2004-09-13 Matt Rice <ratmice@yahoo.com>
	* NSScrollView.h: Declare new ivar _cornerView and private method
	-_synchronizeCornerAndHeaderView
	* NSScrollView.m (tile): Call _synchronizeCornerAndHeaderView method 
	from here. Replace local cornerView variable with _cornerView.
	(-setDocumentView:): Remove code to set the corner and header views.
	(-_synchronizeCornerAndHeaderView): Implement new method.
	* NSTableView.m (-setHeaderView:, -setCornerView:): call tile on the 
	scroll view we're in. Remove comments and warnings for cases which are
	now implemented.

2004-09-12 Matt Rice <ratmice@yahoo.com>
	* Headers/AppKit/NSCell.h (-_sendsActionOn:): New method.
	* Source/NSCell.m (-_sendsActionOn:): Implement it.
	* Source/NSTextFieldCell.m (-initTextCell:): Change _action_mask to a
	key press.
	* Source/NSTableView.m (-mouseDown:): Use _sendsActionOn: to only modify
	the object value and send the event to the cell if the cell works on
	mouse events. (Fixes #9609).

2004-09-12 Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/NSDataLinkPanel.h: Added new attributes.
	* Source/NSDataLinkPanel.m: Implemented some 
	methods.
	* Panels/English.lproj/GSDataLinkPanel.gorm: Updated
	graphics and added link to new ivar.
	* Source/NSDataLink.m:
	* Source/NSDataLinkManager.m: Code cleanup.
	
2004-09-11 Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSCell.m: Reverted previous change. 
	The change was causing an issue where if the font was 
	changed on an NSButtonCell which contains both an image and text. 
	The title was being, incorrectly, reset to "title".  
	* Source/NSDataLinkPanel.m: Renamed the shared variable to something
	more standard.

2004-09-09  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSCell.m (-setStringValue:, -setFont:, -setImage:):  Use
	method call to change cell type. 

2004-09-07  Adam Fedor  <fedor@gnu.org>

	* Source/GNUmakefile: Specify INTERFACE_VERSION explicitly.

	* Documentation/ReleaseNotes.gsdoc, Documentation/news.texi: Update
	for new release.

2004-09-05  Quentin Mathe <qmathe@club-internet.fr>
        
	* Headers/Additions/GNUstepGUI/GSToolbarView.h: Changed
	_heightFromLayout from unsigned int to float.
        * Source/GSToolbarView.m (-initWithFrame:displayMode:sizeMode:): Removed
	the local variable toolbarViewHeight to use the ivar _heightFromLayout
	in order to have a toolbar height which is not equal to zero when the
	toolbar is empty. (the toolbar height now matches initially the height
	associated with the selected size mode)
	(-_handleBackViewsFrame): Added a local variable newHeight to store the
	highest caculated height for a toolbar item in order to not have
	_heightFromLayout set to zero when the toolbar is empty (no toolbar
	items).
	* Source/GSToolbar.m (-setDelegate:, -_setDelegate:broadcast:,
	-setToolbarView:): Deactived the delegate
	synchronization with broadcast set to NO for the method
	-_setDelegate:broadcast: because it could produce strange segmentation
	faults or exceptions with Cocoa applications which haven't been written
	with this delegate synchronization behavior in mind.
	(-setSelectedItemIdentifier:, -_build,
	-_insertItemWithItemIdentifier:atIndex:broadcast:,
	-_setDelegate:broadcast:): Added the nil delegate check because a nil
	delegate could happen more easily without the delegate synchronization,
	moreover it wasn't handled correctly before.

2004-09-05 10:30  Matt Rice <ratmice@yahoo.com>

	* Source/NSTableView.m: [NSTableView mouseDown:] removed code which
	copied and subsequently DESTROYs dataCell.  This was causing a 
	SIGSEGV.
	
2004-09-05 06:23  Matt Rice <ratmice@yahoo.com>

	* Source/GSServicesManager.m: new method -activateIgnoringOtherApps:
	* Source/NSWorkspace.m (-launchApplication:showIcon:autolaunch:):
	call -activateIgnoringOtherApps: on the remote connection to an already
	running app.

2004-09-04 23:32  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:):
	Pass the right glyph position to cells.
	* Headers/AppKit/NSTextAttachment.h: Clarify documentation.

2004-09-04 01:34  Alexander Malmberg <alexander@malmberg.org>

	* PrinterTypes/GNUmakefile, PrinterTypes/GNUmakefile.postamble:
	Revert removal of rules to install .ppd:s.
	* PrinterTypes/English.lproj/Generic-PostScript_Printer-Postscript.ppd:
	New file.
	* Printing/GSLPR/GNUmakefile: Set GNUSTEP_INSTALLATION_DIR.
	* Printing/GSLPR/GNUmakefile.preamble: Compile with -Wall.
	* Printing/GSLPR/GSLPRPrinter.m (+printerWithName:): Remove
	ppdContents variable.
	(+printersDictionary): Only warn once if a printer hasn't been set
	in the defaults. Change the type of the fallback printer to
	Generic-PostScript_Printer-Postscript. Check that the ppd for this
	printer is found.

2004-09-04 01:06  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSToolbarView.m (-_insertionIndexAtPoint:): Remove spurious
	';'.

2004-09-02  Quentin Mathe <qmathe@club-internet.fr>
        
	* Headers/AppKit/NSToolbarItem.h: Added GSMovableToolbarItemPboardType 
	declaration.
	* Source/NSToolbarItem.m: Added the toolbar items rearranging
	possibility by implementing the dragging source methods.
	* Source/GSToolbar.m: Added or reworked some methods to support model
	updates without direct view effects to manipulate the toolbar items when
	a dragging  session happens.
	* Source/GSToolbarView.m: Added the toolbar items rearranging
	possibility by implementing the dragging destination methods. And added
	a method -_insertionIndexAtPoint: to support the insertion index
	calculation based on the mouse location.

2004-09-01  Adam Fedor  <fedor@gnu.org>

	* Source/NSPrintInfo.m ([NSPrintInfo -paperSize]): Avoid returning
	a nil object return value into a struct.

	* Printing/GSLPR/GNUmakefile.preamble: Add 
	Source/$(GNUSTEP_TARGET_DIR) includes
	* Tools/GNUmakefile.preamble: Likewise.

2004-09-02 00:17  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSView.m (-replaceSubview:with:): Clarify documentation.
	(-scrollRectToVisible:): Implement correctly, patch from Andrew
	Ruder. Document.

2004-08-30  Quentin Mathe <qmathe@club-internet.fr>

        * Headers/AppKit/NSCell.h:
	* Source/NSCell.m:
	Make the code a bit more modular with a distinct private method to
	implement the image drawing (the text drawing is already located in a
	separate method), see -_drawImage:inFrame:isFlipped:,
	previously implemented in -drawInteriorWithFrame:inView:
	* Source/NSButtonCell.m: Moved code specific to NSButtonCell
	-drawInteriorWithFrame:inView: in a new method
	-_drawImage:inFrame:isFlipped to match the method added to NSCell. Also
	reverted the 2004-08-11 21:35 Alexander Malmberg commit to have  identical
	margin between the border and the text with every image positions.
	Source/NSToolbarItem.m:
	Added -_drawImage:inFrame:isFlipped and _drawAttributedText:inFrame:
	to override the superclasses behavior, it permits to have the
	GSToolbarButtonCell layout not dependent on the NSButtonCell code.

2004-08-29 02:48  Matt Rice <ratmice@yahoo.com>

	* Source/NSTableView.m (-draggingUpdated:): Return
	currentDragOperation.

2004-08-28 10:34  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Added implementation of method
	shouldSwapClass to GSClassSwapper.  This method checks for the
	implementation of isInInterfaceBuilder and returns whether or
	not the template should perform the class swap or whether it
	should retrieve the superclass.
	* Headers/Additions/GNUstepGUI/GSNibTemplates.h: Added 
	declaration for -[GSClassSwapper shouldSwapClass].
	
2004-08-23 17:29  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow.m (-setFrameFromString:): Don't change the size
	of the window if it isn't resizable.

2004-08-21  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSComboBoxCell.m (-completedString:):  Handle a nil
	substring by returning nil directly without trying to find a
	match. Patch by Andreas Hoeschler <ahoesch@smartsoft.de>.
	Changed data source error messages to consistent wording.
	
2004-08-13  Quentin Mathe <qmathe@club-internet.fr>
        
	* Source/NSComboBoxCell.m -(runModalPopUpWithComboBoxCell:): Remove the
	observer only for the variable onWindow, then it is not needed anymore
	to reset the table view delegate. 
	(-deselectItemAtIndex:): Added a _localSelection flag, the result is now
	the method still triggers -[GSComboWindow tableViewSelectionDidChange:]
	call but the _localSelection variable in -validateSelection
	avoids to have -selectItemAtIndex: wrongly called.
	(-trackMouse:inRect:ofView:untilMouseUp:): Fixed broken combo box
	behavior introduced June 17 with version 1.27, which produced wrong
	tracking in the button cell and extra mouse down call in the NSComboBox
	superclass. Now the rewritten version is also documented. 
	* Source/NSComboBox.m (-mouseDown:): Reverted the use of the variable
	clicked (that contributes to fix the bug explained above) and renamed it
	buttonClicked.
	* Headers/AppKit/NSComboBoxCell.h: Added the method
	-trackMouse:inRect:ofView:untilMouseUp to have the documentation
        generated for this overriden method , it shouldn't be needed( it is a
	temporary hack until we have the root problem corrected).
	
2004-08-12 01:42  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m
	(-textStorage:edited:range:changeInLength:invalidatedRange:):
	Adjust the selected range even if there's no length change. Change
	the handling of the in/in case. Set the selected range using a text
	view if we have any attached.
	* Source/NSTextView.m (-insertText:): Don't set the selected range.
	(-setSelectedRange:affinity:stillSelecting:): Clamp the old range
	to the length of the text.
	* Source/NSTextView_actions.m (-deleteForward:, -deleteBackward:):
	Don't set the selected range.

2004-08-11 21:35  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSButtonCell.m (-drawInteriorWithFrame:inView:): Move
	text back down by 2 points for NSImageAbove.

2004-08-10 02:01  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-usedRectForTextContainer:): Fix
	the calculation of the used rectangle.

2004-08-10 00:47  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSAttributedString.m (cache_init, cache_init_real): Add
	missing void:s.

2004-08-10 00:06  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m: Formatting cleanups.
	(-_reuseSoftInvalidatedLayout): New method. Contains soft invalidated
	layout info handling, moved here from ...
	(-layoutLineNewParagraph:): ...here. Cache the imp for
	-advancementForGlyph: and send it directly to the fontInfo.

2004-08-09 21:45  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Additions/GNUstepGUI/GSLayoutManager_internal.h: Add
	usedRect and usedRectValid fields to textcontainer_t.
	* Source/GSLayoutManager.m (-_doLayout): Set usedRectValid to NO
	when setting complete to YES.
	(-usedRectForTextContainer:): Optimize the calculation of the used
	rect. Use usedRect and usedRectValid.

2004-08-09 14:38  Alexander Malmberg <alexander@malmberg.org>

	* Headers/AppKit/NSWindow.h: _frame is the window frame.
	(+screenRectForFrameRect:styleMask:,
	+frameRectForScreenRect:styleMask:): New methods.
	* Source/GSDisplayServer.m (-window:::, -styleoffsets:::::):
	Update documentation.
	* Source/GSStandardWindowDecorationView.m
	(+screenOffsets::::forStyleMask:): Implement new method.
	* Source/GSWindowDecorationView.h (+screenRectForFrameRect:styleMask:,
	+frameRectForScreenRect:styleMask:): New methods.
	* Source/GSWindowDecorationView.m (+screenOffsets::::forStyleMask:,
	+screenRectForFrameRect:styleMask:,
	+frameRectForScreenRect:styleMask:): Implement them.
	* Source/NSWindow.m (+screenRectForFrameRect:styleMask:,
	+frameRectForScreenRect:styleMask:): Implement new methods.
	(-_initBackendWindow): Always update _wv's frame.

2004-08-08  Quentin Mathe <qmathe@club-internet.fr>

	* Source/NSComboBox.m:
        * Source/NSComboBoxCell.m:
        Fixed the class description markup errors which caused text 
	truncations in the documentation.

2004-08-08 01:19  Chad Hardin <cehardin@mac.com>

	* Source/NSPageLayout.m: Ensure that the units on the panel
	are set.  Using -viewWithTag:, I had to make sure I called
	the view immediately above the view I was loking for.

2004-08-08 00:43  Chad Hardin <cehardin@mac.com>

	* config.make.in: Added CUPS specific make variables.
	* configure: Regenerated.
	* configure.ac: Added code to detect the presence of 
	cups for the new GSCUPS printing backend bundle.
	Detects cups but the GSCUPS bundle is not ready yet
	so it does not actually try to build anything related
	to cups.
	* Headers/AppKit/NSPrinter.h:
	* Source/NSPrinter.m:
	* Printing/GSLPR/GSLPRPrinter.m:
	NSPrinter no longer assumes it is PPD specific.  However,
	it does include a catagory named PPDParsing, which the
	backend printing bundles can call to have a PPD file parsed
	and placed into NSPrinter's tables.  All the PPD parsing code
	was taken out of GSLPRPrinter.m.  Also, a lot of code format
	cleanup was done.
	* Printing/GSLPR/GSLPRPrintInfo.m:
	* Source/AppKit/NSPrintInfo.m: Moved initWithDictionary: code
	out of GSLPR's GSLPRPrintInfo implementation into here.
	* Printing/GSLPR/GSLPRPrincipalClass.h: Correct copyright.
	* Printing/GSLPR/GSLPRPrincipalClass.m: Correct copyright.
	* Printing/GSLPR/GSLPRPrintInfo.h: Fixed reference to NSPrintInfo.
	* Printing/GSLPR/GSLPRPrintOperation.h: Fixed referece to 
	NSPrintOperation.
	* Printing/GSLPR/GSLPRPrinter.h: Fixed reference to NSPrinter.
	* Panels/English.lproj/GSPageLayout.gorm/objects.gorm: Increased the
	size of the panel's title and made it bold.
	* Printing/GNUmakefile: Added code to optionally build the (upcoming)
	GSCUPS printing backend bundle.  Currently it's disabled.

2004-08-07 13:18  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-mouseDown:): Remove -containsAttachments
	call.

2004-08-06 14:13  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSPasteboard.m (-pasteboard:provideDataForType:): Print
	a warning instead of crashing in NSMapFile handling.
	(+_pasteboardWithTarget:name:): Update the local changeCount.

2004-08-02  Adrian Robert <arobert@cogsci.ucsd.edu>

	* Documentation/GuiUser/DefaultsSummary.gsdoc: Clarify the role of
	NSGlobalDomain; explain that NSShowNonLocalizedStrings is a developer
	option (in absence of a document specifically documenting developer
	defaults, the doc will go here).

2004-08-02 16:32  Alexander Malmberg <alexander@malmberg.org>

	* Headers/AppKit/NSCell.h, Source/NSMenuView.m: Rename xDist and
	yDist to GSCellTextImageXDist and GSCellTextImageYDist.
	* Source/NSMenuItemCell.m: Rename xDist and yDist.
	(titleRectForBounds:): Reindent.
	* Source/NSButtonCell.m (-drawInteriorWithFrame:inView:, -cellSize):
	Adjust size calculations, make them more forgiving before clipping
	text, and make -cellSize and -drawInteriorWithFrame:inView: match
	each other again. Update xDist and yDist references.

2004-08-01 14:55  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSStandardWindowDecorationView.m (-drawTitleBar): Fix
	the centering of the title.

2004-08-01 14:28  Alexander Malmberg <alexander@malmberg.org>

	* TextConverters/RTF/RTFProducer.m (-_addAttributesString:): Only add
	attachmentFileWrapper to the attachments array if it isn't nil.

2004-07-30  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Documentation/GuiUser/GNUMakefile.postamble: Remove an unwanted
	level of hierarchy when installing GSdoc generated under
	Documentation/GuiUser.

2004-07-30 15:52  Alexander Malmberg <alexander@malmberg.org>

	* Headers/AppKit/NSGraphicsContext.h (-GSReadRect:): Document.
	* Source/NSBitmapImageRep.m (-initWithFocusedViewRect:): Update for
	new key names from GSReadRect:.
	* Source/NSGraphicsContext.m (-GSReadRect:): Return nil.

2004-07-29  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Documentation/GuiUser/DefaultsSummary.gsdoc: Added some explanation
	of how to set defaults and description of domains, since this isn't
	readily accessible elsewhere.  Also, documented
	NSShowNonLocalizedStrings default.

2004-07-28  Adam Fedor  <fedor@gnu.org>

	* PrinterTypes/: Remove PPD files
	* PrinterTypes/GNUmakefile: Don't install them.

2004-07-28 19:52  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSWindowDecorationView.h, Source/GSWindowDecorationView.m
	(-setBackgroundColor:): New method.
	* Source/NSWindow.m (-setBackgroundColor:): Pass the call along to
	_wv.
	(-orderWindow:relativeTo:): Use -setFrame:display: to change the
	frame after contstraining it.
	(-constrainFrameRect:toScreen:): Fix the check of whether the bottom
	of the window is off the screen.
	(-_sendEvent:becomesKeyOnlyIfNeeded:): Clean up handling of
	GSAppKitWindowResized.
	(-initWithCoder:): Destroy _miniaturizedImage before setting it to
	the decoded image.

2004-07-27  Quentin Mathe <qmathe@club-internet.fr>
        
	* Headers/Additions/GNUstepGUI/GSToolbarView.h:
	* Source/GSToolbarView.m:
	* Source/NSToolbarItem.m:
	Moved static const and enum declarations from GSToolbarView.h to
	GSToolbarView.m and NSToolbarItem.m.
	* Source/NSWindow+Toolbar.m:
	Fixed non correct toolbar view visibility when [NSToolbar -setVisible:]
	is called before [NSWindow -setToolbar:](bug reported by Yen-Ju Chen
	<yjchenx@hotmail.com>).

2004-07-24 22:47  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSToolbarItem.m: Use the predefined variables instead of
	inline string literals for attribute names.
	([GSToolbarButton -layout], [GSToolbarBackView -drawRect:],
	[GSToolbarBackView -layout]): Release attrStr/attrString.
	(-copyWithZone:): Return new, not self.

2004-07-23 01:54  Matt Rice <ratmice@yahoo.com>

	* Documentation/GuiUser/DefaultsSummary.gsdoc: Document
	GSUseWindowmakerIconBackground.
	* Source/NSApplication.m ([NSAppIconView +initialize],
	[NSAppIconView -drawRect:]): If the GSUseWindowmakerIconBackground
	default is YES, do a clear composite of the background instead
	of using the tile.
	* Source/NSWindow.m ([NSMiniWindowView +initialize],
	[NSMiniWindowView -drawRect:]): Idem.

2004-07-22 04:46  Chad Hardin <cehardin@mac.com>

	* Headers/AppKit/NSPageLayout.h: Changed to MVC and a whole new UI.
	* Headers/AppKit/NSPrintInfo.h: Format cleanup.
	* Headers/AppKit/NSPrintOperation.h: Format cleanup.
	* Headers/AppKit/NSPrintPanel.h: Format cleanup.
	* Headers/AppKit/NSPrinter.h: Format cleanup.
	* Panels/English.lproj/GSPageLayout.gorm/data.classes:  New UI.
	* Panels/English.lproj/GSPageLayout.gorm/objects.gorm:  New UI.
	* Printing/GSLPR/GSLPRPrintInfo.m: Format cleanup.
	* Printing/GSLPR/GSLPRPrintOperation.m: Format cleanup.
	* Printing/GSLPR/GSLPRPrintPanel.m: Format cleanup.
	* Printing/GSLPR/GSLPRPrinter.m: Format cleanup.
	* Source/GSEPSPrintOperation.m: Format cleanup.
	* Source/GSPDFPrintOperation.m: Format cleanup.
	* Source/GSPrintOperation.m: Format cleanup.
	* Source/GSPrinting.m: Format cleanup.
	* Source/NSPageLayout.m: Changed to MVS and a whole new UI.
	* Source/NSPrintInfo.m: Format cleanup.
	The big thing changed here is that NSPageLayout has a whole new
	UI and is MVC based.  I have not yet implemented the ability
	to create and edit custom papers, that is next.

2004-07-22 00:18  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibContainer.m: Corrected spelling mistake in comment.
	
2004-07-22 00:59  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSStandardWindowDecorationView.m (-setDocumentEdited:,
	-setTitle:): Pass the calls along to super.

2004-07-21 19:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSFontPanel.m (-_trySelectSize:updateSizeField:): Add
	updateSizeField	argument. Update callers.

2004-07-20 01:24  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSScroller.m (-rectForPart:): Use floor() instead of
	floorf().

2004-07-18  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Removed some commented out code.

2004-07-14  Adam Fedor  <fedor@gnu.org>

	* Documentation/General/OpenStepCompliance.gsdoc: Update.
	* Documentation/Gui/Gui.gsdoc: Add compliance and release links
	* Source/NSSavePanel.m: Remove extraneous ';' at end of some methods
	* Source/NSTableView.m: Idem.

2004-07-15 02:28  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSBezierPath.m (point_on_curve): New function.
	(-_recalculateBounds): Rewrite. Calculate bounds analytically.

2004-07-13 02:54  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSImageRep.m (+_imageRepsWithData:): New method.
	(+imageRepsWithContentsOfURL:): Use +_imageRepsWithData:.
	(+imageRepsWithContentsOfFile:): If the filename has no extension,
	use +_imageRepsWithData: to load it.

2004-07-13 01:15  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow.m (+_handleAutodisplay:, +_addAutodisplayedWindow:,
	+_removeAutodisplayedWindow:): New methods.
	Rename _handleWindowNeedsDisplay: to -_handleAutodisplay.
	([NSWindow +initialize]): Don't initialize modes.
	(-dealloc, -orderWindow:relativeTo:): Use +_addAutodisplayedWindow:
	and +_removeAutodisplayedWindow: instead of adding/removing a runloop
	performer.

2004-07-13 00:23  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSSound.m: Only declare the_server if HAVE_AUDIOFILE_H
	is defined.

2004-07-13 00:21  Alexander Malmberg <alexander@malmberg.org>

	* Headers/AppKit/NSMovieView.h: Make loopMode ivar an unsigned int.

2004-07-13  Serg Stoyan <stoyan255@ukr.net>

	* Source/NSButtonCell.m:
	(_init): Set default values of _gradient_type and 
	_image_dims_when_disabled.
	(drawGradientWithFrame:inView:): Implemented. Draws gradient 
	according to the _gradient_type ivar value.
	(drawInteriorWithFrame:inView:): Call drawGradientWithFrame:inView
	if _gradient_type was set and cell is no highlighted. Dissolve
	image if cell is disabled and _image_dims_when_disabled was set.
	
2004-07-11  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Added code to allow the switching
	of which version of the file gets encoded based on the value
	of the class variable "version".  This is part of an experimental
	feature in .gorm files to allow Gorm.app to encode older versions
	of .gorm files for previous versions of GNUstep.
	
2004-07-11  Chad Hardin <cehardin@mac.com>

	* Headers/AppKit/NSPageLayout.h:
	* Source/NSPageLayout.m:
	* Panels/English.lproj/GSPageLayout.gorm/data.classes:
	* Panels/English.lproj/GSPageLayout.gorm/objects.gorm:
	* Printing/GSLPR/GSLPRPageLayout.m:
	Completely redid NSPageLayout.  It now takes full 
	advantage of being GORM based (ie: connections rather
	than checking tags).  Most of the functionality of 
	NSPageLayout was split off and put into a controller 
	object, GSPrintLayoutController.  The panel	itself is 
	much improved, it even includes a preview display of 
	the page dimensions.

2004-07-11 14:17  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m (-drawGlyphsForGlyphRange:atPoint:):
	When printing, position each glyph explicitly.

2004-07-09  Chad Hardin <cehardin@mac.com>

	* Source/GNUmakefile:
	* Headers/AppKit/NSPageLayout.h:
	* Source/NSPageLayout.m:
	* Headers/AppKit/NSPrintInfo.h:
	* Source/NSPrintInfo.m:
	* Headers/AppKit/NSPrintOperation.h:
	* Source/NSPrintOperation.m:
	* Headers/AppKit/NSPrintPanel.h:
	* Source/NSPrintPanel.m:
	* Headers/AppKit/NSPrinter.h:
	* Source/NSPrinter.m:
	Modifications for the backend printing bundle system.
	* Headers/Additions/GNUstepGUI/GSEPSPrintOperation.h: added.
	* Source/GSEPSPrintOperation.m: added.
	* Headers/Additions/GNUstepGUI/GSPDFPrintOperation.h: added.
	* Source/GSPDFPrintOperation.m: added.
	* Headers/Additions/GNUstepGUI/GSPrintOperation.h: added.
	* Source/GSPrintOperation.m: added.
	* Headers/Additions/GNUstepGUI/GSPrinting.h: added.
	* Source/GSPrinting.m: added.
	Split off the various PrintOperation classes.  This makes is clear that
	the printing backend bundles subclass GSPrintOperation, not NSPrintOperation.
	Also, GSPDFPrintOperation will probably become large when implemented, this
	clarifies the class structure and prevent NSPrintOperation.m from become 
	overly large and confusing.  The GSPrinting class is helper for loading the 
	proper printer backend bundle.
	* GNUMakefile: includes the Printing directory.
	* Printing: Added the printing bundles home directory.
	* Printing/GNUmakefile: added.
	* Printing/GSLPR: Added the first printing bundle.
	* Printing/GSLPR/GNUmakefile: added.
	* Printing/GSLPR/GNUmakefile.postamble: added.
	* Printing/GSLPR/GNUmakefile.preamble: added.
	* Printing/GSLPR/GSLPRPageLayout.h: added.
	* Printing/GSLPR/GSLPRPageLayout.m: added.
	* Printing/GSLPR/GSLPRPrincipalClass.h: added.
	* Printing/GSLPR/GSLPRPrincipalClass.m: added.
	* Printing/GSLPR/GSLPRPrintInfo.h: added.
	* Printing/GSLPR/GSLPRPrintInfo.m: added.
	* Printing/GSLPR/GSLPRPrintOperation.h: added.
	* Printing/GSLPR/GSLPRPrintOperation.m: added.
	* Printing/GSLPR/GSLPRPrintPanel.h: added.
	* Printing/GSLPR/GSLPRPrintPanel.m: added.
	* Printing/GSLPR/GSLPRPrintPrinter.h: added.
	* Printing/GSLPR/GSLPRPrintPrinter.m: added.
	Here it is, the first backend printing bundle, version one.  The are very 
	little code changes from the original source, bugs that may have been 
	present there would have been carried over here.  However, this is just the 
	first round.  This bundle uses GNUstep's original PageLayout and PrintPanel
	GORM panels, it does not have its own.  Hence, it is very simple.  The plan
	is for the future GSCUPS bundle to also use GNUstep's GORM panels, not for 
	each bundle to have their own panels.
	
2004-07-09  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPanel.m:
	* Source/NSAlert.m:
	Moved class GSAlertPanel and alert functions from NSPanel.m to
	NSAlert.m. 
	
2004-07-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GNUmakefile:
	* Source/NSMovieView.m:
	Added file forgotten in last commit.
	
2004-07-08  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSMovie.h:
	* Source/NSMovie.m:
	* Headers/AppKit/NSMovieView.h:
	* Source/NSMovieView.m:
	* Headers/AppKit/NSAlert.h:
	* Source/NSAlert.m:
	New MacOSX classes, implementation still empty.

2004-07-08  Serg Stoyan <stoyan255@ukr.net>

	* Images/common_ArrowDownH.tiff: added.
	* Images/common_ArrowLeftH.tiff: added.
	* Images/common_ArrowRightH.tiff: added.
	* Images/common_ArrowUpH.tiff: added.
	
	* Source/NSScroller.m: (drawParts): Use added images.
	Cells now highlights also by NSContentsCellMask.
	
2004-07-07  Quentin Mathe <qmathe@club-internet.fr>
        
	* Source/GSToolbar.m: Fixed several segmentation faults which could
	occur when windows with a toolbar have been closed and new similar
	windows are initialized (bug #9535), rewritten validation support to
	be more clearer and efficient, and the toolbar notifications now
	correctly bundles the toolbar items in the notification dictionary
	(Patch by Ludovic Marcotte).
	* Source/GSToolbarView: 
	* Source/NSToolbar.m:
	* Source/NSWindow+Toolbar.m:
	* Source/NSToolbarItem.m:
	Related changes and lot of memory leaks fixed permitting to have now
	the toolbar system properly deallocated when the toolbar is not anymore
	retained by the user and the toolbar view.
	Note: In order to observe the toolbar system being deallocated when you close
	a window, you need to have the option "Window released when closed"
	checked.
	Actual retain logic is strictly : 
	- Superview in the view hierarchy retains toolbar view
	- Toolbar view retains toolbar
	- Toolbar view retains toolbar items view
	- Toolbar retains toolbar items
	And when a toolbar is based on NSToolbar class :
	- Windows retains toolbar view.
	* Source/NSView.m: Added a missing method call -viewWillMoveToSuperview:
	in -removeSubview: method (this missing method is used by the toolbar
	view).
	* Headers/Additions/GNUstepGUI/GSToolbar.h:
	* Headers/AppKit/NSToolbar.h:
	Moved the _window ivar from GSToolbar class to NSToolbar class.
	* Headers/AppKit/NSToolbarItem.h: Added a _tag ivar and other minor changes.

2004-07-07 01:23  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow+Toolbar.m: Properly convert window frames to
	content view frames and back.
	(-_toggleToolbarViewWithDisplay:): Move the old content view to the
	origin of the new content view.

2004-07-06 22:15  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Additions/GNUstepGUI/GSDisplayServer.h: Add
	-handlesWindowDecorations.
	* Headers/AppKit/NSWindow.h: Document _frame ivar and add update
	for -gui-managed window decorations.
	(+minFrameWidthWithTitle:styleMask:): Change return type to float.
	* Source/GNUmakefile: Add GSWindowDecorationView.m and
	GSStandardWindowDecorationView.m .
	* Source/GSDisplayServer.m (-handlesWindowDecorations): Provide a
	default implementation.
	* Source/NSPanel.m (-sendEvent:): Reimplement using
	-_sendEvent:becomesKeyOnlyIfNeeded: .
	(setControl): Only call -setStringValue: on the cell if it doesn't
	respond to -setTitle: .
	* Source/NSWindow.m: Reorganize management of the top-level view.
	Implement -gui-managed window decorations.
	(-_sendEvent:becomesKeyOnlyIfNeeded:): New method.
	(-sendEvent:): Reimplement using -_sendEvent:becomesKeyOnlyIfNeeded: .
	* Source/GSWindowDecorationView.h, Source/GSWindowDecorationView.m,
	Source/GSStandardWindowDecorationView.m: New files.

2004-07-05  Gregory John Casamento <greg_casamento@yahoo.com>
	
	* Source/NSToolbar.m: [NSToolbar _setWindow:] added logic
	to accept the NSWindowWillCloseNotification, since the toolbar
	will need to remove itself from the "toolbars" master array.
	Also added a method called [NSToolbar _handleNotification:]
	to do the actual removal.
	* Source/GSToolbar.m: [GSToolbar _setDelegate:] toolbar
	no longer retains it's delegate.   This prevents the delegate
	from leaking.

2004-07-03  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSOutlineView.m: Moved private methods into separate
	category. Made (-_collectItemsStartingWith:into:) safe against nil
	parameter and simplified code. (_removeChildren:) new method as a
	helper in (-reloadItem:reloadChildren:).

2004-07-01  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSOutlineView.m (-reloadItem:reloadChildren:): Convert
	possible NSNull key to nil.

2004-06-28  Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/Additions/GNUstepGUI/GSNibTemplates.h: Updated the 
	GNUSTEP_NIB_VERSION.  This constant defines the number used for
	the GSNibContainer objects' version.   Also added a new topLevelObjects
	ivar to the GSNibContainer class and the method to retrieve it.
	* Source/GSNibTemplates.m: Move the private class GSNibItemCollector
	from NSBundleAdditions.m to GSNibTemplates.m.  This helped clean up
	code and also facilitated the changes necessary for the new .gorm 
	version.  Also changed the signature of awakeWithContext: so it 
	only takes the context dictionary as an argument and no longer 
	requires the items to be passed in. 
	Changed the awakeWithContext method to efficiently retain the objects.
	In initWithCoder: and encodeWithCoder: added new section for updated
	version.  Added some logic to collect the top level items at that time
	so that version 0 and version 1 .gorm files load in a precisely 
	equivalent manner.   Also, updated a change made by Alex Malmberg 
	which was causing the designated initializers to not be called.
	* Source/NSBundleAdditions.m: Moved class to GSNibTemplates as 
	described above.  Cleaned up implementation of +loadNibFile:
	externalNameTable:withZone:.
	* Source/NSNib.m: Removed some of the code which was there to 
	collect top level items.  Also cleaned up some of the code with 
	the new implementation.

2004-06-28  Serg Stoyan <stoyan255@ukr.net>

        * Headers/AppKit/NSScroller.h: Added _pendingKnobProportion ivar.

        * Source/NSScroller.m:
        (setFloatValue:knobProportion:): Implemented disabling of scroller
        when knob proportion equals to 1.0, and implemented pending knob
        proportion setting (fix disappearing of scroller parts when mouse
        button still held down). Set float value only if knob is not being
        dragged.
        (mouseDown): Redundant code removed. Call
        setFloatValue:knobProportion: if _pendingKnobProportion is not 0 or
        just update scroller otherwise.

        * Source/NSBrowser.m:
        (_createColumn): Set initial frame origin to -110,-110 to avoid
        appearing newly created column on top of exising.
        (updateScroller): Remove enabling/disabling scroller wrt last
        NSScroller changes. Rewrite floating value calculating code and
        avoid devide-by-zero case. Always update scroller values (scroller
        handle the case when it shouldn't update itself).

2004-06-28  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSCursor.h: Added more MacOSX methods for standard
	cursors.
        * Source/NSCursor.m: Implemented new standard cursors methods. 
	(+setHiddenUntilMouseMoves:) added implementation. 
	(+initialize) set isHiddenUntilMouseMoves to NO (was YES).
        * Source/NSApplication.m: (-nextEventMatchingMask:...dequeue:) when
	cursor is hidden until mouse move, call [NSCursor
	setHiddenUntilMouseMoves: NO] instead of [NSCursor unhide].

2004-06-27 23:10  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSNibTemplates.m: Replace calls to
	GSGetInstanceMethodNotInherited with calls to GSGetMethod.

2004-06-25  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibCompatibility.m: Print a message when .gorm files are
	loaded which use the old templates contained here.  The next major
	release should see the removal of these templates from GNUstep.  The
	new templates have completely superceded these.
	* Source/NSTextView.m: Added call to register for types in
	initWithCoder:
	* Source/NSDataLinkPanel.m: Minor reformatting.

2004-06-26  Serg Stoyan <stoyan255@ukr.net>

        * Source/NSBrowser.m:
	(updateScroller): Use _firstVisibleColumn to define visibility of
	scroller. Use _lastVisibleColumn to calculate knob proportion if
	last visible column and last loaded column is not the same.
	
2004-06-25  Serg Stoyan <stoyan255@ukr.net>

        * Source/NSBrowser.m:
	(setPath:): Deselect all cells in first column before setting
	absolute path if first column's selection changed.
	(doClick:): Fix problem with deselection of already selected item.
	Update scroller after setting selection.

2004-06-24  Fred Kiefer <FredKiefer@gmx.de>

        * Source/NSTableView.m: (-noteNumberOfRowsChanged) corrected off
	by one error in (NSIndexSet -removeIndexesInRange:) call.
	
2004-06-23  Serg Stoyan <stoyan255@ukr.net>

	* Source/NSBrowser.m: (frameOfColumn:): Fixed calculating of last
	visible column width when columns are separated.
	(drawRect:): Draw horizontal scroller border only when columns are
	separated. Fixed calculating of horizontal scroller width.
	
2004-06-22  Adrian Robert <arobert@cogsci.ucsd.edu>

	* Documentation/manual: Beginnings of programming manual for GUI like
	the one for Base but just focusing on the library itself (no
	Objective-C introduction).  Structure copied from base manual.
	* Documentation/gnustep-gui.texi: Moved to manual/Introduction.texi.
	* Documentation/Gui/Introduction.gsdoc: Moved to
	manual/BasicClasses.texi.
	* Documentation/Gui/Gui.gsdoc: Updated to reflect above moves.
	* Documentation/General/OpenStepCompliance.gsdoc: Fix typos.
	* Documentation/GNUmakefile: Update to build manual and also be a
	little more parallel to base Documentation makefile.
	* Documentation/GNUmakefile.postamble: Remove stray backslash.

2004-06-21  Fred Kiefer <FredKiefer@gmx.de>

        * Source/NSTableView.m:
        * Source/NSOutlineView.m: (-_willDisplayCell:forTableColumn:row:)
	New method to abstract from differences in table and outline
	view. Used whenever the delegate gets informed by
	willDisplayCell:.
	(_setObjectValue:forTableColumn:row:) Check for correct method.

2004-06-20  Fred Kiefer <FredKiefer@gmx.de>

        * Source/NSTableView.m: (-mouseDown:) Set value after cell tracking.
	(_setObjectValue:forTableColumn:row:) Check for correct method.
	Patch by Matt Rice <ratmice@yahoo.com>
       * Source/NSComboBoxCell.m: (-objectValue) Added this method, as
       the object value never gets set.

2004-06-19  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSDragView.m: (-_handleEventDuringDragging:) Get mouse
	location on periodic event.

2004-06-19  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSDisplayServer.h: Added new method
	(-findWindowAt:windowRef:excluding:).
	* Source/GSDisplayServer.m: Implemented (-dragInfo) with
	GSDragView.
	* Source/GNUmakefile: Added GSDragView.h. 
	* Source/GSDragView.m: Implemented
	(-_windowAcceptingDnDunder:windowRef:) with new GSDisplayServer
	method.	
	
2004-06-17  Fred Kiefer <FredKiefer@gmx.de>

       * Source/NSComboBoxCell.m: buttonCellFrameFromRect(),
       (-drawWithFrame:inView:), (-highlight:withFrame:inView:) and
       (-trackMouse:...untilMouseUp:): Made draw bettere when used in a
       flipped view. (-positionWithComboBoxCell:) position popup correctly
       for flipped view.

2004-06-16  Fred Kiefer <FredKiefer@gmx.de>

        * Source/NSTableView.m: (-mouseDown:) Added mouse tracking in the cell.
        * Source/NSComboBoxCell.m: (-trackMouse:...untilMouseUp:) Set _lastValidFrame
	[GSComboWindow positionWithComboBoxCell:] compute position based on
	_lastValidFrame not the frame from the control view.
	
2004-06-16  Fred Kiefer <FredKiefer@gmx.de>

        * Source/NSTableView.m: (-mouseDown:) Reordered code and
	simplified. (-textShouldEndEditing:) Get formatter from
	_editedCell not _cell. (-_unselectAllColumns) Clear the header
	view as well.

2004-06-15  Fred Kiefer <FredKiefer@gmx.de>

        * Source/NSComboBoxCell.m: (-copyWithZone:) Added missing method.

2004-06-11  Adam Fedor  <fedor@gnu.org>

	* Version 0.9.3
	* Documentation/ReleaseNotes.gsdoc: New file
	* Documentation/GNUmakefile: generate ReleaseNotes. Update
	GuiUser make
	* Documentation/GuiUser/GNUmakefile: New file.
	* Source/DocMakefile: Remove GuiUser generation.

2004-06-09  Quentin Mathe <qmathe@club-internet.fr>

        * Source/NSComboBoxCell.m: Improved look, added constrained height and
	minor documentation change.
	* Source/NSComboBox.m: Added constrained height and minor documentation
	change.

2004-06-08  Fred Kiefer <FredKiefer@gmx.de>

        * Source/NSCell.m: (-drawWithFrame:inView:)
        * Source/NSFormCell.m: (-drawWithFrame:inView:)
        * Source/NSTableHeaderCell.m: (-drawWithFrame:inView:)
        * Source/NSTableView.m: (-drawRect:)
        * Source/NSColorWell.m: (-drawRect:)
        * Source/NSProgressIndicator.m: (+initialize, -drawRect:)
        * Source/NSScrollView.m: (-drawRect:)
        * Source/NSTabView.m: (-drawRect:)
        * Source/GSTitleView.m: (-drawRect:)
        * Source/NSBrowser.m: (-drawRect:, [GSBrowserTitleCell drawWithFrame:inView:])
	Use GSDrawingFunction methods instead of NS functions. Also
	changed colour of progress indicatore. Patch by Nicolas Roard
	<nicolas@roard.com>. 
	
2004-06-07  Quentin Mathe <qmathe@club-internet.fr>
        
	* Source/NSComboBoxCell.m: Added complete documentation.
	* Source/NSComboBox.m: Minor documentation corrections.

2004-06-06  Quentin Mathe <qmathe@club-internet.fr>
        
	* Source/NSComboBox.m: Added complete documentation.

2004-06-04  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSDragView.h:
	* Source/GSDragView.m: New files with a backend neutral drag and
	drop implementation.
	* Source/GNUmakefile: Added GSDragView.m. 
	* Source/NSPrintOperation.m: Use correct subclass for PDF operations.

2004-06-02  Riccardo Mottola  <rollei@tiscalinet.it>
	    David Ayers  <d.ayers@inode.at>

	* Source/GSToolbar.m ([GSValidationManager-initWithWindow:):
	Move variable declarations to the beginning of the block.
	Format according to standards.
	
2004-06-01  Gregory John Casamento <greg_casamento@yahoo.com>

	* configure.ac: added code to detect the presence of 
	libaspell for the new implementation of GSspell.
	* configure: regenerated.
	* Tools/GSspell.m: Completely reimplemented the 
	spell-checker code using aspell.  This simplified the
	code tremendously.
	
2004-05-31  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSDrawFunctions.h:
	* Source/GSDrawFunctions.m: (-drawDarkButton::) New
	method. Changed all methods to return the interior rectangle.
	based on patch by Nicolas Roard <nicolas@roard.com>.
	* Source/NSComboBoxCell.m: (-_selectCompleted) new method to
	handle completion of selection in data source case correctly.
	(-popUpForComboBoxCell:) use this method and also clear
	selection at the end, so a new popup starts without selection.
	(-selectItemAtIndex:) simplified and return when invalid
	index is given. (-_loadButtonCell) always use image name
	"NSComboArrow" and removed force arrow variable.
	* Images/nsmapping.strings: mapping "NSComboArrow" to
	"common_ComboBoxEllipsis". 
		
2004-05-29  Quentin Mathe <qmathe@lub-internet.fr>
        
	* Source/NSComboBoxCell.m: Fixed problems related to decoding an
	encoded combo box previous version (Bug reported by Gregory
	Casamento).

2004-05-29  Gregory John Casamento <greg_casamento@yahoo.com>

	* Images/page_landscape.tiff: Removed the tags in the image
	which were causing warnings on load.
	* Images/page_portrait.tiff: same.
	* Images/common_ToolbarClippedItemsMark.tiff

2004-05-29  Quentin Mathe <qmathe@lub-internet.fr>
        
	* Source/NSComboBox.m:
	* Headers/AppKit/NSComboBox.h:
	* Source/NSComboBoxCell.m:
	* Headers/AppKit/NSComboBoxCell.h:
	* Images/GNUmakefile:
	* Images/common_ComboBoxEllipsis.tiff:
	New rewritten combo box implementation (which can be called completion
	box now).  Everything should work except the completion possibility 
	which needs some layout manager and text view changes (patches to be 
	commited by Alexander Malmberg).

2004-05-29  Quentin Mathe <qmathe@lub-internet.fr>

	* Source/NSControl.m: Reverted to the previous version (1.61) because 
	the 2004/05/23 changes changed the way an event can be caught by one
	responder definitively through the responder chain.
	* Source/GSToolbar.m: New way to catch mouse events with the validation
	system (Uses NSWindowDidUpdateNotification instead of events 
	interception at the view level) and other minor changes.

2004-05-27 01:39  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSImage.m (-size): Don't try to get the size if rep is nil.

2004-05-25  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTableView.m: (-noteNumberOfRowsChanged)
	Made save against [_selectedRows lastIndex] returning NSNotFound.
	
2004-05-23  Quentin Mathe <qmathe@lub-internet.fr>

        * Source/NSWindow.m: Added a method -_windowView which returns the 
	root view (variable _wv) and replaced _contentView by _wv in the 
	tracking implementation.
	* Source/NSControl.m: Modified to call the associated superclass method
	each time -mouseDown: is called to have the possibility to add 
	behaviors to the related NSView method.
	Modifications needed to fully support toolbar validation mechanism.

2004-05-23  Quentin Mathe <qmathe@lub-internet.fr>
        
        * Source/GSToolbarView.m:
	* Headers/GNUstepGUI/GSToolbarView.h:
        * Source/GSToolbar.m:
	* Headers/GNUstepGUI/GSToolbar.h:
	* Source/NSToolbar.m:
	* Headers/AppKit/NSToolbar.h:
	* Source/NSToolbarItem.m:
	* Headers/AppKit/NSToolbarItem.h:
	* Source/NSWindow+Toolbar.m:
	Last part in the validation implementation, border taken in
	account by the layout process, lot of memory leaks fixed, selected
	item possibility implemented and other minor improvements.
	
2004-05-18  Quentin Mathe  <qmathe@club-internet.fr>

        * Source/GSToolbarView.m: Added color customization (default background
	color is now no color), part of the toolbar validation mechanism
	and other minor changes.
	* Headers/GNUstepGUI/GSToolbarView.h: Same.
	* Source/NSToolbarItem.m: Added part of the toolbar validation
	mechanism, new menuFormRepresentation implementation to have the
	menu item titles used as label with the text display mode and
	other minor changes.

2004-05-14  Adam Fedor  <fedor@gnu.org>

	* Source/NSDocumentController.m 
	([NSDocumentController -currentDirectory]): 
	Conform to the documentation. (Fixes #7900).

	* Tools/gsnd/gsnd.m: Rename variables starting with _, indent lines 
	properly (Fixes #7502).

2004-05-14  Serg Stoyan <stoyan@on.com.ua>

	* Source/NSBrowser.m ([drawRect:]): use _bounds instead of rect
	for NSDrawGrayBezel().

	* Source/NSSplitView.m ([adjustSubviews]): call setNeedsDisplay:
	after resizing subviews.

2004-05-04  Enrico Sersale  <enrico@imago.ro>

	* Source/NSWorkspace.m ([NSWorkspace -mountedRemovableMedia]): 
  Doesn't consider a final empty line in mtab.

2004-05-12 16:50  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSParagraphStyle.m (+defaultWritingDirectionForLanguage:):
	Implement. Patch from Christopher Culver.

2004-05-12 15:52  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-_generateGlyphsForRun:at:): Use a
	properly typed function pointer for characterIsMember.

2004-05-08  Fred Kiefer <FredKiefer@gmx.de>

	* Header/Cocoa/Cocoa.h:
	New header file for Cocoa compatibility. Currently not installed.
	* Source/NSTableView.m:
	Implemented [selectColumnIndexes:byExtendingSelection:] and
	[selectRowIndexes:byExtendingSelection:].
	* Source/NSDocument.m:
	Implemented [runModalSavePanelForSaveOperation:..contextInfo:], 
	[saveDocumentWithDelegate:didSaveSelector:contextInfo:] and
	[saveToFile:..contextInfo:]. Added call to [prepareSavePanel] in
	[fileNameFromRunningSavePanelForSaveOperation:]. 

2004-05-04  Enrico Sersale  <enrico@imago.ro>

	* Source/NSWindow.m ([NSWindow -sendEvent:]): Doesn't
	makeKeyAndOrderFront if _windowLevel == NSDesktopWindowLevel.

2004-04-27  Adam Fedor  <fedor@gnu.org>

	* Source/NSApplication.m ([NSAppIconView -drawRect:]): Draw dot when
	hidden.
	([NSAppIconView -setImage:]): Use -drawRect:
	(-hide:,-unhideWithoutActivation:): Mark icon view as needing display.
	(based on patch from Rafael Herzog).

2004-04-27  Quentin mathe <qmathe@club-internet.fr>
       
        * Source/NSToolbarItem.m: Modified to have the action message sent by
	NSToolbarItem instances (not by GSToolbarButton instances) in order to
	match the Mac OS X behavior. (Bug reported by Ludovic Marcotte)

2004-04-16 15:33  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTableView.m (-dragImageForRows:event:dragImageOffset:):
	Autorelease the new image.

2004-04-14 00:36  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSBrowser.m (-keyDown:): When the user selects a cell
	by typing a partial name, make sure all other cells are
	deselected.

2004-04-13  Quentin Mathe <qmathe@club-internet.fr>

        * Source/NSToolbarItem.m:
        * Headers/AppKit/NSToolbarItem.h: 
        * Source/NSToolbar.m:
        * Headers/AppKit/NSToolbar.h:
        * Source/GSToolbar.m:
        * Headers/GNUstepGUI/GSToolbar.h:
        * Source/GSToolbarView.m:
        * Headers/GNUstepGUI/GSToolbarView.h:
        * Source/NSWindow+Toolbar.m:
        * Headers/AppKit/NSWindow+Toolbar.h:
        Added support for display mode and size mode and other minor changes.

2004-04-09  Kazunobu Kuriyama <kazunobu.kuriyama@nifty.com>

	* Documentation/GuiUser/LanguageSetup.gsdoc: Added Korean stuff.
	  (Thanks to Song Woo-il.)

2004-04-04  Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/AppKit.h: Added NSNib.h to the #ifndef STRICT_OPENSTEP
	section of the headers.
	
2004-04-02  Quentin Mathe <qmathe@club-internet.fr>

        With the help of Fred Kiefer and Alexander Malmberg, the modifications
	below are mainly introduced to fix the fact -[NSCell performClick:] 
	doesn't work correctly when the cell frame is not identical to the
	control frame which is displaying it :
        * Source/NSButton.m: Removed -performClick: method already present in
	the superclass NSControl.
	* Headers/AppKit/NSButton.h: Same.
	* Source/NSButtonCell.m: Replaced -performClick: method by
	-performClickWithFrame:inView: method which overrides new method with
	the same name in the superclass NSCell.
	* Headers/AppKit/NSButtonCell.h: Same
	* Source/NSCell.m: Added a method -performClickWithFrame:inView:
	to be used in place of -performClick: method which has been deprecated.
	* Headers/AppKit/NSCell.h: Same
	* Source/NSControl.m: Modified -performClick: method to use the new
	NSCell method -performClickWithFrame:inView:.
        * Source/NSPopUpButtonCell.m: Modified
	-performClickWithFrame:inView: to override the new method with the
	same name in the superclass NSCell.

2004-04-02  Quentin Mathe <qmathe@club-internet.fr>

        * Source/NSWindow+Toolbar.h: Moved into Headers/AppKit
	* Headers/AppKit/AppKit.h: Include NSWindow+Toolbar.h now
	* Source/GNUMakefile: Modified to reflect this change

2004-03-29 18:25  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-setSelectedRange:affinity:stillSelecting:):
	Always scroll to make the selection visible, and scroll to the right
	part of it. (Bug reported by Ludovic Marcotte.)

2004-03-27  Fred Kiefer <FredKiefer@gmx.de>

	* Header/AppKit/NSTableView.h:
	Added ivars _selectedColumns and _selectedRows to NSMutableIndexSet.
	* Source/NSTableView.m: 
	* Source/NSOutlineView.m: 
	Changed all the uses of these ivars and started to restructure the
	row selection code. Also removed some (not all) dead code.
	
2004-03-23 23:52  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Additions/GNUstepGUI/GSToolbar.h,
	Headers/Additions/GNUstepGUI/GSToolbarView.h: Add missing includes
	to make the headers selfcontained.

2004-03-23  Quentin Mathe <qmathe@club-internet.fr>

        * Source/NSWindow.m: NSToolbar related methods removed.
	* Headers/AppKit/NSWindow.h: same (NSToolbar related ivars still 
	present).

2004-03-22 18:06  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSView.m (-lockFocusInRect:): Don't convert the clipping
	rect to the window's coordinate system; the clip is done in the
	view's coordinate system. Reported by Georg Fleischmann.

	(convert_rect_using_matrices): New function that (correctly)
	converts rectangles between views.

	(-convertRect:fromView:, -convertRect:toView:): Reimplement using
	convert_rect_using_matrices. Document.

2004-03-22 02:00  Georg Fleischmann <georg@vhf.de>

	* Source/NSAffineTransform.m (-rotationAngle): Correct the sign of
	the angle and wrap it so that it's always >=0 and <=360.

2004-03-22 01:13  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m
	(-textStorage:edited:range:changeInLength:invalidatedRange:): Update
	layout_char, glyph_delta, and new_last_glyph only if it makes sense
	to do so and we need the value.	Clarify and correct layout_char
	update. Add comments.

2004-03-14 19:42  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSView.m (-hitTest:): Don't require that the point is
	inside our super view if we don't have a super view.

2004-03-14 19:29  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTableView.m (-mouseDown:): Send the action for simple
	clicks even if the selection changed.

2004-03-13 03:19  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m
	(-textStorage:edited:range:changeInLength:invalidatedRange:): Handle
 	the case where layout_char is inside the modified range explicitly to
	avoid accidentally causing the value to wrap around.

	(-drawGlyphsForGlyphRange:atPoint:): Remove dead (since the change
	2003-11-01) code. Update comments.

2004-03-12  Quentin Mathe <qmathe@club-internet.fr>

        * Source/GSToolbarView.m: Bug fixes related to clipped items and more
	efficient code.
	* Headers/Additions/GNUstepGUI/GSToolbarView.h: Minor changes.
        * Source/NSToolbar.m: Refactored NSToolbar implementation, most part of
	the code has moved to GSToolbar.
        * Headers/AppKit/NSToolbar.h: Same.
	* Source/GSToolbar.m: New class which implements functionnality for the
	basic GNUstep toolbars with some bug fixes.
        * Headers/Additions/GNUstepGUI/GSToolbar.h: Header for the new basic
	GNUstep toolbar class.
	* Source/NSWindow+Toolbar.m: Bug fixes.
	* Source/NSWindow+Toolbar.h: Minor changes.

2004-03-12 15:30  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTableView.m (-mouseDown:): Send our action if we get
	a single, simple (no drag) click.

2004-03-08 19:19  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSPageLayout.m (-readPrintInfo): Move declarations before
	statements.

2004-03-08 19:04  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSComboBoxCell.m (-runModalPopUp): Don't make the popup
	the key window.

2004-03-08  Fred Kiefer <FredKiefer@gmx.de>

	* Header/AppKit/NSView.h:
	Added ivars _is_hidden, _in_live_resize and _focusRingType.
	* Source/NSView.m: 
	(-canDraw) fully implemented. (-displayIfNeededInRectIgnoringOpacity:,
	-displayRectIgnoringOpacity:) use canDraw. (-setFocusRingType:,
	-focusRingType, -needsToDrawRect:, -isHidden, -setHidden:,
	-inLiveResize, -viewWillStartLiveResize, -viewDidEndLiveResize)
	implemented. (-canBecomeKeyView) use isHiddenOrHasHiddenAncestor
	instead of isHidden.
	
2004-03-07  Adam Fedor  <fedor@gnu.org>

	* Documentation/Gui/Gui.gsdoc: Use automatic indexing
	* Source/DocMakefile (AUTOGSDOC_HEADERS_GUI): Add NSNib, NSOpenGL
	NSOpenGLView.
	* Source/NSNib.m: Fix doc markup typo.

2004-03-06  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSActionCell.m: 
	Removed methods -setFloatValue:, -setIntValue: and setDoubleValue:

2004-03-06  Fred Kiefer <FredKiefer@gmx.de>

	* Header/AppKit/NSSavePanel.h:
	Added some ivars for new methods.
	* Source/NSSavePanel.m: (-setDelegate:, -_selectTextInColumn:)
	implemented delegete calls on selection and directory change,
	based on patch by Fabien Vallon.
	Basic implementation for some of the new Cocoa methods.

2004-02-29  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSToolbar.m: Added code in 
	-[NSToolbar insertItemWithIdentifier:atIndex:] to properly
	handle when a system defined identifier is passed to the toolbar.

2004-03-01  Fred Kiefer <FredKiefer@gmx.de>

	* Header/AppKit/NSTableView.h:
	* Header/AppKit/NSSavePanel.h:
	* Source/NSTableView.m:
	* Source/NSSavePanel.m:
	Declared some more MacOSX 10.3 methods and added place holders for
	them.
	* Source/NSTextView.m:
	Implemented keyed unarchiving.
	
2004-02-29  Adam Fedor  <fedor@gnu.org>

	* Headers/AppKit/NSPageLayout.h: Update tags.
	* Images/GNUmakefile: Add page_landscape.tiff, page_portrait.tiff.
	* Panels/English.lproj/GSPageLayout.gorm: Update.
	* Source/NSPageLayout.m: Internationalize gui text. Update for
	gorm changes. (Patches from Fabien Vallon).

2004-02-28  Adam Fedor  <fedor@gnu.org>

	* Version 0.9.2
	* Documentation/news.texi: Update.

2004-02-28  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSToolbarItem.m: Corrected misspelling of Separator.
	* Images/common_ToolbarSeparatorItem.tiff: added, misspelled 
	image file deleted
	* Images/GNUmakefile: Corrected.
	
2004-02-29  Fred Kiefer <FredKiefer@gmx.de>

	* Header/AppKit/NSApplication.h:
	Defined values for the constants NSRunStoppedResponse,
	NSRunAbortedResponse, NSRunContinuesResponse.
	* Source/NSOpenPanel.m: (-ok:)
	* Source/NSSavePanel.m: (-cancel:, -ok:) Use stopModalWithCode:
	with the approriate button code.
	* Source/NSSavePanel.m: (-runModalForDirectory:file:,
	-runModalForDirectory:file:relativeToWindow:) Removed the check
	for the pressed button and return the value of the model loop
	directly.
	* Source/NSBox.m: (-drawRect:) Blank out the title rectangle
	here and not delegate this to the title cell via the background
	colour. (-initWithFrame:) Use an NSCell instead of an
	NSTextFieldCell for the title, as setBackgroundColour: is no
	longer needed.

2004-02-28  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Don't add CPPFLAGS to ADDITIONAL_INCLUDES, add
	ungif and X11 flags to GRAPHIC_... flags.

2004-02-26  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSApplication.m: (-beginSheet:...contextInfo:)
	Corrected signature of didEnd function.
	* Source/NSMenu.m: (-update)
	Tried to handle case for autoenabling correctly where a popup
	button doesn't have an action.
	* Source/NSBezierPath.m: (-contributionToContains:)
	* Source/NSStringDrawing.m: (cache_match())
	Replaced random() with rand() to increase portability.	

2004-02-24  Quentin Mathé <qmathe@club-internet.fr>
	committed by Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/Additions/GNUstepGUI/GSToolbarView.h: Changes for 
	new toolbar implementation.
	* Headers/AppKit/NSToolbar.h: same as above.
	* Headers/AppKit/NSToolbarItem.h: same...
	* GNUmakefile: Added new files
	* Source/NSButtonCell.m: Changes to improve the look of 
	unbordered buttons.
	* Source/NSToolbar.m: Changes for new toolbar implementation.
	* Source/NSToolbarItem.m: same...
	* Source/NSWindow+Toolbar.[hm]: New category to localize
	changes for NSToolbar which need to reside in NSWindow.
	* Images/common_ToolbarClippedItemsMark.tiff: ">>" image to
	show that there are more items which are not being displayed.

2004-02-24  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSDrawFunctions.h:
	Corrected misnaming of method in last change.
	
2004-02-24  Fred Kiefer <FredKiefer@gmx.de>

	* Images/nsmapping.strings:
	Added definition for NSMenuMixedState.
	* Source/NSButtonCell.m: (-setButtonType:)
	* Source/NSMenuItemCell.m: (+initialize)
	* Source/NSMenuItem.m: (-initWithTitle:action:keyEquivalent:)
	Use image aliases instead of file names.
	* Source/GSNibCompatibility.m: Reenabled keyed archiver for
	NSWindowTemplate and added missing include.

2004-02-20  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSView.h:
	* Source/NSView.m: (+defaultFocusRingType,
	-setKeyboardFocusRingNeedsDisplayInRect:, -setFocusRingType:,
	-focusRingType, -setHidden:, -isHidden,
	-isHiddenOrHasHiddenAncestor, -wantsDefaultClipping,
	-needsToDrawRect:, -getRectsBeingDrawn:count:, -inLiveResize,
	-viewWillStartLiveResize, -viewDidEndLiveResize,
	-mouseDownCanMoveWindow, -dragPromisedFilesOfTypes:...event:,
	-canBecomeKeyView) 
	Stubs for new MacOSX methods.

2004-02-17 00:18  Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/NSNib.h: Improved documentation.
	
2004-02-15 20:56  Gregory John Casamento <greg_casamento@yahoo.com>
	
	* Source/GSNibCompatibility.m: Removal of keyed archiver
	code in deprecated template NSWindowTemplate.  I commented this
	out as we need to determine how to implement this with the 
	keyed archiver changes in the new templates.

2004-02-15  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSLayoutManager.m: 
	* Source/NSTextContainer.m:
	* Source/NSTextStorage.m:
	* Source/GSNibCompatibility.m: (NSWindowTemplate 
	More keyed dearchiving.
	* Source/NSView.m: (-initWithCoder:)
	Don't keyed decode next responder, as this gets set by superview
	anyway. 

2004-02-14 23:05  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSNib.[hm]: Corrected previous issue with NSNib.  
	Uncommented the code and cleaned up the implementation.
	
2004-02-14 22:56  Matt Rice <ratmice@yahoo.com>
		  Alexander Malmberg <alexander@malmberg.org>

	* Tools/gopen.m (main): Remove NSTask-based app launching code; always
	use [NSWorkspace -launchApplication:] to launch applications.

2004-02-14  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSOutlineView.m: (-reloadItem:reloadChildren:) Simplified
	and corrected code by inlining the method
	[_findItem:childIndex:ofParent:]. 

2004-02-13  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSButtonCel.m: (-setObjectValue:, -objectValue)
	Implemented to set/return the state. 
	(-mouseEntered:, -mouseExited:, -drawWithFrame:inView:)
	Partially added old showsBorderOnlyWhileMouseInside patch from
	Michael Hanni (mhanni@yahoo.com).
	* Headers/Additions/GNUstepGUI/GSDrawFunctions.h:
	* Source/GSDrawFunctions.m: New gradient border drawing method.

2004-02-12  Adam Fedor  <fedor@gnu.org>

	* Documentation/GuiUser/KeyboardSetup.gsdoc: Update.
	* Source/DocMakefile (GuiUser_AGSDOC_FILES): Add it.

2004-02-12  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSOutlineView.m: (-draggingUpdated:) Applied patch from
	Andreas Heppel (andreas.heppel@sysgo.com) to determine drag
	operation correctly.
	
2004-02-11  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMatrix.m: (-setBackgroundColor:,
	-setCellBackgroundColor:, -setDrawsBackground:,
	-setDrawsCellBackground:) call setNeedsDisplay: to give better
	feedback on change.

2004-02-11 17:27  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Additions/GNUstepGUI/GSServicesManager.h,
	Headers/Additions/GNUstepGUI/GSTitleView.h,
	Headers/AppKit/NSDrawer.h, Headers/AppKit/NSHelpManager.h,
	Headers/AppKit/NSMenuItem.h, Headers/AppKit/NSPrintOperation.h,
	Headers/AppKit/NSSpellProtocol.h, Headers/AppKit/NSTableColumn.h,
	Headers/AppKit/NSToolbar.h,
	Headers/AppKit/NSUserInterfaceValidation.h: Add missing forward
	declarations and includes to make all headers self-contained.

2004-02-11  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenuItemCell.m: (-drawBorderAndBackgroundWithFrame:inView:)
	Let GSDrawFunctions do the border drawing. Removed caching of
	colour class.
	* Source/NSImageCell.m: (-drawWithFrame:inView:) Let
	GSDrawFunctions do the border drawing. 
	
2004-02-10 21:48  Alexander Malmberg <alexander@malmberg.org>

	* Headers/AppKit/NSFont.h: Add cachedScreenFont ivar.
	* Source/NSFont.m: Add GSFontMapKey class and use it to find fonts
	in globalFontMap. Replace newNameWithMatrix function with keyForFont.
	Update callers.
      	(-initWithName:matrix:fix:screenFont:role:): Initialize
	cachedScreenFont.
	(-screenFont): Use cachedScreenFont.

2004-02-09 03:10  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac: Check for X. Add --enable-ungif/--disable-ungif and
	--with-ungif-include/--with-ungif-library options. If the check for
	libungif fails and X was found, check for libungif again, including
	the X libraries. Patch from Kazunobu Kuriyama.
	* configure: Regenerate.

2004-02-08 20:56  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Backout of NSNib modification.
	* Source/NSBundleAdditions.m: ditto.
	* Source/NSNib.m: Commented out some code and private class.

2004-02-09  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSLayoutManager.m (-drawGlyphsForGlyphRange:atPoint:)
	Replaced explicit colour setting.
	* Source/NSTabView.m: (-drawRect:) Use color constant instead of
	number in DPSsetgray().	

2004-02-08  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSDrawFunctions.h: Add two more methods.
	* Source/GSDrawFunctions.m: Evaluate colour names only ones per
	method. Corrected count in drawFramePhoto: and drawButton:. Added
	drawGrayBezel: and drawWhiteBezel:.
	* Source/NSButtonCell.m: (-drawWithFrame:inView:) use
	GSDrawFunctions to draw border.
	* Source/NSTabView.m
	* Source/NSTabViewItem.m
	* Source/NSBundleAdditions.m (NSNibConnector)
	Added keyed decoding. 

2004-02-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/Function.m
	Corrected NSDrawWhiteBezel(), NSDrawDarkBezel() and
	NSDrawLightBezel() to be almost identical to their Cocoa counterparts.
	* Source/NSMenuItemCell.m
	* Source/NSPopUpButtonCell.m
	Corrected keyed decoding. 

2004-02-08 01:36  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSNib.m: Added implmentation for this class.
	* Headers/AppKit/NSNib.h: Added header for this class.
	* Source/GSNibTemplates.m: Modified awakeWithContext:topLevelItems:
	to use the NSNibOwner/NSNibTopLevelObjects entries.
	* Source/NSBundleAdditions.m: Added code to use NSNib to load
	and instantiate the .gorm file.   NSNib now contains all of the
	.gorm loading code.   NSNib currently does not support .gmodel
	loading.
	
2004-02-07 03:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTableView.m (-initWithCoder:): Remove an erroneous 'else'
	from the previous change.

2004-02-06  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenu.m (-dealloc) Clean up pointer from items to menu.
	* Source/NSMenuView.m (-update) Removed the setting of the menu
	for the title view. Patch by Quentin Mathé
	(gnustep-quentin@club-internet.fr) 
	* Source/NSActionCell.m
	* Source/NSComboBoxCell.m
	* Source/NSTableColumn.m
	* Source/NSTableView.m
	* Source/NSTextField.m
	* Source/NSTextFieldCell.m
	Added keyed decoding. 

2004-02-05 21:04  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSTitleView.m: Fix declarations after statements.

2004-02-05  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenu.m
	* Source/NSMenuItem.m
	* Source/NSPopUpButtonCell.m
	Added keyed decoding. 
	
2004-02-04 01:24  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSView.m: Remove uses of the deprecated "casts as lvalues"
	gcc extension.

2004-02-03 23:38  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSBitmapImageRep.m (+imageRepsWithFile:,
	_initFromWrasterFile:, _wrasterFileTypes): Remove obsolete libwraster
	image loading hack. Update callers.

	* Source/NSImageRep.m (+imageRepsWithContentsOfFile:): Remove uses
	of the removed NSBitmapImageRep methods.

2004-02-02  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSFont.m
	Try to get at least some font on keyed decoding.
	* Source/NSTextFieldCell.m
	* Source/NSImageCell.m
	* Source/NSImageView.m
	* Source/NSBox.m
	* Source/NSSplitView.m
	Added keyed decoding. 

2004-02-01  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTextFieldCell.m (-setBackgroundColor:,
	-setDrawsBackground:, setTextColor:) tell the control, that the
	cell did update.
	
2004-01-30  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBrowser.m
	* Source/NSBrowserCell.m
	* Source/NSButtonCell.m
	* Source/NSCell.m
	* Source/NSClipView.m
	* Source/NSColor.m
	* Source/NSControl.m
	* Source/NSCursor.m
	* Source/NSFont.m
	* Source/NSProgressIndicator.m
	* Source/NSScroller.m
	* Source/NSScrollView.m
	* Source/NSView.m
	Added keyed decoding. 

2004-01-26  Adam Fedor  <fedor@gnu.org>

	* /Headers/Additions/GNUstepGUI/GSHbox.h: Fix doc markup.
	* Headers/Additions/GNUstepGUI/GSTable.h: Idem.
	* Source/NSApplication.m: Idem.

	* Source/DocMakefile (GuiAdditions_AGSDOC_FILES): 
	  Add GuiAdditions.gsdoc

2004-01-26  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPopUpButton.m (-setTitle:) Call
	[synchronizeTitleAndSelectedItem], this may as well belong into
	the cells setTitle: method instead.

2004-01-25  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSAffineTransform.m: Exchanged the code of
	appendTransform: and prePendTransform: to be Cocoa compatibile.
	(-concatenateWith:) replaced appendTransform: with prependTransform:.
	* Source/NSPrintOperation.m: (NSView
	-_displayPageInRect:atPlacement:withInfo:) Item.
	* Source/NSView.m (+initialize, -_rebuildCoordinates) Item.
	
2004-01-25 16:16  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSStringDrawing.m: Big redesign.

	(cache_match, cache_lookup_string, cache_lookup_attributed_string,
	use_screen_fonts): New helper functions for caching layout
	information.

	(init_string_drawing, [NSAttributedString -drawAtPoint:],
	[NSAttributedString -drawInRect:], [NSAttributedString -size],
	[NSString -drawAtPoint:withAttributes:],
	[NSString -drawInRect:withAttributes:],
	[NSString -sizeWithAttributes:]): Reimplement using the cache system
	and the new helper functions.

2004-01-25  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSWindow.m (-orderWindow:relativeTo:): In OrderOut case
	cancle _handleWindowNeedsDisplay unconditional. (-close): Don't
	cancle _handleWindowNeedsDisplay as this gets done by the
	following [orderOut:] call. These changes adopt to a previous
	change in [_handeWindowNeedsDisplay:] to always resend itself.

2004-01-25 04:15  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m (-invalidateDisplayForCharacterRange:,
	-textStorage:edited:range:changeInLength:invalidatedRange:): Adjust
	a few edge cases so that no work is done if there is no existing
	layout information.

2004-01-24 15:17  Gregory John Casamento  <greg_casamento@yahoo.com>

	* Headers/AppKit/NSDataLink.h: Added ivars.
	* Source/NSDataLink.m: Added implementation of some methods.

2004-01-23 21:32  Gregory John Casamento  <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Removal of some commented out test code.

2004-01-22 13:15  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSFontPanel.m (-_initWithoutGModel): Use -setTitle: to set
	the titles of the buttons, not -setStringValue:. Patch from Matt
	Rice.

2004-01-22 13:09  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSButton.m: Rename _nsbuttonCellClass to buttonCellClass
	and make it static.

2004-01-22 13:06  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSActionCell.m (-encodeWithCoder:): Encode nil instead of
	the control view.

2004-01-22 13:04  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Additions/GNUstepGUI/GSDrawFunctions.h: Add missing
	include guards.

	* Source/GSDrawFunctions.m: Correct misspellings and clarify the
	documentation.

2004-01-22 12:16  Alexander Malmberg <alexander@malmberg.org>

	* Model/GMAppKit.m ([NSFont +createObjectForModelUnarchiver:]):
	If there's no font of the decoded name, fall back to the system
	font of the decoded size.

2004-01-19  Kazunobu Kuriyama <kazunobu.kuriyama@nifty.com>

	* GNUmakefile.postamble (after-distclean): Fix deletion of config.make.

2004-01-18  Adam Fedor  <fedor@gnu.org>

	* Source/GSDrawFunctions.m: New class.
	* Source/NSBox.m ([NSBox -drawRect:]): Use it.

2004-01-17 Serg Stoyan <stoyan@on.com.ua>

	* Source/NSBrowser.m:
	(frameOfColumn:): Adjust horizontal position if browser doesn't have
	horizontal scroller.
	(tile): Adjust column height if browser doesn't have horizontal 
	scroller.
	(drawRect:): Better handling of cases with and without horizontal
	scroller.
	
2004-01-16  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSImageView.h: Added ivars for traget and action.
	* Source/NSImageView.m: Implemented target and action handling and
	sending of the action when an image gets dropped on the
	view. Patch by Kazunobu Kuriyama (kazunobu.kuriyama@nifty.com)

2004-01-15 Serg Stoyan <stoyan@on.com.ua>

	* Images/common_MiniWindowTile.m: New file.
	* Images/common_Tile.m: Updated.
	* Images/GNUmakefile: Added common_MiniWindowTile.tiff.
	
	* Source/NSWindow.m (NSMiniWindowView):
	(+initialize): Use common_MiniWindowTile.tiff
	(-drawRect:): Move imageCell down to avoid overlapping with title.
	(-setTitle:): Do not draw background; common_MiniWindowTile.tiff now
	has title background.

	* Source/GSTitleView.[hm]:
	Added closeButton and miniaturizeButton methods to access title
	buttons. Added initWithOwner: method. Comments added. Cleanup.
	(dealloc): Remove observer. Release textAttributes and titleColor.
	Don't release closeButton and miniaturizeButton.
	(setOwner:): Observe NSApplication activate/deactivate notifications.
	Add title buttons according to the window style mask.

	* Source/NSMenuView.m:
	(update): Use GSTitleView's initWithOwner: method. Cleanup.

2004-01-13 Serg Stoyan <stoyan@on.com.ua>

	* Source/NSMenuView.m (trackWithEvent:): Changed checking for
	highlighted item. Old checking have a problems when
	_highlightedItemIndex changed after performActionForItemAtIndex:,
	for example when selecting "Close Window" in detached "Windows"
	submenu.
	
2004-01-12 Serg Stoyan <stoyan@on.com.ua>

	* Source/GSTitleView.m (setOwner): Recognize class that responds 
	to menuRepresentation method as NSMenu derived class. Fix for Gorm.
	Use isKindOfClass: instead of class names comparison.

	* Images/GNUmakefile: Added common_Miniaturize*.tiff to IMAGE_FILES.
	* Images/common_CloseBroken.tiff: Updated.
	* Images/common_CloseBrokenH.tiff: Added.

	* Images/common_WMClose.tiff: Deleted.
	* Images/common_WMCloseBroken.tiff: Ditto.

	* Source/NSApplication.m: (setImageForWindowsItem:): Use common_Close 
	and common_CloseBroken images instead of removed common_WMClose and
	common_WMCloseBroken.
	
2004-01-11  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSTextStorage.m (_setAttributesFrom): Initialize
	range in the aRange.length==0 case. (Found by Andrew Ruder using
	valgrind.) This mirrors the patch to base/GSAttributedString.m.

2004-01-12 Serg Stoyan <stoyan@on.com.ua>

	* Source/GSTitleView.m:
	(+height): return at least 23 pixels.
	(-mouseDown:): Make submenu torn off only after mouse released and if
	menu position changed(so submenu isn't made torn off just clicking on
	the title).
	
2004-01-11 Serg Stoyan <stoyan@on.com.ua>

	* Headers/Additions/GNUstepGUI/GSTitleView.h: new file.
	* Source/GSTitleView.m: ditto.
	
	* Images/common_Close.tiff: updated for GSTitleView.
	* Images/common_CloseH.tiff: ditto.
	* Images/common_Miniaturize.tiff: new file.
	* Images/common_MiniaturizeH.tiff: ditto.
	
	* Source/NSMenuView.m: modified to use GSTitleView for menu title.
	NSMenuWindowTitleView class removed.

2004-01-10 18:53 Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: The unarchiver was failing when 
	decoding objects which contain references to themselves 
	(e.g. NSTabView).  When an object contains a class/item which
	refers to it's parent it should receive the new object and not
	the template.   I modified the initWithCoder: method of GSClassSwapper
	to correct the issue.

2004-01-10  Adam Fedor  <fedor@gnu.org>

	* orderFront fixes
	* Source/NSWindow.m (-orderFront:): Remove NSApp isActive
	check.
	(-orderFrontRegardless): Update for special case (otherWin=-1)
	(-orderWindow:relativeTo:): Pass -1 for otherWin to backend
	if we're the current app.

	* Source/GSDisplayServer.m: Update documentations.

	* Source/NSApplication.m (-changeWindowsItem:title:filename:): Revert
	patch from 2003-10-20.

2004-01-10 16:36  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSScrollView.m (-drawRect:): Indentation fixes after last
	patch.

2004-01-09 Serg Stoyan <stoyan@on.com.ua>

	* Source/NSBrowser.m: 
	(drawRect:) Cosmetic changes in drawing of column separators 
	and horizontal scroller border.
	
	* Source/NSScrollView.m:
	(drawRect): Calculate separator line usning scoller frame. Remove 
	header view counting cases.
	
	* Source/NSScroller.m:
	(drawKnobSlot): Always draw background. Even if there's no room 
	for scroller parts.

2004-01-08 23:26  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSBitmapImageRep+GIF.m: Re-#define Object across the
	include of gif_lib.h . (Reported by Stefan Kleine Stegemann.)

2004-01-08 19:41  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac: Add a check for libungif.
	* configure, Headers/Additions/GNUstepGUI/config.h.in: Regenerate.

	* Source/GNUmakefile: Add NSBitmapImageRep+GIF.m.

	* Source/NSBitmapImageRep+GIF.m, Source/NSBitmapImageRep+GIF.h:
	New files with the GIF image loader.

	* Source/NSBitmapImageRep.m (+canInitWithData:)	Check if the GIF
	loader can handle the data.
	(+imageUnfilteredFileTypes): Add ".gif".
	(+imageRepsWithData:, -initWithData:): Use the GIF loader to load
	GIF images.

2004-01-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSActionCell.m (-initWithCoder:) Don't decode the control
	view, as this may be a Gorm placeholder or otherwise invalid.
	* Source/GSDisplayServer.m:
	(-discardEventsMatchingMask:beforeEvent:),
	(getEventMatchingMask:beforeDate:inMode:dequeue:) Use function
	NSEventMaskFromType instead of explicit switch statement where a
	few entries where missing.	

2004-01-08 01:24  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSActionCell.m (-setObjectValue:): Change the argument type
	to id from 'NSString *'.

2004-01-08 00:47  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac: Fail with a verbose error message if libjpeg or
	libpng can't be found. Add --disable-jpeg/--disable-png options that
	override this.
	* configure: Regenerate.

	* Source/GNUmakefile: Add NSBitmapImageRep+JPEG.m,
	NSBitmapImageRep+PNG.m, and NSBitmapImageRep+PNM.m .

	* Source/NSBitmapImageRep.m (+canInitWithData:) Check if one of the
	new loaders can handle the data.
	(+imageUnfilteredFileTypes): Include the types from the new loaders.
	(+imageRepsWithData:, -initWithData:): Use the new loaders to load
	images.

	* Source/NSBitmapImageRep+JPEG.m, Source/NSBitmapImageRep+JPEG.h,
	Source/NSBitmapImageRep+PNG.m, Source/NSBitmapImageRep+PNG.h,
	Source/NSBitmapImageRep+PNM.m, Source/NSBitmapImageRep+PNM.h:
	New files with image loaders for JPEG, PNG, and PNM.

2004-01-07  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSHbox.h:
	* Headers/Additions/GNUstepGUI/GSVbox.h:
	Cleaned up to remove compiler warnings.
	* Source/NSDataLinkPanel.m: Added include of GSGuiPrivate.h to
	remove compiler warning.
	* Source/NSPrintInfo.m: Removed unused global paperSizes.
	* Source/NSScroller.m: (-trackKnob:) Initialise presentEvent.

2004-01-06 23:39  Gregory John Casamento  <greg_casamento@yahoo.com>

	* Source/NSSpellServer.m: Documentation.
	* Headers/AppKit/NSSpellServer.h: Documentation.
	
2004-01-06 21:58  Gregory John Casamento  <greg_casamento@yahoo.com>

	* Source/NSAffineTransform.m: More documentation.
	
2004-01-07 02:51  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSSplitView.m (-mouseDown:): Use an NSDebugLLog when we get
	an event in a subview area instead of an NSLog.

2004-01-04 02:32  Gregory John Casamento  <greg_casamento@yahoo.com>

	* Source/NSApplication.m: Documentation.
	* Source/NSAffineTransform.m: Documentation.
	
2004-01-03 23:36  Gregory John Casamento  <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Removed some uneeded includes.
	
2004-01-03  Ludovic Marcotte <ludovic@Sophos.ca>

        * Source/NSOutlineView.m: Started to fix the DnD code.
	  Modified -mouseDown: to not select the row when clicking
          only on the expand/collapse image. Rewrote
          -noteNumberOfRowsChanged to correctly restore the list
          of selected rows after an expand/collapse operation.
          Also did some general cleanups. More to come on this class.

2004-01-03 19:00  Gregory John Casamento  <greg_casamento@yahoo.com>

	* Source/NSBundleAdditions.m: Removed some uneeded includes.

2004-01-01 23:22  Gregory John Casamento  <greg_casamento@yahoo.com>

	* Source/NSBundleAdditions.m: Moved the declaration of 
	nibitems in loadNibFile:externalNameTable:withZone: so
	that it can be released if there is an exception.
	* Source/NSActionCell.m: Documentation.
	* Source/NSScreen.m: Documentation.
	
2003-12-31 01:07  Alexander Malmberg <alexander@malmberg.org>

	* KeyBindings/DefaultKeyBindings.dict: Uncomment the
	moveUpAndModifySelection: and moveDownAndModifySelection:
	entries.

2003-12-31 00:37  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-setSelectedRange:affinity:stillSelecting:):
	Make sure oldRange is always initialized.

2003-12-30  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBundleAdditions.m (-pathForNibResource:) ignore
	extension "nib", so "gorm" or "gmodel" get used instead.

2003-12-30  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSAffineTransform.h: Corrected element names tX
	and TY of structure NSAffineTransformStruct to fit Cocoa naming.
	* Source/NSAffineTransform.m
	* Source/NSView.m (-_rebuildCoordinates)
	* Source/NSPrintOperation.m (-_displayPageInRect:atPlacement:withInfo:)
	Adopted to change of NSAffineTransformStruct elements.
	* Source/Function.m
	Implemented NSDrawWindowBackground(), NSDrawDarkBezel() and
	NSDrawLightBezel().
	* Source/NSTableHeaderView.m (-drawRect:) Use NSDrawTiledRects()
	instead of DPS operations.

2003-12-30 00:48  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSBundleAdditions.m: Added private class to collect
	top level items (controllers) which are instantiated in the
	.gorm file.  This and the change to GSNibContainer provide a
	much cleaner way of retaining the top level items in the .gorm
	file without requiring a new special entry in the nameTable.
	* Source/GSNibContainer.[hm]: Renamed method awakeWithContext:
	to awakeWithContext:topLevelItems: to allow passing in the
	items collected.  Also added code to add the GSNibItems which
	are in the archive to the instance of the private class which
	is created.
	
2003-12-29 20:43  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: removed extraneous retain in
	GSClassSwapper which was causing the retain counts of
	custom classes to be one too many. 

2003-12-29  Adam Fedor  <fedor@gnu.org>

	* Source/NSApplication.m (-activateIgnoringOtherApps:): Change
	location of _inactive count calculation.

	* Documentation/gnustep-gui.texi: Move class documentation...
	* Headers/Additions/GNUstepGUI/GSHbox.h: ...to here.
	* Headers/Additions/GNUstepGUI/GSTable.h: and here.
	* Headers/Additions/GNUstepGUI/GSVbox.h: and here.

2003-12-28 19:33  Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/AppKit/NSMenuItem.h: Added documentation for many 
	of the methods in NSMenuItem.
	* Source/GSNibTemplates.m: Further refinements on the earlier
	memory leak fix.

2003-12-25 00:03  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSDataLinkPanel.m: Changed to use the correct method
	to find and load the .gorm file for the panel.
	
2003-12-23 13:46  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Added a loop which retains only the
	top level objects in the nameTable.  Also added some conditions
	which prevent some of the special entries in the nametable from
	having awakeFromNib called unnecessarily.  Added code
	which implements the NSTopLevelObjects undocumented feature which
	allows users to get the top level objects in an array so that they
	can be easily released.  Tightened up memory management.
	* Source/NSBundleAdditions.m: Removed extra retain which was 
	causing the container to leak.
	
2003-12-23 18:13  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow.m (-_handleWindowNeedsDisplay:): Disable flushing
	while displaying the window and flush after all displaying is done.

2003-12-06 14:03  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-readSelectionFromPasteboard:type:,
	NSTIFFPboardType): Send -setFileWrapper: to the attachment after
	setting the wrapper's icon to force an update of the attachment's
	image. Reported by Fabien Vallon.

2003-12-03 02:54  Alexander Malmberg <alexander@malmberg.org>

	* Source/GNUmakefile.postamble (after-clean): Add a missing ':'.
	Reported by Matt Rice.

2003-12-02  Adam Fedor  <fedor@gnu.org>

	* Source/GNUmakefile.postamble (libgnustep-gui.def): Generate at   
	compile time using the proper dependencies.

2003-12-01  Serg Stoyan <stoyan@on.com.ua>

	* Headers/AppKit/NSButton.h: Add setHighlightsBy: and 
	setShowsStateBy: methods.
	* Source/NSButton.m: Implement setHighlightsBy: and setShowsStateBy:
	methods
	
	* Source/NSPanel.m:
	Removed TODO about message font size.
	(-sendEvent:): Cast self when compared with iconWindow to omit
	compiler warning.
	(-_initWithoutGModel): Center title vertically relatively to image.
	Some comments added. Use NSButton's setHighlightsBy for default 
	button of altert panel.
	(-sizePanelToFit): Center message text horizontally.

	* Images/common_ret.tiff: Edit to be more NeXTish.
	* Images/common_retH.tiff: Ditto.

2003-11-29  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSWindow.m (+initialize) cache runloop modes. 
	(-_handleWindowNeedsDisplay:) and (-orderWindow:relativeTo:) use cached modes.

2003-11-29  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSCell.m (-setTitleWithMnemonic:) use [setTitle:] instead
	of [setStringValue:].
	(-mnemonic) use [title] instead of [stringValue].

2003-11-28  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBezierPath.m (-bezierPathByReversingPath) return create
	path not self. 
	(-containsPoint) new implementation, that respects the winding rule.

2003-11-26 23:55  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow.m (-sendEvent:): Ignore most events sent to
	windows that have been ordered out.
	* Source/NSPanel.m (-sendEvent:): Synchronize with [NSWindow
	-sendEvent:].

2003-11-26 23:54  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSView.m (-autoscroll:): Document.

2003-11-26 15:00  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSGuiPrivate.h: Fix GSGuiBundle() prototype.

2003-11-26 14:47  Alexander Malmberg <alexander@malmberg.org>

	* Headers/AppKit/NSApplication.h: Add -_windowWillDealloc:.
	* Source/NSApplication.m: Fix some prototypes.
	(-_windowWillDealloc:): Implement.
	* Source/NSWindow.m (-dealloc): Call -_windowWillDealloc: so NSApp
	can clear any unretained references to the window.

2003-11-25 17:16  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow.m (-orderWindow:relativeTo:): Start the window
	auto-display performer when a window is ordered in regardless of
	whether it needs display right now or not.

2003-11-23  Adam Fedor  <fedor@gnu.org>

	* Version 0.9.1

2003-11-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBrowser.m (-tile) corrected computation of columnCount,
	so that at least one column gets diplayed, even when this is
	smaller than the minColumnwidth. 
	* Source/NSMatrix.m (-drawRect:) corrected clipping of row2, here
	row1 had been tested. 
	* Source/NSScrollView.m (-drawRect:) removed the saving of the context.
	
2003-11-22 15:07  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSNibTemplates.m ([GSNibContainer -awakeWithContext:]):
	Don't release connections when enumerating them; they're owned
	by the array. Partial fix for bug #6354.

2003-11-19 21:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-sizeToFit): If we are horizontally resizable
	and the inset width is 0, increase our width by 1.

2003-11-19 17:06  Alexander Malmberg <alexander@malmberg.org>

	* Tools/GNUmakefile, Tools/example.m, Tools/exampleInfo.plist,
	Tools/md5Digest.m: Move example.service and md5Digest.app to
	usr-apps/examples/gui/ExampleService/.

2003-11-19  Adam Fedor  <fedor@gnu.org>

	* Window Focus fixes.
	* Source/NSApplication.m (-activateIgnoringOtherApps:): Make
	hidden_key key only if we have no key, make main key if neither,
	make menu key as last resort.
	(-deactivate): Resign main window.
	(Patches from Benhur Stein <benhur@inf.ufsm.br>).
	(-unhideWithoutActivation): Set hidden=no before ordering windows
	to avoid possible recursive loops.
	* Source/NSWindow.m (-sendEvent:)(NSLeftMouseDown): Activate app
	after ordering window front.	
	(-sendEvent:)(GSAppKitWindowFocusIn): Don't make ourselves key
	if we're not the modal window. Remove check for app isHidden.

2003-11-19 03:17  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSClipView.m (-autoscroll:): Reimplement correctly.

	* Source/NSTextView.m (-mouseDown:): When the mouse is outside
	the view, autoscroll smoothly using periodic events.

2003-11-18 21:43  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSEvent.m (-description): Remove a stray , that was messing
	up a +stringWithFormat: call. Make eventTypes static.

2003-11-11 14:41  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSApplication.m: (-targetForAction:): Added code to check the
	document of the main window as well.
	* NSToolbar.m: Additional implementation.
	* NSWindow.[hm]: Added some code for drawing the toolbar.
	* GSToolbarView.h: added initWithToolbar: method.
	
2003-11-07 15:28  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSControl.m (-mouseDown:): Rewrite to use -setHighlighted:
	and the normal drawing mechanisms instead of trying to draw and flush
	manually. (Fixes a bunch of visual glitches.)

2003-11-07 14:42  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSInputManager.m (-loadBindingsFromFile:): Handle errors
	directly instead of using (broken) exception code.

2003-11-01 18:19  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m (-drawGlyphsForGlyphRange:atPoint:):
	If a range of glyphs has no color set, use the default text color
	(as returned by [NSColor textColor]) instead of assuming black.

2003-10-30 00:38  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSImage.m (iterate_reps_for_types, repd_for_rep): Make
	static.
	* Source/NSStepperCell.m (DrawUpButton, DrawDownButton,
	HighlightUpButton, HighlightDownButton): Idem.

	* Source/NSPrintInfo.m: Make the "class variables" static.
	* Source/NSProgressIndicator.m: Idem.

2003-10-29  Bjorn Giesler <bjoern@giesler.de>

	* Source/externs.m: New MacOS 10.3 pasteboard types
	* Headers/AppKit/NSPasteboard.h: New MacOS 10.3 pasteboard types

2003-10-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSDisplayServer.m: ([-dealloc]) remove deallocated server
	from windowsmap to avoid segfault on app shuytdown ... fix suggested
	by benhur@inf.ufsm.br

2003-10-29 02:22  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSServicesManager.m (-updateServicesMenu): Always enable
	an item with a submenu.

2003-10-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSavePanel.m: Change to have entire window accept DnD.
	* Source/NSWindow.m: Fix to get whole window DnD working, also
	to enable propogation of drag events up the view hierarchy to the
	first drag-aware view ... Adam reports that this seems to be the
	behavior on MacOS-X too.

2003-10-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSOpenPanel.m: Allow users to type in an absolute path name.
	Support DnD of filename into panel.
	* Source/NSSavePanel.m: ditto.  Also, if the name of a non-existent
	directory is typed in, provide a prompt to create the directory as
	in NeXTstep/OPENSTEP.

2003-10-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSServicesManager.m: Tidy last patch to match use of
	whitespace etc in GNUstep code.
	* Source/GSDisplayManager.m:
	(-getEventMatchingMask:beforeDate:inMode:dequeue:) fix incorrect
	termination ... should terminate when limit date has passed,
	irrespective of the state of any input sources.
	* Source/NSApplication.m: ([-runModalForWindow:]) wait for new events
	between calls to ([-runModalSession:])
	([-runModalSession:]) rewritten to handle multiple events, but only
	those events which are available ... ie don't wait for more.
	Requires latest base library from CVS to get modified/corrected
	runloop behavior.

2003-10-26 15:18  Alexander Malmberg <alexander@malmberg.org>
		  Matt Rice <ratmice@yahoo.com>

	* Source/NSFontManager.m (-availableFonts, -availableFontFamilies,
	availableMembersOfFontFamily:): Don't check delegate; always return
	all fonts.
	(-_includeFont:): Move...

	* Source/NSFontPanel.m (_includeFont:delegate:): Here.
	(-_familySelectionChanged:, reloadDefaultFontFamilies): Use that
	method to check with the delegate which fonts should be included in
	the font panel.
	(-_doPreview, -_fontForSelection:): Check that the face list isn't
	empty before accessing it.
	(-_getOriginalSize): Move to the Private category to match the
	@interface.

2003-10-25 16:52  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: initWithFrame is not supposed to be called
	on subclasses of NSControl as the designated initializer according to
	docs.  Removed the call.
	* Source/GSNibCompatibility.[hm]: Added in the old templates for 
	compatibility ONLY.  This is so any of the older .gorms which use 
	these templates can be loaded and used normally.
	* Source/NSOutlineView.m: Corrected a documentation issue.
	
2003-10-25 12:53  Matt Rice <ratmice@yahoo.com>

	* Source/NSWorkspace.m (-_connectApplication:): Ignore the path to
	the application when extracting the port name. (Committed by
	Alexander Malmberg.)

2003-10-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSWorkspace.m: Change a few uses of '/' in strings to
	use stringByAppendingPatchComponent:
	* Tools/gopen.m: Fix to pass the full path of the file to the
	app being used to open it, so relative paths in the arguments
	work properly.

2003-10-21  Bjorn Giesler <bjoern@giesler.de>

	* Source/GSServicesManager.m: Fix NSPerformService() to work for
	any localised service name.

2003-10-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSServicesManager.m: Revert last modification in favour
	of a fix by ... Bjorn.

2003-10-20  Adam Fedor  <fedor@gnu.org>

	* Source/NSApplication.m (-changeWindowsItem:title:filename:): Use
	deminiaturize to get the window back.

	* Source/NSWindow.m (-deminiaturize:): Don't order out
	the miniwindow since it should be ordered out automatically.
	Fixes PR #5849.

2003-10-18  16:48  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSOutlineView.m: Added full gsdoc documentation for this
	class.
	
2003-10-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSServicesManager.m: Make mapping of service names to
	their definitions include all available language variants so
	that NSPerformService() should work irrespective of the
	currently selected language preferences.  Tested to ensure it
	still works for my selected english, but not yet to see if it
	actually fixes the bug.

2003-10-13  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Simplify graphics libs lookup
	* config.make.in: Update.
	
	* Documentation/make_services.1: New file (from Martin Brecher)
	* Documentation/GNUmakefile: Install it.

2003-10-09  Adam Fedor  <fedor@gnu.org>

	* Tools/make_services.m: Add quiet option.

2003-10-07 23:38  Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/Additions/GNUstepGUI/GSNibTemplates.m: Added
	setDeferFlag: and deferFlag declarations to 
	GSWindowTemplate.

2003-10-07 14:32  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow.m (-miniaturize:): Check that the window is
	miniaturizable, visible, and not already miniaturized before
	trying to miniaturize it.
	(-deminiaturize:): Do nothing if the window isn't miniaturized.
	(Based on patch from Matt Rice.)

2003-10-05  Adam Fedor  <fedor@gnu.org>

	* Source/DocMakefile: Remove dependencies file when cleaning.

2003-10-03  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Use -Wl for netbsd linker options.

2003-10-03  Benhur Stein <benhur@inf.ufsm.br>

	* Source/NSWindow.m (-setFrameAutosaveName:): remove previous frame
	name from defaults; if there is a saved frame with the new name in
	defaults, set window frame to it, otherwise store current frame in
	defaults.

2003-10-03  Benhur Stein <benhur@inf.ufsm.br>

	* Source/NSWindow.m (class variables, +initialize,
	+removeFrameUsingName:, -dealloc, -saveFrameUsingName:,
	-setFrameAutosaveName:): removed variable windowsLock

2003-10-02  David Ayers  <d.ayers@inode.at>

	* Source/NSBrowser.m (-[NSBrowser setDelegate]):
	Set _passiveDelegate to YES for 'nil' delegate.  
	Use GSObjCRuntime functions to get selector names.
	Update documentation.

2003-10-02  Andrew Ruder  <aereder@ksu.edu>

	* Source/NSBrowser.m (-[NSBrowser setDelegate]):  Check for
	nil object to allow unsetting the delegate.

2003-09-29  Adam Fedor  <fedor@gnu.org>

	* Version 0.9.0

2003-09-29  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSLayoutManager.h
	* Source/GSLayoutManager.m
	Added missing method [isValidGlyphIndex:].
	
2003-09-29  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBrowser.m
	Patch by Christopher Culver:
	Define empty [sizeToFit] method to override NSControl implementation.
	
2003-09-27 19:29 Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibContainer.m: [GSNibContainer awakeWithContext:]
	Added code to set the services and windows menus as designated in
	Gorm.  Addresses Report #5205
	
2003-09-27  David Ayers  <d.ayers@inode.at>

	* Source/NSCell.m (-compare:):  Compare the stringValue of
	NSCell's rather than their contents directly.

2003-09-23 19:14  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow.m (-orderWindow:relativeTo:): Only force a display
	of the content view if we're being ordered _to_ the screen.

2003-09-23 19:11  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextContainer.m (-dealloc): Set the text container of
	our text view, if any, to nil.

2003-09-22  Adam Fedor  <fedor@gnu.org>

	* Source/NSWindowController.m (-setWindow:):  Set window's
	releaseWhenClosed when document is not nil. Add documentation.

2003-09-21  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPopUpButtonCell.m
	Undid the tracking of changes for the menu item. Changed [dealloc]
	to not call clean up methods as these caused segmentation faults
	in GNUMail.
	
2003-09-21 15:15  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-readSelectionFromPasteboard:type:): Handle
	NSTIFFPboardType. Based on patch from Nicolas Roard.

2003-09-20  Adam Fedor  <fedor@gnu.org>

	* Source/NSWindowController.m ([NSWindowController -setDocument:]): 
	Set window to releaseWhenClosed if document is not nil.
	* Source/NSApplication.m ([NSApplication -targetForAction:]): Revert
	last change.
	* Source/NSWindow.m ([NSWindow -performClose:]): Idem.

2003-09-19  Matt Rice <ratmice@yahoo.com>

	* Source/NSApplication.m ([NSApplication -targetForAction:]): Check
	document of a document-based app before key window.
	* Source/NSWindow.m ([NSWindow -performClose:]): Close the
	document not self if there is a document associated with this window.

2003-09-19  Adam Fedor  <fedor@gnu.org>

	* Headers/Additions/GNUstepGUI/GSMethodTable.h: Change NSReadPixel
	to GSReadRect
	* Headers/AppKit/NSGraphicsContext.h, Source/NSGraphicsContext.m: Idem.
	* Headers/AppKit/NSGraphics.h (NSReadPixel): Move to...
	* Source/Functions.m (NSReadPixel): here.
	* Source/NSBitmapImageRep.m (-initWithFocusedViewRect:): Implement.
	
2003-09-16  Adam Fedor  <fedor@gnu.org>

	* GNUmakefile (SUBPROJECTS): Don't build Documentation by default.

2003-09-14  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPopUpButtonCell.m
	Corrected bug in previous change. In [itemAtIndex:] the index 0
	was handled wrong.
	
2003-09-14  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPopUpButtonCell.m
	According to Gregory John Casamento <greg_casamento@yahoo.com> the
	popup button does not change its enable state when the selected item
	does. To adopt this behaviour all setEnable: calls have been
	removed and one in [initWithCoder:] added that enables the popup
	for all old encodings.
	
2003-09-13  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSPopUpButtonCell.m: Corrected minor problem which 
	was causing a compilation error.

2003-09-13  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenu.m
	In [update] use [NSApplication targetForAction:to:from:] to be
	consistent with the [performActionForItemAtIndex:] implementation.
	* Source/NSPopUpButtonCell.m
	Undid last change. Rewrote [setMenu:] to make the popup button
	cell listen to change notifications of the menu. New method
	[itemChanged:] gets called when a menu item changes. Added hack to
	[initWithCoder:] to set menu correctly and read old menu items 
	correctly.
	Check in [itemAtIndex:] that the index is vaild and return nil
	otherwise.
	
2003-09-07  Adam Fedor  <fedor@gnu.org>

	* Source/NSBitmapImageRep.m: Document.
	(+imageRepWithData:): Return empty array not nil on failure.
	(-TIFFRepresentation): Check for unsupported compression types.
	(-TIFFRepresentationUsingCompression:factor:): Idem.
	* Source/tiff.m (NSTiffGetInfo, NSTiffRead,
	NSTiffWrite): Better error checking.

	* Source/NSTableView.m (-draggingUpdated:sender): Support
	NSTableViewDropOn (patch from Björn Giesler <giesler@ira.uka.de>).

2003-09-06  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSPopUpButtonCell.m: -drawInteriorWithFrame:inView:
	added setEnabled to enable the popup button cell.  A previous
	change was causing all popup button cells to show up as disabled.

2003-09-06 22:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSFont.m (getNSFont): Set the explicit-size bit in the
	role correctly.

2003-09-06  Gregory John Casamento <greg_casamento@yahoo.com>

	* Images/common_Printer.tiff 
	* Images/common_ToolbarSeperatorItem.tiff
	* Images/common_ToolbarShowColorsItem.tiff 
	* Images/common_ToolbarShowFontsItem.tiff
	* Images/common_ToolbarSpaceItem.tiff 
	* Source/NSToolbarItem.m: set the correct images and
	target/action information for all of the standard toolbar items.

2003-09-06  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenuItem.m
	Autorelease the [separatorItem].
	
2003-09-06  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenuView.m
	In [itemChanged:] set if the cell is enabled like the item.
	* Source/NSMenuItemCell.m
	[setMenuItem:] enable/disable cell. [drawTitleWithFrame:inView:]no
	longer enable/disable cell.
	
2003-09-04 18:43  Alexander Malmberg <alexander@malmberg.org>

	* Headers/AppKit/NSWindow.h, Source/NSWindow.m: Change the return
	type of	-initWithWindowRef: to id.

2003-09-02  Adam Fedor  <fedor@gnu.org>

	* Tools/gsnd/gsnd.m (main): Don't mess with file descriptors on MinGW.

2003-09-02  Adam Fedor  <fedor@gnu.org>

	* Source/libgnustep-gui.def: Update.

2003-09-01  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSAttributedString.m
	[readFromURL:options:documentAttributes:] corrected the handling
	to type "text", where [NSString alloc] was missing.
	* Source/NSBundleAdditions.m
	Removed unused global currentVersion.
	* Headers/AppKit/NSCell.h
	Corrected type of method _nonAutoreleasedTypingAttributes
	* Headers/AppKit/NSInputManager.h
	Added protocol NSTextInput to ivar _currentClient.
	* Headers/AppKit/NSTextFieldCell.h
	Removed uneeded and inconsistent method declarations.
	* Source/NSApplciation.m
	* Source/NSBezierPath.m
	* Source/NSClipView.m
	* Source/NSDocumentController.m
	* Source/NSInputManager.m
	* Source/NSMenuItem.m
	* Source/NSSavePanel.m
	* Source/NSTableView.m
	Removed new GCC 3.4 warnings from Alexander Malmbergs list.
	
2003-09-01  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBitmapImageRep.m
	[canInitWithData:], [imageRepsWithData:] and [initWithData:]
	protect against data being nil. [imageRepsWithFile:] check if the
	file exists and only return an array when it contains objects.
	* Source/NSWorkspace.m
	New method [_saveImageFor:] used in all places in this file where
	an icon is created from a file name. New method
	[thumbnailForFile:] calculated the name of the corresponding
	FreeDeskTop.org thumbnail file for a given file name. This does
	not chack if this file exists!. In [iconForFile:] use this
	thumbnails if the user default GSUseFreedesktopThumbnails is YES.
	* Documentation/GuiUser/DefaultsSummary.gsdoc
	Documented the new user default value GSUseFreedesktopThumbnails.
	
2003-09-01  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: [GSNibContainer awakeWithContext:]
	was initializing mainMenu too late.   It should be accessible
	from within awakeFromNib.

2003-08-31  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSToolbarItem.m: Corrected code to instantiate
	button for toolbar items.

2003-08-30  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: [GSNibContainer awakeWithContext:]
	was not releasing the connections in the array after calling
	establishConnection.   Once this is done, the connections
	are no longer needed.

2003-08-30  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSWindowController.m
	Changed [setWindow:] to manage the notification connection to the
	window.
	[initWithWindow:], [dealloc] and [_windowWillClose:] now use
	[setWindow:].
	[setDocument:] now no longer retains the document, as this is
	already retaining the window controller. Simplified [loadWindow]
	by using the method [windowNibPath].
	
2003-08-30  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Added code to templates to conditionally
	call the designated initializer if and only if it is defined
	on the class which is being unarchived, not the parent classes.
	This is consistent with behaviour under OpenStep.

2003-08-29  Adam Fedor  <fedor@gnu.org>

	* Source/GNUmakefile.preamble (ADDITIONAL_OBJCFLAGS): Include
	target dir for config.h (disable-flattened).

2003-08-29  Adam Fedor  <fedor@gnu.org>

	* Tools/gsnd/gsnd.m (main): Reopen stderr.

2003-08-29  Gregory John Casamento <greg_casamento@yahoo.com>

	* NSToolbarItem.[hm]: Implemented copyWithZone: for NSCopying,
	removed an unused flag and shortened the flag names which were
	somewhat long.  Did some general cleanup.  Implemented standard
	items.
	
2003-08-28  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.m: Removed an extra release which was causing
	a segfault.  Added code to prevent calling the designated initializer
	when isInterfaceBuilder is defined.

2003-08-27  Adam Fedor  <fedor@gnu.org>

	* Tools/gsnd/gsnd.m (main): Set daemon flag when forking.

2003-08-26  Adam Fedor  <fedor@gnu.org>

	* Version 0.8.9

2003-08-23  Gregory John Casamento <greg_casamento@yahoo.com>

	* GSNibTemplates.m: Minor corrections and bugfixes.

2003-08-23  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GNUmakefile: Added new header to the list.
	* Source/GSNibTemplates.m: Added assertion to GSClassSwapper to 
	prevent it from being initialized with superClassName and className
	being the same.
	* Source/NSToolbar.m: Added some more code to properly implement 
	this class.
	* Source/NSToolbarItem.m: Added code to implement this class.
	* Headers/AppKit/NSToolbar.h: Added flags declaration.
	* Headers/AppKit/NSToolbarItem.h: Added attributes.
	* Headers/Additions/GNUStepGUI/GSToolbarView.h: Private class which
	will be used to display the toolbar in the window.
	
2003-08-22  Adam Fedor  <fedor@gnu.org>

	* Tools/gsnd/gsnd.m (main): Close any open file descriptors so
	we can be a proper daemon.
	Fixes #4825

2003-08-22  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/GSNibTemplates.[hm]: Added new template classes to a new file
	removed old templates and implemented GSClassSwapper, GSWindowTemplate,
	GSViewTemplate and etc.. to act as stand-in object in the 
	interface builder application.
	* NSBundleAdditions.m: Removed old template classes and moved some
	of the hiddle classes to GSNibTemplates for better organization.

2003-08-20  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSWindow.m
	In [performClose:] call the method [shouldCloseWindowController:]
	on the document instead of [windowShouldClose:]
	
2003-08-20  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenuView.m
	In [itemChanged:] call [setNeedsDisplayForItemAtIndex:] so that
	changes get redisplayed.
	* Source/NSPopUpButtonCell.m
	Overall change to use method calls rather than direct ivar access.
	[setMenu:] also call [setMenuView:]. [removeItemWithTitle],
	[removeItemAtIndex] and [removeAllItems] make sure that the
	selected item ivar gets unset, when this is
	removed. [setMenuItem:] overwrite super method to set/unset the
	image. [selectItem:] no longer changes the image of this
	item. [synchronizeTitleAndSelectedItem] now works on the menu item
	not the selected item. [attachPopUpWithFrame:inView:] added
	listening for notifications. [dismissPopUp] remove listening for
	notifications. Added [performClickWithFrame:inView:] and
	[performClick:]. Further simplified [drawInteriorWithFrame:inView:].
	[initWithCoder:] made sure that old stored objects still get read
	in correctly even if most ivars may be set wrong.
	* Source/NSPopUpButton.m
	In [keyDown:] removed setting and unsetting of notification
	listening, as this now gets handled in NSPopUpButtonCell.
	
2003-08-20 14:36  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSFontInfo.m (+sharedEnumerator,
	+fontInfoForFontName:matrix:screenFont:): Assert that the backend
	classes have been set.

	* Source/NSBrowser.m (+initialize, -initWithFrame:): Don't create
	the shared title cell in +initialize. Creating the cell requires
	that the backend has been set up (by creating the shared application
	object). We can't assume that this has been done before +initialize
	is called.

	* Source/NSTextView.m (+initialize, -initWithFrame:textContainer:):
	Don't register for services in +initialize for the same reason: the
	shared application object might not have been created yet (also, note
	that calling +sharedApplication is unsafe; it will create a shared
	application object, but in some cases of the wrong class, which would
	lead to confusing errors later).

2003-08-20 14:08  Alexander Malmberg <alexander@malmberg.org>

	Clean up code to remove warnings issued by (what will become)
	gcc 3.4.

	* Model/GMArchiver.m, Source/GSFusedSilica.m,
	Source/GSFusedSilicaContext.m, Source/NSResponder.m: Don't return
	values from methods returning void.

2003-08-19  Adam Fedor  <fedor@gnu.org>

	* Source/NSImageRep.m ([NSImageRep +imageRepsWithContentsOfFile:]): 
	Make sure extension is lowercase.
	Fixes #4750.

2003-08-18  Adam Fedor  <fedor@gnu.org>

	* Model/GNUmakefile (ADDITIONAL_INCLUDE_DIRS): Don't include
	../Headers on non-gnu targets.

2003-08-17  Adam Fedor  <fedor@gnu.org>

	* Source/NSTableView.m ([NSTableView -textDidBeginEditing:]): Fix leak
	of dictionary object.
	([NSTableView -textDidChange:]): Idem.
	([NSTableView -textDidEndEditing:]): Idem.
	Fixes #4568.

2003-08-17  Adam Fedor  <fedor@gnu.org>
	
	* Source/NSImageCell.m ([NSImageCell -setObjectValue:]): Implement.

2003-08-17 Benhur Stein <benhur@inf.ufsm.br>
	* NSBrowser.m:
	(-selectRow:inColumn:): cleanup
	(-loadedCellAtRow:column:): cleanup
	(-matrixInColumn:): return nil if column not in _browserColumns
	(-setPath:): cleanup; fix optimization for not loading columns that
	are already loaded
	(-setLastColumn:): return if column is not loaded; remove unnecessary
	call to setNeedsDisplay:; remove columns greater than
	_lastVisibleColumn instead of numberOfVisibleColumns; call
	scrollColumnToVisible instead of making it by hand.
	(-reloadColumn:): reselect previously selected cells by searching them
	in reloaded matrix, instead of by position
	(-scrollColumnToVisible:): removed test that assumed that if
	numberOfVisibleColums is enough to display all loaded columns, they
	are all displayed. This is not always the case now.
	(-tile): hack to garantee that all visible columns exist. Should fix 
	 the code that's before instead.
	(-doClick:): cleanup; removed drawing of matrix's cells
	(-moveLeft:): cleanup; move left from firstResponder instead of from
	selectedColumn
	(-moveRight:): cleanup; move right from firstResponder instead of from
	selectedColumn; removed call to doClick:
	(-_performLoadOfColumn:): change _lastColumnLoaded if necessary    

2003-08-16  Matt Rice <ratmice@yahoo.com>

	* Source/NSDocument.m ([NSDocument -init]): Check the count of the
	types array and uses Viewer and Editor NSRoles to set the default
	type.

2003-08-13  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/gui/*.h/*.h.in: Remove headers moved in header
	reorganization on 2003-07-31.
	* Headers/Additions/GNUstepGUI/GSVersion.h: Remove generated
	file that should have been ignored by entry in .cvsignore.
	
2003-08-05  Martin Brecher <martin@mb-itconsulting.com>

	* Documentation/gopen.1: New file.
	* Documentation/GNUmakefile: Install it.

2003-08-10 23:27  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Additions/GNUstepGUI/GSFontInfo.h: Add new methods in
	GSFontEnumerator that return the default names of some standard
	fonts.

	* Source/GSFontInfo.m: Implement them.

	* Source/NSFont.m: Use them.

2003-08-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/GNUmakefile.postamble: Invoke Source/DocMakefile to
	clean reference documentation.

2003-08-02  Ludovic Marcotte <ludovic@Sophos.ca>

	* Modified NSPopUpButtonCell: -insertItemWithTitle: atIndex:
	  so that we get our item count after removing a potential
	  duplicated item value.


2003-08-01  Adam Fedor  <fedor@gnu.org>

	* Documentation/GNUmakefile.postamble (after-install): Install
	gsdoc docs in proper places.
	* Source/DocMakefile: Add GuiUser DOCUMENT

	* Images/GNUmakefile: Remove obsolete files.

2003-07-31  David Ayers  <d.ayers@inode.at>

	* Created tag 'pre-header-reorg-20030731'.
	
	* Headers/Additions/GNUstepGUI: New directory.
	* Headers/AppKit: Ditto.
	* Headers/gnustep/gui: Obsoleted.

	* Headers/Additions/GNUstepGUI/GMAppKit.h: Moved here from
	Headers/gnustep/gui.
	* Headers/Additions/GNUstepGUI/GMArchiver.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSDisplayServer.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSFontInfo.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSFusedSilica.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSHbox.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSHelpManagerPanel.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSHorizontalTypesetter.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSInfoPanel.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSLayoutManager.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSLayoutManager_internal.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSMemoryPanel.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSMethodTable.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSNibTemplates.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSPasteboardServer.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSServicesManager.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSTable.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSTextConverter.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSTrackingRect.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSTypesetter.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSVbox.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSVersion.h: Ditto.
	* Headers/Additions/GNUstepGUI/GSVersion.h.in: Ditto.
	* Headers/Additions/GNUstepGUI/IMConnectors.h: Ditto.
	* Headers/Additions/GNUstepGUI/IMCustomObject.h: Ditto.
	* Headers/Additions/GNUstepGUI/IMLoading.h: Ditto.
	* Headers/Additions/GNUstepGUI/.cvsignore: Ditto.

	* Headers/AppKit/AppKit.h: Ditto.
	* Headers/AppKit/AppKitDefines.h: Ditto.
	* Headers/AppKit/AppKitExceptions.h: Ditto.
	* Headers/AppKit/DPSOperators.h: Ditto.
	* Headers/AppKit/NSActionCell.h: Ditto.
	* Headers/AppKit/NSAffineTransform.h: Ditto.
	* Headers/AppKit/NSApplication.h: Ditto.
	* Headers/AppKit/NSAttributedString.h: Ditto.
	* Headers/AppKit/NSBezierPath.h: Ditto.
	* Headers/AppKit/NSBitmapImageRep.h: Ditto.
	* Headers/AppKit/NSBox.h: Ditto.
	* Headers/AppKit/NSBrowser.h: Ditto.
	* Headers/AppKit/NSBrowserCell.h: Ditto.
	* Headers/AppKit/NSButton.h: Ditto.
	* Headers/AppKit/NSButtonCell.h: Ditto.
	* Headers/AppKit/NSCachedImageRep.h: Ditto.
	* Headers/AppKit/NSCell.h: Ditto.
	* Headers/AppKit/NSClipView.h: Ditto.
	* Headers/AppKit/NSColor.h: Ditto.
	* Headers/AppKit/NSColorList.h: Ditto.
	* Headers/AppKit/NSColorPanel.h: Ditto.
	* Headers/AppKit/NSColorPicker.h: Ditto.
	* Headers/AppKit/NSColorPicking.h: Ditto.
	* Headers/AppKit/NSColorWell.h: Ditto.
	* Headers/AppKit/NSComboBox.h: Ditto.
	* Headers/AppKit/NSComboBoxCell.h: Ditto.
	* Headers/AppKit/NSControl.h: Ditto.
	* Headers/AppKit/NSCursor.h: Ditto.
	* Headers/AppKit/NSCustomImageRep.h: Ditto.
	* Headers/AppKit/NSDataLink.h: Ditto.
	* Headers/AppKit/NSDataLinkManager.h: Ditto.
	* Headers/AppKit/NSDataLinkPanel.h: Ditto.
	* Headers/AppKit/NSDocument.h: Ditto.
	* Headers/AppKit/NSDocumentController.h: Ditto.
	* Headers/AppKit/NSDocumentFrameworkPrivate.h: Ditto.
	* Headers/AppKit/NSDragging.h: Ditto.
	* Headers/AppKit/NSDrawer.h: Ditto.
	* Headers/AppKit/NSEPSImageRep.h: Ditto.
	* Headers/AppKit/NSEvent.h: Ditto.
	* Headers/AppKit/NSFileWrapper.h: Ditto.
	* Headers/AppKit/NSFont.h: Ditto.
	* Headers/AppKit/NSFontManager.h: Ditto.
	* Headers/AppKit/NSFontPanel.h: Ditto.
	* Headers/AppKit/NSForm.h: Ditto.
	* Headers/AppKit/NSFormCell.h: Ditto.
	* Headers/AppKit/NSGraphics.h: Ditto.
	* Headers/AppKit/NSGraphicsContext.h: Ditto.
	* Headers/AppKit/NSHelpManager.h: Ditto.
	* Headers/AppKit/NSHelpPanel.h: Ditto.
	* Headers/AppKit/NSImage.h: Ditto.
	* Headers/AppKit/NSImageCell.h: Ditto.
	* Headers/AppKit/NSImageRep.h: Ditto.
	* Headers/AppKit/NSImageView.h: Ditto.
	* Headers/AppKit/NSInputManager.h: Ditto.
	* Headers/AppKit/NSInputServer.h: Ditto.
	* Headers/AppKit/NSInterfaceStyle.h: Ditto.
	* Headers/AppKit/NSLayoutManager.h: Ditto.
	* Headers/AppKit/NSMatrix.h: Ditto.
	* Headers/AppKit/NSMenu.h: Ditto.
	* Headers/AppKit/NSMenuItem.h: Ditto.
	* Headers/AppKit/NSMenuItemCell.h: Ditto.
	* Headers/AppKit/NSMenuView.h: Ditto.
	* Headers/AppKit/NSNibConnector.h: Ditto.
	* Headers/AppKit/NSNibDeclarations.h: Ditto.
	* Headers/AppKit/NSNibLoading.h: Ditto.
	* Headers/AppKit/NSOpenGL.h: Ditto.
	* Headers/AppKit/NSOpenGLView.h: Ditto.
	* Headers/AppKit/NSOpenPanel.h: Ditto.
	* Headers/AppKit/NSOutlineView.h: Ditto.
	* Headers/AppKit/NSPageLayout.h: Ditto.
	* Headers/AppKit/NSPanel.h: Ditto.
	* Headers/AppKit/NSParagraphStyle.h: Ditto.
	* Headers/AppKit/NSPasteboard.h: Ditto.
	* Headers/AppKit/NSPopUpButton.h: Ditto.
	* Headers/AppKit/NSPopUpButtonCell.h: Ditto.
	* Headers/AppKit/NSPrintInfo.h: Ditto.
	* Headers/AppKit/NSPrintOperation.h: Ditto.
	* Headers/AppKit/NSPrintPanel.h: Ditto.
	* Headers/AppKit/NSPrinter.h: Ditto.
	* Headers/AppKit/NSProgressIndicator.h: Ditto.
	* Headers/AppKit/NSResponder.h: Ditto.
	* Headers/AppKit/NSRulerMarker.h: Ditto.
	* Headers/AppKit/NSRulerView.h: Ditto.
	* Headers/AppKit/NSSavePanel.h: Ditto.
	* Headers/AppKit/NSScreen.h: Ditto.
	* Headers/AppKit/NSScrollView.h: Ditto.
	* Headers/AppKit/NSScroller.h: Ditto.
	* Headers/AppKit/NSSecureTextField.h: Ditto.
	* Headers/AppKit/NSSelection.h: Ditto.
	* Headers/AppKit/NSSlider.h: Ditto.
	* Headers/AppKit/NSSliderCell.h: Ditto.
	* Headers/AppKit/NSSound.h: Ditto.
	* Headers/AppKit/NSSpellChecker.h: Ditto.
	* Headers/AppKit/NSSpellProtocol.h: Ditto.
	* Headers/AppKit/NSSpellServer.h: Ditto.
	* Headers/AppKit/NSSplitView.h: Ditto.
	* Headers/AppKit/NSStepper.h: Ditto.
	* Headers/AppKit/NSStepperCell.h: Ditto.
	* Headers/AppKit/NSStringDrawing.h: Ditto.
	* Headers/AppKit/NSTabView.h: Ditto.
	* Headers/AppKit/NSTabViewItem.h: Ditto.
	* Headers/AppKit/NSTableColumn.h: Ditto.
	* Headers/AppKit/NSTable* HeaderCell.h: Ditto.
	* Headers/AppKit/NSTable* HeaderView.h: Ditto.
	* Headers/AppKit/NSTableView.h: Ditto.
	* Headers/AppKit/NSText.h: Ditto.
	* Headers/AppKit/NSTextAttachment.h: Ditto.
	* Headers/AppKit/NSTextContainer.h: Ditto.
	* Headers/AppKit/NSTextField.h: Ditto.
	* Headers/AppKit/NSTextFieldCell.h: Ditto.
	* Headers/AppKit/NSTextStorage.h: Ditto.
	* Headers/AppKit/NSTextView.h: Ditto.
	* Headers/AppKit/NSToolbar.h: Ditto.
	* Headers/AppKit/NSToolbarItem.h: Ditto.
	* Headers/AppKit/NSUserInterfaceValidation.h: Ditto.
	* Headers/AppKit/NSView.h: Ditto.
	* Headers/AppKit/NSWindow.h: Ditto.
	* Headers/AppKit/NSWindowController.h: Ditto.
	* Headers/AppKit/NSWorkspace.h: Ditto.
	* Headers/AppKit/PSOperators.h: Ditto.

	* configure.ac: Update to new header structure.
	* configure: Regenerated.
	* GNUmakefile.postamble: Remove handling of header-links and
	update to new header structure.

	* Source/GNUmakefile: Update to new header structure.
	Install gnustep specific headers in GNUstepGUI by splitting
	libgnustep-gui_HEADER_FILES into APPKIT_HEADERS and GUI_HEADERS.
	Include CompatibilityHeaders.make makefile fragement.

	* Source/GNUmakefile.preamble: Update to new header structure.
	* Source/CompatibilityHeaders.make: New file which installs dummy
	headers in the place of the old headers, warning about obsoleting
	the old location and includeing the header from its new location.
	
	* Source/GNUmakefile.postamble: Install AppKit Headers manually.
	* Source/*.[hm]: Update includes for new header structure.
	* Source/GSGuiPrivate.h: Moved here from Headers/gnustep/gui.
	* Source/GSFusedSilica.h: Ditto.
	* Source/nsimage-tiff.h: Ditto.

	* Tools/GNUmakefile.preamble: Update to new header structure.
	* Tools/example.m: Remove include of config.h.
	
	* ColorPickers/GNUmakefile: Update to new header structure.
	* ColorPickers/*.[hm]: Ditto.

	* TextConverters/RTF/GNUmakefile.preamble: Update to new header
	structure.
	* TextConverters/RTF/*.[hm]: Ditto.

	* Documentation/gnustep-gui.texi: Update to new header structure.
	* Documentation/Gui/Gui.gsdoc: Remmove gnustep additions.
	* Documentation/GuiAdditions/.cvsignore: New file.
	* Documentation/GuiAdditions/GNUmakefile: Ditto.
	* Documentation/GuiAdditions/GuiAdditions.gsdoc: Ditto.

	* Model/GNUmakefile: Update to new header structure.
	* GNUmakefile.postamble: Ditto.
	* Model/*.[hm]: Ditto.

	* Resources/GNUmakefile: Update to new header structure.

	* Source/DocMakefile: Update to new header structure.
	Added GuiAdditions to DOCUMENT_NAME. 
	Split AUTOGSDOC_HEADERS into AUTOGSDOC_HEADERS_GUI and
	AUTOGSDOC_HEADERS_GUIADD.
	
	
2003-07-31  Michael Hanni  <mhanni@yahoo.com>

        * Source/NSBrowserCell.m (drawInteriorWithFrame:inView:): Remove
        unnecessary code to set the background of an image.
        * Source/NSButtonCell.m: ditto.
        * Source/NSMenuItemCell.m: remove usage of system image
        "common_3DArrowRightH" as it is unneeded.
        (drawImageWithFrame:inView:): remove unnecessary code to set the
        background of an image.
        (drawKeyEquivalentWithFrame:inView:): ditto.
        (drawStateImageWithFrame:inView:): ditto.
        * Source/NSScroller.m: remove usage of system images
        (common_ArrowUpH, common_ArrowDownH, common_ArrowLeftH,
        common_ArrowRightH) as they are unnecessary.
        (drawParts): reset HighlightsBy: code for all the cells, remove
        all the alternate images.
        * Source/NSTableHeaderCell.m (drawInteriorWithFrame:inView:):
        remove unnecessary call to set the background of an image.
        * Images/(common_ArrowUpH, common_ArrowDownH, common_ArrowLeftH,
        common_ArrowRightH).tiff: removed.

2003-07-31  Yen-Ju Chen <yjchenx@hotmail.com>

	* Documentation/Gui/LanguageSetup.gsdoc: Updated.

2003-07-27 17:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSColor.m (+colorFromString:):	Use NSScanner instead of
	sscanf to avoid problems on non-c locales.

	(initSystemColors): Make the creation of the system color list
	more robust. If entries are missing, add them.

2003-07-26 18:50  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSView.m, Source/NSWindow.m: Make drawing debug logging
	more detailed.

2003-07-26  Fred Kiefer <FredKiefer@gmx.de>

	* Panel/English.proj/GSPageLayout.gorm/objects.gorm
	* Panel/English.proj/GSPrintPanel.gorm/objects.gorm
	Made all buttons non-continuous.
	
2003-07-26  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/NSTableView.h
	Added new ivar _action.
	* Source/NSTableView.m
	Implemented methods [action] and [setAction:].
	
2003-07-26  Fred Kiefer <FredKiefer@gmx.de>

	* Tools/gopen.m 
	The option -a no longer starts the provided applciation
	directly, but uses this application to open the specified files.
	
2003-07-26  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSColorPicker.m
	Autorelease image returned by [provideNewButtonImage].
	* Source/NSColorPanel.m
	* ColorPickers/GSStandardColorPicker.m
	In [_setupPickers] release cell array.
	* ColorPickers/GSNamedColorPicker.m
	Now basically working.
	* ColorPickers/GSNamedColorPicker.tiff
	Removed background of image.
	* ColorPickers/GNUmakefile
	Activate GSNamedColorPicker.
	
2003-07-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSApplication.m: Use NSInvocation to perform actions, so
	we can handle cases where the action method returns a non-id or
        misses an argument.
	* Source/NSResponder.m: ditto

2003-07-26  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSImage.m
	In [initWithIconHandle:] and [initWithBitmapHandle:] release the
	new bitmap image representation after adding it to the array.
	* Source/NSBitmapImageRep.m
	In [_initFromTIFFImage:number:] free the info returned by
	NSTiffGetInfo(). 
	* Source/NSTableView.m
	In [sizeToFit] free isResizable.
	* Source/GSMemoryPanel.m
	In [update:] free the list returned by GSDebugAllocationClassList().

2003-07-24  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Fix setting ADDITIONAL_INCLUDE_... in
	audiofile section.

2003-07-23  Gregory John Casamento <greg_casamento@yahoo.com>

	* Panels/GSSpellPanel.gorm: Added to replace old .gmodel
	* Source/NSSpellChecker.m: Updated to use .gorm file.
	
2003-07-23  Adam Fedor  <fedor@gnu.org>

	* Version 0.8.8

2003-07-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/DocMakefile: only remove directory containing 'stamp' for
	clean.

2003-07-23 22:23  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSResponder.h: Make _menu private.

	* Headers/gnustep/gui/NSMenuView.h: Add _attachedMenu ivar.
	* Source/NSMenuView.m: Use it.

2003-07-22  Adam Fedor  <fedor@gnu.org>

	* Source/NSOpenGLView.m ([NSOpenGLView -initWithFrame:]): Implemented
	(Patch from Damien Genet).

2003-07-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/GNUmakefile.postamble: Tweak for make update.
	* Source/DocMakefile: ditto
	* Headers/gnustep/gui/NSLayoutManager.h: documentation tweaks.
	* Headers/gnustep/gui/NSRulerMarker.h: ditto
	* Headers/gnustep/gui/NSText.h: ditto
	* Headers/gnustep/gui/NSTextContainer.h: ditto
	* Source/NSLayoutManager.m: ditto
	* Source/NSPopUpButtonCell.m: ditto
	* Source/NSTextContainer.m: ditto
	* Source/NSWorkspace.m: ditto
	* Source/NSFont.m: ditto
	* Source/NSOpenPanel.m: ditto
	* Source/NSPasteboard.m: ditto
	* Source/NSView.m: ditto
	* Source/NSBezierPath.m: ditto
	* Source/NSGraphicsContext.m: ditto
	* Headers/gnustep/gui/NSBezierPath.h: ditto
	* Headers/gnustep/gui/NSMenu.h: ditto

2003-07-22  Andrew Ruder <aeruder@ksu.edu>

	* Source/NSWindow.m: Fix potential (unlikely) leak
	* Source/NSCursor.m: Fix memory leak;
	* Source/NSResponder.m: Fix memory leak;
	* Source/NSPrintPanel.m: Fix memory leak;

2003-07-21  Kazunobu Kuriyama <kazunobu.kuriyama@nifty.com>

	* Documentation/Gui/LanguageSetup.gsdoc: Update.

2003-07-21  Andrew Ruder <aeruder@ksu.edu>

	* Source/NSBundleAdditions.m: Fix memory leaks.

2003-07-21  Andrew Ruder <aeruder@ksu.edu>

	* Source/GSMemoryPanel.m: Add dealloc method
	* Source/NSOutlineView.m: Efficiency tweak.
	* Headers/AppKit/NSComboBoxCell.h:Fix misplaced semicolon 
	* Source/NSSelection.m: Fix memory leak
	* Source/NSComboBoxCell.m: Fix misplaced semicolon.
	* Source/NSPageLayout.m: Fix memory leak.
	* Source/NSMenuView.m: Fix memory leak.
	* Source/NSToolbar.m: Fix memory leak and tidy
	* Source/GSServicesManager.m: Clarify retain/release of timer.

2003-07-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileWrapper.m: Tidy initialisation and fix leak in
	dealloc.
	* Source/NSTextAttachment.m: ditto.
	* Source/NSGraphicsContext.m: Memory leak fixes (suggested by Andrew
	Ruder) and initialisation tidyups.
	* Source/NSInputManager.m: ditto
	* Source/NSOpenPanel.m: ditto
	* Source/NSDocument.m: minor tidyup in init and add some documentation
	* Source/NSDocumentController.m: add some documentation

2003-07-19  Adam Fedor  <fedor@gnu.org>

	* GNUmakefile: Build Documentation if doc=yes (yes by default).

	* Tools/gsnd/GNUmakefile.postamble: Linke in pthreads if not
	already linked in (non-mingw targets only).
	* Tools/gsnd/portaudio/pa_unix_oss/pa_unix_oss.c: On OpenBSD
	include soundcard.h.

	* Panels/English.proj: Replace GSPageLayout.gorm and 
	GSPrintPanel.gorm with updated GOrm dirs. Make Options button 
	non-continuous.
	* Panels/GNUmakefile.postamble (after-install): Install the
	gorm dirs.

2003-07-19  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPopUpButtonCell.m
	Added methods [init], [objectValue], [setObjectValue:],
	[setImage:]. In [initTextCell:pullsDown:] create the menu first,
	so that the first item gets entered to it. In [setPullsDown:] and
	[setAltersStateOfSelectedItem] set the values that depend on these
	flags. In [insertItemWithTitle:atIndex:] remove duplicates. 
	[selectItem:] the used image now depends on the arrow
	position. Removed [drawWithFrame:inView:] and rewrote
	[drawInteriorWithFrame:inView:].
	
2003-07-18  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/NSControl.h
	* Source/NSControl.m
	New MacOSX methods [formatter], [setFormatter:],
	[attributedStringValue], [setAttributedStringValue:].
	
2003-07-16  Adam Fedor  <fedor@gnu.org>

	* Documentation/Gui/LanguageSetup.gsdoc: Updated with changes from
	Yen-Ju Chen and (Kazunobu Kuriyama.)

2003-07-16  Fred Kiefer <FredKiefer@gmx.de>

	* TextConverters/RTF/rtfGrammer.y
	Free the name for RTFOtherStatement.
	* TextConverters/RTF/rtfGrammer.tab.c
	Regenerated.

2003-07-15  Fred Kiefer <FredKiefer@gmx.de>

	* TextConverters/RTF/RTFConsumerFunctions.h
	Added function GSRTFunicode().
	* TextConverters/RTF/RTFConsumer.m
	Added method [RTFConsumer appendString:] with code coming from
	GSRTFmangleText(). Use this in GSRTFmangleText() and new function
	GSRTFunicode(). Corrected GSRTFmangleText() to convert the input
	from NSISOLatin1StringEncoding, as this is what our current RTF
	exporter produces.
	* TextConverters/RTF/rtfScanner.c
	Define RTFunichar token.
	* TextConverters/RTF/rtfGrammer.y
	Added rule to read unicode character from RTF input.
	* TextConverters/RTF/rtfGrammer.tab.c
	* TextConverters/RTF/rtfGrammer.tab.h
	Regenerated.

2003-07-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/gui/GSServicesManager.h: removed a function
	* Headers/gnustep/gui/NSApplication.h: and added it here so it's
	public.  Also fixed some argument name missmatches.
	* Source/GSServicesManager.m: Some fixes for recent changes to
	DO in base library ... also make listener even safer.
	* Source/NSPasteboard.m: Improve documentation and change pasteboards
	to always be sent over DO bycopy.
	* Tools/example.m: Set error response to nil when there is no error.

2003-07-12 18:20  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSTextView.h, Source/NSTextView.m: Add
	-_updateInputMethodState and -_updateInputMethodWithInsertionPoint:
	methods. Call them in suitable places. Minor cleanups in comments.

2003-07-12 Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSMatrix.m: -[NSMatrix keyCell] failed to check if the
	_cells array is initialized before accessing it.  This was causing
	a core dump when unarchiving.

2003-07-10 03:37  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSStringDrawing.m, Source/NSTextView.m: Adjust "really large"
	sizes to ensure accuracy to a whole point.

2003-07-10 Benhur Stein <benhur@inf.ufsm.br>

	* Source/NSSavePanel.m: added new private method
	_compareFilename:with:. Use it in _selectCellName:.
	In [-browser:createRowsForColumn:inMatrix:]: use self as context to
	sortedArrayUsingFunction:context:
	* Source/NSOpenPanel.m (-_selectCellName:): use new [NSSavePanel
	_compareFilename:with:] method.
	* This fixes bug #4255

2003-07-05  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Add openbsd flags like freebsd.

	* Documentation/Gui/DefaultsSummary.gsdoc: Move backend defaults
	to back/Documentation/Back/DefaultsSummary.gsdoc.

2003-07-05 18:02  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m
	(-textStorage:edited:range:changeInLength:invalidatedRange:): Improve
	behavior of the adjustments to the selected range.

2003-07-05 17:20  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSAttributedString.m (-fixParagraphStyleAttributeInRange:):
	Handle paragraphs with a paragraph style set for a part of it but
	not the first character correctly.

	* Source/NSFont.m (getNSFont): Retain/autorelease when returning a
	cached instance to make the retain status of the instance correct.

2003-07-05 16:07  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSFont.m (-initWithCoder:): Make sure that the returned
	font has a correct retain count on all paths.

2003-07-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPasteboard.m: Add code to set protocols for proxy objects.
	and dum my class implementations to let protocols work with old
	compilers.
	* Headers/AppKit/GSPasteboard.h: Add missing method of owner.

2003-07-03 01:43  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSFont.m (getNSFont): Only update the cache when the font
	has the default size.

2003-07-02 16:38  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSFont.m: (Mostly) rewrite handling of standard fonts to
	provide better behavior, especially when only some fonts are set in
	the defaults. Updated documentation.

2003-07-01 Serg Stoyan <stoyan@hologr.com>

	* Source/NSBrowser.m (_createColumn):
	Set border type of column's scroll view according to 
	_separateColumns flag.
	
2003-06-29 20:15  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWorkspace.m (-launchApplication:showIcon:autolaunch:):
	Add a missing '@'.

2003-06-29 17:37  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSStringDrawing.m (-drawAtPoint:, -drawAtRect:, -size):
	Automatically turn off screen fonts in the layout manager if the
	ctm for the current context isn't the identity matrix (possibly
	flipped vertically).

2003-06-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/make_services.m: Alter format of filter info.
	* Tools/example.m: Added an example filter.
	* Tools/md5Digest.m: Example filter user.
	* Source/GSServicesManager.m: tweak for filters.
	* Source/NSPasteboard.m: more documentation

2003-06-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPasteboard.m: Documented all methods, fixed minor bugs
	writing fiels to pastebaords, implemented ([+typesFilterableTo:])
	wrote (partial implementation ...) the unimplemented filters stuff.
	* Source/GSServicesManager.m: helpers for filters.
	* Headers/AppKit/GSPasteboard.h: Removed unused methods, added
	documentation.

2003-06-26  Ludovic Marcotte <ludovic@Sophos.ca>

	* Fixed the transparency of Images/common_ret.tiff
	* Source/NSOutlineView (-setDataSource:) Modified to allow
	  a nil data source.

2003-06-26  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/GSLayoutManager.h
	Changed ivars cached_pos and cached_cpos to unsigned.
	* Headers/gnustep/gui/GSLayoutManager_internal.h
	Changed element char_offset of structure glyph_t to unsigned.
	* Source/GSLayoutManager.m (_glyphDumpRuns,
	helpers::generateRunsToCharacter:,
	helpers::generateGlyphsUpToCharacter:,
	helpers::generateGlyphsUpToGlyph:,
	helpers::glyphForCharacter:index:positions::, getGlyphs:range:,
	characterRangeForGlyphRange:actualGlyphRange:,
	glyphRangeForCharacterRange:actualCharacterRange:,
	invalidateGlyphsForCharacterRange:changeInLength:actualCharacterRange:,
	insertTextContainer:atIndex:):
	Removed compiler warning about signed/unsigned comparision. 

2003-06-25  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSImage.m (initWithPasteboard:):
	* Source/NSView.m (dragFile:fromRect:slideBack:event:):
	Corrected handling of pasteboard data of type NSFilenamesPboardType.
 
2003-06-24 01:05  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTabViewItem.m (-drawLabel:inRect:): Update for change
	in the behavior of -drawAtPoint:. Use -drawInRect: instead.

2003-06-23 19:03  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSStringDrawing.m (-drawAtPoint:): Place the text correctly
	when the view isn't flipped.

2003-06-23  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPanel.m
	Commented out unused variables WTitleHeight, ScrollMinSize,
	MessageMinHeight. 
	* Source/NSTabView.m (selectNextTabViewItem:):
	* Source/NSTableView.m (selectAll:):
	* Source/NSTextStorage.m (edited:range:changeInLength:,
	processEditing):
	* Source/GSTextStorage.m (replaceCharactersInRange:withString:)
	* Source/tiff.m (NSTIFFRead, NSTIFFWrite, CheckAndCorrectColormap):
	* Source/GSTable.m (_updateForNewFrameSize:)
	* Source/NSTextView.m (changeFont:):
	Removed compiler warning about signed/unsigned comparision. 
	* Source/GSHorizontalTypesetter.m
	Changed element char_index of structure glyph_cache_t to unsigned.

2003-06-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSWorkspace.m: Implement autolaunch flag and add
	documentation describing hwo GNUstep and MacOS-X actually
	handle launching ... hopefully more clearly than the
	somewhat misleading MacOS-X documentation.

2003-06-22  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/NSInputManager.h
	Changed ivar _abortFlags to unsigned. Changed all modifier
	parameters to unsigned.
	* Source/NSInputManager.m (initWithName:host:):
	Removed compiler warning about signed/unsigned comparision. 
	Adopted to changes in header.
	* Headers/gnustep/gui/GSLayoutManager.h
	Changed ivars layout_glyph and layout_char to unsigned.
	* Headers/gnustep/gui/GSLayoutManager_internal.h
	Changed elements glyph_length and char_length of structure
	glyph_run_head_t to unsigned.
	* Source/NSLayoutManager.m
	(rectArrayForGlyphRange:...rectCount:,
	glyphRangeForBoundingRect:inTextContainer:,
	_insertionPointRectForCharacterIndex:textContainer:): 
	Removed compiler warning about signed/unsigned comparision. 
	* Source/NSMatrix.m (selectAll:)
	Removed compiler warning about signed/unsigned comparision. 
	* Source/NSPageLayout.m (initWithContentRect:...screen:, readPrintInfo)
	Removed compiler warning about signed/unsigned comparision. 
	* Headers/gnustep/gui/NSPopUpButtonCell.h
	Changed ivar _selectedItem to type (id <NSMenuItem>).
	* Source/NSPopUpButtonCell.m (insertItemWithTitle:atIndex:,
	selectItemAtIndex:, selectItemWithTitle:, setTitle:)
	Corrected type of local variable.
	* Source/NSPrintInfo.m
	In [+initPrintInfoDefaults] initialize variable printer with nil.
	* Source/NSPrintOperation.m (_print)
	Removed compiler warning about signed/unsigned comparision. 
	* Source/NSPrintPanel.m
	Added missing include for GSGuiPrivate.h.
	(initWithContentRect:...screen:, updateFromPrintInfo) 
	Removed compiler warning about signed/unsigned comparision. 

2003-06-21  Adam Fedor  <fedor@gnu.org>

	* Source/NSOutlineView.m ([NSOutlineView -drawRow:clipRect:]): 
	Add delegate method call. Patch from Yen-Ju Chen

	* Source/NSView.m (-menuForEvent:): Add note about this
	method being discouraged.

2003-06-20  Adam Fedor  <fedor@gnu.org>

	* Source/NSFont.m ([NSFont -initWithCoder:]): Use NSFont not isa
	to call class methods.

2003-06-20  Adam Fedor  <fedor@gnu.org>

	* Source/DocMakefile (after-all): Check if Gui exists before
	removing.

2003-06-20  Adam Fedor  <fedor@gnu.org>

	* Version 0.8.7

2003-06-21  David Ayers  <d.ayers@inode.at>

	* PrinterTypes/GNUmakefile.postamble: Add -f option to rm in
	uninstall of resource files.

2003-06-17  Adam Fedor  <fedor@gnu.org>

	* GNUmakefile (SUBPROJECTS): Add Documentation

2003-06-17  Adam Fedor  <fedor@gnu.org>

	* Source/NSDocumentController.m: Add GSGuiPrivate header for
	localization.
	* Source/NSSavePanel.m: Idem.

2003-06-17  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/GSDisplayServer.h
	Changes style parameter of [stylewindow:style:] and
	[styleoffsets:::::] to unsigned, to be consistent with the other
	style methods.
	* Source/GSDisplayServer.m
	Adopted to changes in header.

2003-06-15 16:26  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m: Use NSIsEmptyRect instead of
	comparing for equality with NSZeroRect.
	(-layoutLineNewParagraph:): Handle text containers with no area.

2003-06-15 14:57  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac: Don't add GNUSTEP_HDIR/GNUSTEP_LDIR to
	ADDITIONAL_INCLUDE_DIRS/ADDITIONAL_LIB_DIRS.
	configure: Regenerate.

2003-06-15 02:35  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSNibTemplates.h, Source/NSBundleAdditions.m:
	Remove unused GSFontProxy class.

 2003-06-08  David Ayers  <d.ayers@inode.at>
 	
	* Headers/gnustep/gui/IMConnectors.h: Change syntax of include <>
 	to "" for local headers.  Change base/ to gnustep/base/ in
 	includes.  Change AppKit/GSFiles.h to gnustep
 	gnustep/gui/GSFiles.h includes.
 	* Source/Functions.m, Source/GSDisplayServer.m, Source/GSFontInfo.m,
 	Source/GSFusedSilica.m, Source/GSFusedSilicaContext.m,
 	Source/GSHbox.m, Source/GSHelpManagerPanel.m,
 	Source/GSInfoPanel.m, Source/GSKeyBindingAction.m,
 	Source/GSKeyBindingTable.m, Source/GSLayoutManager.m,
 	Source/GSMemoryPanel.m, Source/GSServicesManager.m,
 	Source/GSSimpleLayoutManager.m, Source/GSSlideView.h
 	Source/GSSlideView.m, Source/GSTable.m, Source/GSTextStorage.h
 	Source/GSTextStorage.m, Source/GSTrackingRect.m,
 	Source/GSTypesetter.m, Source/GSVbox.m, Source/NSActionCell.m,
 	Source/NSAffineTransform.m, Source/NSApplication.m,
 	Source/NSAttributedString.m, Source/NSBezierPath.m,
 	Source/NSBitmapImageRep.m, Source/NSBox.m, Source/NSBrowser.m,
 	Source/NSBrowserCell.m, Source/NSBundleAdditions.m,
 	Source/NSButton.m, Source/NSButtonCell.m,
 	Source/NSCachedImageRep.m, Source/NSCell.m, Source/NSClipView.m,
 	Source/NSColor.m, Source/NSColorList.m, Source/NSColorPanel.m,
 	Source/NSColorPicker.m, Source/NSColorWell.m,
 	Source/NSComboBox.m, Source/NSComboBoxCell.m, Source/NSControl.m,
 	Source/NSCursor.m, Source/NSCustomImageRep.m,
 	Source/NSDataLink.m, Source/NSDataLinkManager.m,
 	Source/NSDataLinkPanel.m, Source/NSDocument.m,
 	Source/NSDocumentController.m, Source/NSDrawer.m,
 	Source/NSEPSImageRep.m, Source/NSEvent.m, Source/NSFileWrapper.m,
 	Source/NSFont.m, Source/NSFontManager.m, Source/NSFontPanel.m,
 	Source/NSForm.m, Source/NSFormCell.m, Source/NSGraphicsContext.m,
 	Source/NSHelpManager.m, Source/NSHelpPanel.m, Source/NSImage.m,
 	Source/NSImageCell.m, Source/NSImageRep.m, Source/NSImageView.m,
 	Source/NSInputManager.m, Source/NSInputServer.m,
 	Source/NSInterfaceStyle.m, Source/NSLayoutManager.m,
 	Source/NSMatrix.m, Source/NSMenu.m, Source/NSMenuItem.m,
 	Source/NSMenuItemCell.m, Source/NSMenuView.m,
 	Source/NSOpenGLContext.m, Source/NSOpenGLPixelFormat.m,
 	Source/NSOpenGLView.m, Source/NSOpenPanel.m,
 	Source/NSOutlineView.m, Source/NSPageLayout.m, Source/NSPanel.m,
 	Source/NSParagraphStyle.m, Source/NSPasteboard.m,
 	Source/NSPopUpButton.m, Source/NSPopUpButtonCell.m,
 	Source/NSPrintInfo.m, Source/NSPrintOperation.m,
 	Source/NSPrintPanel.m, Source/NSPrinter.m,
 	Source/NSProgressIndicator.m, Source/NSResponder.m,
 	Source/NSRulerMarker.m, Source/NSRulerView.m,
 	Source/NSSavePanel.m, Source/NSScreen.m, Source/NSScrollView.m,
 	Source/NSScroller.m, Source/NSSecureTextField.m,
 	Source/NSSelection.m, Source/NSSlider.m, Source/NSSliderCell.m,
 	Source/NSSound.m, Source/NSSpellChecker.m,
 	Source/NSSpellServer.m, Source/NSSplitView.m, Source/NSStepper.m,
 	Source/NSStepperCell.m, Source/NSStringDrawing.m,
 	Source/NSTabView.m, Source/NSTabViewItem.m,
 	Source/NSStepperCell.m, Source/NSStringDrawing.m,
 	Source/NSTabView.m, Source/NSTabViewItem.m,
 	Source/NSTableColumn.m, Source/NSTableHeaderCell.m,
 	Source/NSTableHeaderView.m, Source/NSTableView.m,
 	Source/NSText.m, Source/NSTextAttachment.m,
 	Source/NSTextContainer.m, Source/NSTextField.m,
 	Source/NSTextFieldCell.m, Source/NSTextStorage.m,
 	Source/NSTextView.m, Source/NSTextView_actions.m,
 	Source/NSToolbar.m, Source/NSToolbarItem.m, Source/NSView.m,
 	Source/NSWindow.m, Source/NSWindowController.m,
 	Source/NSWorkspace.m, Source/externs.m, Source/linking.m,
 	Source/tiff.m: Ditto.
 
2003-06-08  Kazunobu Kuriyama  <kazunobu.kuriyama@nifty.com>

        * configure.ac: Add --with-audiofile-include and --with-audiofile
        -library options

2003-06-11  Dirk Latterman <dlatt@alqualonde.de>

	* Source/NSActionCell.m (-setObjectValue:): Implemented.

2003-06-11 15:34  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSFontInfo.h, Source/GSFontInfo.m: Add
	-appendBezierPathWithGlyphs:count:toBezierPath: method.

	* Source/NSBezierPath.m: Use it to implement the glyph methods.

2003-06-09  Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/gnustep/gui/NSDataLinkPanel.h: Added ivar declarations
	for the data link panel.
	* Source/NSDataLinkPanel.m: Added some implementations for panel
	methods.
	* Source/NSDataLinkManager.m: Manages the data links for an
	application.
	added implementation for some methods.
	* Headers/gnustep/gui/NSFontPanel.h: Added topView and bottomView
	and sizes for use by accessory view code.
	* Source/NSFontPanel.m: Added implementation for _getOriginalSize
	and also for sertAccessoryView.  Previously the setAccessoryView
	method was causing the accessory view to overlay the content view
	of the window.
	* Panels/GNUmakefile: added GSDataLinkPanel.gorm in the makefile.
	* Source/NSBundleAdditions.m: Skeletal implementation of GSObjectData
	class.

2003-06-09  Alexander Malmberg <alexander@malmberg.org>
	committed by: Gregory Casamento <greg_casamento@yahoo.com>

	* Headers/gnustep/gui/NSFont.h: Added ivar to hold font role
	to represent preferred fonts (e.g. system, user, & tooltip fonts)
	* Source/NSFont.m: Added roles and modified code to properly encode
	and decode fonts such that an intelligent default is selected if the
	specified font is unavailable and also unarchives as the correct
	preferred font if one of the predefined roles is selected.
	

2003-06-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBitmapImageRep.m
	In [initWithBitmapDataPlanes:...bitsPerPixel:],
	[getBitmapDataPlanes:] and [copyWithZone:] changed type of i
	to unsigned int.
	* Source/NSBrowser.m (-setPath:, pathToColumn:, -addColumn):
	Removed compiler warning about signed/unsigned comparision. 
	* Source/NSComboBoxCell.m (-completedString:): ditto.
	* Source/NSFontPanel.m (-setPanelFont:isMultiple:,
	-_trySelectSize:, -_familySelectionChanged:, -browser:...column:)
	: ditto 
	* Source/NSFontmanager.m (-availableFonts,
	-availableFontNamesWithTraits:, -availableMembersOfFontFamily:,
	-convertFont:, convertWeight:ofFont:,
	-fontWithFamily:traits:weight:size:, -fontNamed:hasTraits:): ditto.
	[setSelectedFont:isMultiple:] and [fontMenu:] changed menuItem to
	type (id <NSMenuItem>). 
	
2003-06-05 16:42  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSMenu.m: Check the types of all defaults values before
	using them.

2003-06-05  Adam Fedor  <fedor@gnu.org>

	* GMAppKit.m (-initWithModelUnarchiver:): #ifdef out ivar assignment
	when compiling nib2gmodel.

2003-06-04 23:02  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSCell.m (-_setupTextWithFrame:inView:editor:): Use a (much)
	larger maximum size for the field editor.

2003-05-26  Adam Fedor  <fedor@gnu.org>

	* Source/NSApplication.m (gsapp_user_bundles): New function
	(-_init): Use it.
	* Documentation/Gui/DefaultsSummary.gsdoc: Update.

2003-05-25  Adam Fedor  <fedor@gnu.org>

	* Version 0.8.6

2003-05-22 18:07  Alexander Malmberg <alexander@malmberg.org>

	* Tools/make_services (addExtensionsForApplication): Parse
	NSExtensions dictionary correctly. Based on patch from Jeff
	Teunissen.

2003-05-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSFontPanel.m
	[_familySelectionChanged:] removed unused local variable.
	* Headers/gnustep/gui/NSWorkspace.h
	Added new MacOSX methods.
	* Source/NSWorkspace.m
	Basic implemention of [activeApplication] and [launchedApplications].
	* Source/NSApplication.m
	In [finishLaunching] and [replyToApplicationShouldTerminate:] use
	[NSWorkspace activeApplication] to get application information.

2003-05-20 22:50  Alexander Malmberg <alexander@malmberg.org>

	* Tools/make_services.m (scanDynamic): Skip anything with a .service
	extension.

2003-05-18 00:00  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/DPSOperators.h,
	Headers/gnustep/gui/PSOperators.h,
	Headers/gnustep/gui/GSMethodTable.h,
	Headers/gnustep/gui/NSGraphicsContext.h, Source/NSGraphicsContext.m:
	Add shfill operator.

2003-05-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSInfoPanel.m: Draw authors in the order they occur in
	the info.plist

2003-05-14 Serg Stoyan <stoyan@on.com.ua>

	* Source/NSMenuView.m 
	(-setFont:): Set cell height at least to 20 pixels.
	
2003-05-13 20:19  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSButton.m (-setState:, -setNextState): Mark the view
	as needing display, don't force a display.

	* Source/NSWindow.m (-_terminateBackendWindow): Set _windowNum to 0
	so the window will be recreated the next time it is needed.

2003-05-12 17:30  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSView.m (-lockFocusInRect:): Don't save the clipping path
	in the gstate if one is allocated since it depends on the rectangle
	focus is locked in.

2003-05-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSWorkspace.m: Add support for generic application icon.
	Reduce private method name pollution a little.
	* Images/common_UnknownApplication.tiff: copied from WM ...
	* Images/common_UnknownTool.tiff: similar image for unix cmd-line
	tools.
	* Source/NSApplication.m: Add some user info to the launch
	notification (provided by urbanek@host.sk).

2003-05-05  Michael Hanni   <michael@deviant-behavior.com>

	* Source/NSTabView.m: implemented 
	selectTabViewItemWithIdentifier:.

2003-05-05 22:48  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager.h, Source/GSLayoutManager.m,
	Source/GSHorizontalTypesetter.m: Detect and handle gaps in the soft
	invalidated layout information.

2003-05-02  Adam Fedor  <fedor@gnu.org>

	* Documentation/Gui/GNUmakefile: Remove GNUSTEP_MAKEFILES.
	* Source/DocMakefile: Idem.

2003-05-02  Fred Kiefer <FredKiefer@gmx.de>

	* TextConverters/RTF/RTFProducer.h
	* TextConverters/RTF/RTFProducer.m
	New implemtation by Axel "Mikesch" Katerbau (axel@objectpark.org)
	with small changes from me. RTF output now support much more
	attributes and even Unicode characters. 
	* Source/NSBezierPath.m
	Moved code from [bezierPathWithOvalInRect:] and
	[bezierPathWithRect:] to [appendBezierPathWithOvalInRect:] and 
	[appendBezierPathWithRect:] and implemented the former with a call
	to the later.
	Preliminary implemetation for [appendBezierPathWithGlyph:inFont:]
	and [appendBezierPathWithGlyphs:count:inFont:]. 
	* Source/NSFont.m:
	Preliminary implemetation for NSConvertGlyphsToPackedGlyphs().
	
2003-05-01 21:48  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSScroller.m (-acceptsFirstResponder): Implement to
	return NO.

2003-05-01 20:02  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSInputManager.m (-loadBindingsWithName:): Update for file
	system layout changes.

	* Source/NSTextView.m (-drawRect:): Draw the background correctly.

2003-04-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSScrollView.m: ([scrollWheel:]) enable horizontal scrolling
	with shift key.

2003-04-28 18:35  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSTextContainer.h: Documented.
	* Source/NSTextContainer.m: Cleanups.

Mon Apr 28 13:14:15 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSApplication.m ([NSApplication -targetForAction:]): If this
	is a document-based application, check if the key window's document
	responds to the action; if it does, use it.

2003-04-28  Nicola Pero  <nicola@nicola.brainstorm.co.uk>

	* Resources/GNUmakefile
	(gui-resources_RESOURCE_FILES_INSTALL_DIR): Define using the full
	relative path.

2003-04-27  Adam Fedor  <fedor@gnu.org>

	* Source/GSServicesManager.m (+newWithApplication:) Change
	Services to Library/Services.
	* Source/NSWorkspace.m (+initilize): Idem.
	* Tools/make_services.m (main): Idem.

2003-04-27  Adam Fedor  <fedor@gnu.org>

	* Updates for filesystem change.
	* GNUmakefile (GNUSTEP_MAKEFILES): Remove
	* ColorPickers/GNUmakefile, Documentation/GNUmakefile,
	Images/GNUmakefile, KeyBindings/GNUmakefile, Model/GNUmakefile,
	Panels/GNUmakefile, Panels/GNUmakefile.postamble, 
	PrinterTypes/GNUmakefile, PrinterTypes/GNUmakefile.postamble,
	Source/GNUmakefile, TextConverters/GNUmakefile, Tools/GNUmakefile: 
	Idem and update install locations.
	* Resources/GNUmakefile: Update for change in resource-set.make
	* configure.ac: Replace $GNUSTEP_SYSTEM_ROOT/Makefiles with
	$GNUSTEP_MAKEFILES.  Replace Libraries with Library/Libraries.
	Replace Headers with Library/Headers.

	* Source/NSImage.m (+initialize, +imageNamed:): Use
	+pathForLibraryResource:ofType:inDirectory.
	* Source/NSPrintInfo (+initPrintInfoDefaults): Idem.
	* Source/NSPrinter.m (getFile): Idem.
	* Source/NSSound.m (+initialize, +soundNamed:): Idem.
	* Source/NSView.m (-_loadPrinterProlog): Idem.

	* Source/NSPageLayout.m
	(-initWithContentRect:styleMask:backing:defer:screen:): Use
	GSGuiBundle to get resources.
	* Source/NSPrintPanel.m
	( -initWithContentRect:styleMask:backing:defer:screen:): Idem.
	* Source/NSSpellChecker.m ([NSSpellChecker -init]): Idem.

2003-04-27  Michael Hanni  <michael@deviant-behavior.com>

	* Source/NSPopUpButtonCell.m (drawWithFrame:inView:): added a call 
        to the NSMenuItemCell's calcSize method to place the image 
        correctly when we are making a temp item. Fixes regression 
        prompted by changes on 2003-04-17.

2003-04-27  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSFontInfo.m
	Removed creation of fontDictionary from [init] method. This now
	gets done on demand in [afmDictionary].
	* Source/NSFontPanel.m:
	[_familySelectionChanged:] made the call to [_trySelectSize:]
	safer against none existing fonts. This used to result in a NaN
	being displayed as font size. 

2003-04-25  Benhur Stein <benhur@inf.ufsm.br>

	* Source/NSRulerView.m:
	Removed unused macro BASE_LINE_LOCATION.
	(setMeasurementUnits:, setClientView:, setOriginOffset:): Add call
	to invalidateHashMarks, remove call to setNeedsDisplay:.
	(invalidateHashMarks): Add call to setNeedsDisplay:.
	(drawHashMarksAndLabelsInRect:): Changed calculation of location
	of zero hash mark. Changed use of _zeroLocation ivar into
	zeroLocation local variable. Limited display of hashs and
	marks to baseline.
	* Headers/gnustep/gui/NSRulerView.h: Renamed unused ivar
	_zeroLocation to _UNUSED.

2003-04-26  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSControl.m
	Removed [becomeFirstResponder] and [resignFirstResponder] as the
	handling of [showFirstResponder] is still unclear.
	* Source/NSMenuView.m
	Moved the computation of the cell size into the method [setFont:]
	and use this in [init]. Added call to [setNeedsSizing:] in
	[setHorizontalEdgePadding:]. In [locationForSubmenu:] check for
	the interface style of the submenu.  Also cleaned up up coding
	style and comments in the whole file.
	* Headers/gnustep/gui/NSParagraphStyle.h
	Added new ivar and methods from MacOSX to handle writing directions.
	* Source/NSParagraphStyle.m
	Implemented handling of writing directions. These are needed for the
	upcoming new RTFProducer.
	
2003-04-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSWindow.m: ([setFrameFromString:]) try to adjust sensibly
	for changes to screen size.
	([constrainFrameRect:toScreen:]) bugfix for positioning when the
	window origin is negative.
	* Tools/make_services.m: Ignore illegal (null) file extension spec.

2003-04-26  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPanel.m
	Use controlBackgroundColor instead of lightGrayColor. Patch by Matt
	Rice (matt@vespertine.pc.ashlandfiber.net).
	* Headers/gnustep/gui/NSGraphics.h
	* Source/externs.m
	Added NSPatternColorSpace.
	* Source/NSColor.m
	[GSPatternColor colorSpaceName] uses NSPatternColorSpace.
	Corrected [blendedColorWithFraction:ofColor:], where self and aColor
	where exchanged and alpha handling was missing.
	* Source/NSWindow.m
	Removed unused local variable in [sendEvent:].
	* Source/NSSliderCell.m
	Basic implementation of the tick mark methods. Added en-/decoding
	for tick marks. [setKnobThickness:], [setNumberOfTickMarks:] and
	[setTickMarkPosition:] now update the control.
	
2003-04-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSavePanel.m: Track window resizing and adjust browser
	columns to match.  Use larger minimum width.

2003-04-21  Serg Stoyan <stoyan@hologr.com>

	* Source/NSMenuView.m:
	(mouseDown:): Generate periodic events every 0.01 seconds.
	
2003-04-17  Serg Stoyan <stoyan@hologr.com>

	* Source/NSMenuItemCell.m:
	(setMenuView:): Removed setting image position and
	_mcell_belongs_to_popupbutton ivar for popup button cell.
	(calcSize): Removed code from setMenuView placed here.
	
2003-04-13 Michael Hanni  <michael@deviant-behavior.com>

	* Images/common_WMCloseBroken.tiff,common_WMClose.tiff: remove 
	background of image.

Mon Apr 14 14:24:27 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/gui/AppKit.h: Include NSDocument.h

2003-04-14  Serg Stoyan <stoyan@hologr.com>

	* Source/NSApplication.m:
	(setImageForWindowsItem:): Do not add "X" image if window has 
	no close button.
	
2003-04-13 Michael Hanni  <michael@deviant-behavior.com>

	* Source/NSProgressIndicator.m: revert last change.
	* Source/NSInterfaceStyle.m: revert last change.
	* Headers/NSInterfaceStyle.h: revert last change.

2003-04-13 Michael Hanni  <michael@deviant-behavior.com>

	Multiple outstanding commits.

	* ColorPickers/GSWheelColorPicker.m:
	(mouseDown:): Implemented new event loop that really speeds things 
	up on slow machines.
	* Source/NSScroller.m:
	(init): Decreased periodic delay for scroller buttons.
	(trackKnob:): Implemented new event loop to improve speed. Added 
	code to "snap" back the scroller when you release the alternate 
	key in mid-scroll (modeled after OS 4.2 behavior.)
	(trackScrollButtons:): Removed event loop as we weren't using it 
	anyways.
	* Source/NSFontPanel.m:
	(_trySelectSize:): Put size textfield update code here, make sure 
	column is loaded.
	(_familySelectionChanged:): Call _trySelectSize: to update the 
	size column just like we do for the face browser.
	* Source/NSProgressIndicator.m:
	(drawRect:): Implement GSGtkInterfaceStyle for 
	NSProgressIndicatorInterfaceStyle.
	* Source/NSInterfaceStyle.m: added GSGtkInterfaceStyle.
	* Headers/NSInterfaceStyle.h: ditto.

2003-04-13 Michael Hanni  <michael@deviant-behavior.com>

	* Source/NSPopUpButton.m:
	(mouseDown:): Beep and return if menu items array is empty.
	(keyDown:): ditto.
	
	* Source/NSPopUpButtonCell.m:
	(removeAllItems:): Revert last change. Really remove all items.
	(drawWithFrame:inView:): Draw temporary cell if no items in menu.

2003-04-12  Serg Stoyan <stoyan@hologr.com>

	* Source/NSPopUpButtonCell.m:
	(removeAllItems): Leave item at index 0 with empty title.
	
2003-04-11  Michael Hanni  <michael@deviant-behavior.com>

	* Source/NSApplication.m:
	(updateWindowsItem:): call to sizeToFit removed. NSMenuItemCell
	manipulation removed which the cell makes internally anyways.
	
	* Source/NSMenuView.m:
	(- update:): if we are a popup bail out before messing around 
	with titleview buttons.
	(isOpaque): method added. We are opaque after all.
	 
2003-04-11  Serg Stoyan <stoyan@hologr.com>

	* Source/NSPopUpButton.m:
	(mouseDown): Set menu view's highlightedItemIndex to 
	lastSelectedItem if result index is -1. Comments added.
	
	* Source/NSApplication.m:
	(setImageForWindowsItem:): implemented.
	(changeWindowsItem:title:filename:): call setImageForWindowsItem:
	added. TODO: removed from comment.
	
2003-04-10  Serg Stoyan <stoyan@hologr.com>

	* Source/NSPopUpButton.m:
	(mouseDown): Get selected item index from _cell. Set NSMenuView
	selected item if selection changed, revert to old if unchanged or
	menu item disabled.
	
	* Source/NSPopUpButtonCell.m:
	(selectItem:): Remove image from old selected item and add image 
	to new selected item only if image is not set by user.

2003-04-10  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSWindow.m ([-sendEvent:], case NSRightMouseDown):
	removed code to display the menu. This is now done by 
	[NSView -rightMouseDown:].
	* Source/NSView.m: overrides -menu, 
	changes -rightMouseDown: to display the menu,
	documents -menu, -menuForEvent: and +defaultMenu.

2003-04-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSServicesManager.m: on opening file, only activate for
	document based applications as suggested by Alexander.
	* Source/NSWorkspace.m: ([_connectApplication:]) fix to handle
	retries and timeouts correctly.

2003-04-10 01:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-_generateGlyphs_char_r::::::): Fix
	updating of glyph counts in some rare cases. Minor cleanups.

2003-04-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/gui/GSServicesManager.h: Expost file open methods.
	* Source/GSServicesManager.m: Tidy file opening methods.
	* Source/NSApplication.m: Use methods from GSServicesManager
	Activate NSApp when opening a file.  Use NSDocumentController if the
	app delegate won't open a file.  Remove temporary files once they
	are opened.

2003-04-09  Serg Stoyan <stoyan@hologr.com>

	* Source/NSMenuView.m: return back horizontal menu code.
	(sizeToFit): ditto. Take into account title view's width when
	calculating horizontal menu frame. 
	(innerRect): ditto.
	(rectOfItemAtIndex:): ditto. Take into account title view's width 
	when calculating placement of menu item in horizontal menu.
	(locationForSubmenu:): ditto.
	(setWindowFrameForAttachingToRect:): ditto.
	(encodeWithCoder:): ditto.
	(initWithCoder:): ditto.
	(setHorizontal:): added.
	(isHorizontal): added.
	
	([NSMenuWindowTitleView mouseDown]): Event loop changed to 
	Michael Hanni's version.

	* Headers/NSMenuView.h:
	(setHorizontal:): added.
	(isHorizontal): added.

	* Source/NSWindow.m:
	(orderWindow:): Display content view before backend window ordering.
	
2003-04-09 00:38  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSView.m (-setNeedsDisplay:, -setNeedsDisplayInRect:):
	Clean up, fix a potential issue when subclassing and thread-safety,
	and clarify the documentation. (Based on discussion with David Ayers
	and Pierre-Yves Rivaille.)

2003-04-08 15:33  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-mouseDown:): Rewrite mouse tracking loop.

2003-04-08 02:12  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSApplication.m: Note which thread is the -gui thread.

	* Source/NSView.m (-setNeedsDisplay:, -setNeedsDisplayInRect:):
	If the current thread isn't the -gui thread, perform the call
	in the main thread instead.

2003-04-07 13:05  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSFont.m (-initWithName:matrix:fix:screenFont:): Release
	all memory if the fontInfo can't be created.

2003-04-07 11:56  Alexander Malmberg <alexander@malmberg.org>

	* TextConverters/RTF/rtfGrammer.y: Add error recovery rules.
	* TextConverters/RTF/rtfGrammer.tab.c: Rebuild.

	* TextConverters/RTF/RTFConsumer.m: Change uses of autoreleased
	objects to retain/release explicitly instead.

	(GSRTFError): Try to recover from errors instead of raising an
	exception.

2003-04-06 19:56  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow.m: Make sure -_handleWindowNeedsDisplay: is run
	on every runloop iteration so -setNeedsDisplay* can be used safely
	from methods invoked by -performSelector:target:argument:order:modes:.

2003-04-06 15:10  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-_generateGlyphsUpToCharacter:): Make
	sure that all editing of the text storage has been processed before
	trying to generate glyhps for it.

2003-04-05 12:58  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSFontPanel.m (-_initWithoutGModel): Make preview active
	by default.

2003-04-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/gui/NSAttributedString.h:
	* Headers/gnustep/gui/NSDocumentController.h:
	* Headers/gnustep/gui/NSGraphicsContext.h:
	* Headers/gnustep/gui/NSResponder.h:
	* Headers/gnustep/gui/NSStringDrawing.h:
	* Headers/gnustep/gui/NSTextView.h:
	* Headers/gnustep/gui/NSWindow.h:
	Fixes to allow compliation of apps with STRICT_OPENSTEP defined.
	This does *NOT* mean I've checked that STRICT_OPENSTEP is defined
	where it should be, just that I've stopped it preventing compilation.

2003-03-28  Serg Stoyan  <stoyan@on.com.ua>

	* Source/NSMenuView.m:
	(displayTransient:): Call [self sizeToFit] before caclulating
	locations.

2003-04-04 02:46  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m: Misc. cleanups.
 	(-dealloc): Remove the delegate from the notification center for
	the notifications we added it for.

2003-04-03 20:28  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m: When stepping forward at the end of the
	glyph runs, correctly handle the case where the current run is
	extended.

2003-04-02 15:26  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m: Tweak glyph caching parameters
	to increase performance.

2003-04-01  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Source/NSMenuView.m (NSMenuWindowTitleView): reformatted one line to 
	conform to coding standards

	* Source/NSMenu.m: renamed ivar _changed to _needsSizing.
	([NSMenu -sizeToFit]): Changed call [_view update] to [_view sizeToFit]
	([NSMenu -displayTransient]): call [NSMenuView-update] to ensure
	that the menuView knows it belongs to a transient menu.
	([NSMenu -closeTransient]): call [NSMenuView-update] to ensue that the 
	menuView knows it is not transient anymore.

	* Headers/gnustep/gui/NSMenu.h: renamed ivar _changed to _needsSizing.

2003-04-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSApplication.m: ensure that application initialisation
	is performed in the main thread.

2003-03-31  Adam Fedor  <fedor@gnu.org>

	* Source/NSWindow.m (-becomeKeyWindow): Set initialFirstResponder.
	(-display): Remove this code from here.

2003-03-31  Adam Fedor  <fedor@gnu.org>

	* Source/NSButtonCell.m, Source/NSCell.m, Source/NSMenuItem.m:
	Add GSCategories.h

2003-03-30 19:14  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSScroller.m (-trackKnob:): Wrap each iteration of the
	loop in an autorelease pool.

	* Source/NSTextView.m: Correct the name of the delegate method
	-textView:shouldChangeTextInRange:replacementString: (was missing
	the textView: part).

2003-03-30  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Source/NSMenuView.m: Reformatted to comply to coding standards

	* Source/NSMenu.m: Reformatted to comply to coding standards


2003-03-28 21:08  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTableView.m (mouseDown:): Wrap each iteration of the mouse
	tracking loop in an autorelease pool to avoid using huge amounts of
	memory if the button is held down a long time.

2003-03-28  Serg Stoyan  <stoyan@on.com.ua>

	* Source/NSMenuView.m:
	(attachSubmenuForItemAtIndex:): Documentation comment moved to 
	NSMenuView.h.
	(indexOfItemAtPoint:): ditto.
	(locationForSubmenu:): ditto.
	(trackWithEvent:): ditto.
	(setWindowFrameForAttachingToRect:): Removed "move menu to the screen"
	TODO since it is out of this method scope.
	
	* Headers/NSMenuView.m: Added documentation for almost all methods.
	Cleanup.
	
2003-03-27 23:52  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSMatrix.m (-setSelectionFrom:to:anchor:highlight:): Update
	the selection related ivars after changing the selection.

2003-03-27  Serg Stoyan  <stoyan@on.com.ua>

	* Source/NSMenuView.m:
	([NSMenuWindowTitleView createButton:]): Made imageSize an ivar and 
	removed	declaration. Made rect setting with NSMakeRect().
	([NSMenuWindowTitleView addCloseButton:]): Added button location
	update.
	(initWithFrame:): Title adding moved int update method.
	(setWindowFrameForAttachingToRect:): Title removing moved into update 
	method. Call update instead sizeToFit.
	
	* Source/NSMenu.m: 
	(initWithTitle:): Create NSMenuView with NSZeroRect frame.
	(insertItem:atIndex): removed [menu update] call, because itemChanged:
	calls it.
	(removeItemAtIndex:): ditto.
	(sizeToFit:): Added NSMenuView update. Removed [_view sizeToFit], 
	beacuse [_view update] calls it. Don't set window's origin if size less
	than 1 (window is just created).
	(display): Removed [self update] call (sizeToFit calls
	it). Reformatting.  Do not call setGeometry if menu is owned by popup.
	(close): Removed [self update] call.
	(closeTransient): ditto.
	
2003-03-18 Benhur Stein <benhur@inf.ufsm.br>

        * Fix mouse tracking in NSMatrix
	* Headers/gnustep/gui/NSMatrix.h: Change _keyCell ivar to _reserved1.
        * Source/NSMatrix.m (-_setKeyRow:column:): New method
        (-_selectCell:atRow:column:): Use it.
        (-setSelectionFrom:to:anchor:highlight:): Rewrite.
        (-highlightCell:atRow:column:): Simplify
        (-_mouseDownNonListMode:): Fix tracking.
        (-_mouseDownListMode:theEvent): New method.
        (-mouseDown:): Use previous methods.

2003-03-25 Serg Stoyan <stoyan@on.com.ua>

	* Source/NSMenuView.m 
	(setWindowFrameForAttachingToRect:):Compute frame if number	of 
	items > 0 instead of > 1 (fixes size problem when there is 1 item 
	in popup button's menu).
	(sizeToFit): optimized and fixed offsets calculation.

	* Source/NSMenuItemCell.m
	(imageRectForBounds:): removed pad adding between state image and
	title image and text, because [NSMenuView sizeToFit] does this.
	(titleRectForBounds:): ditto.

2003-03-25  Michael Hanni <michael@deviant-behavior.com>

	* Source/NSMenuView.m (-trackWithEvent:): reset highlighted items in a
	submenu that we leave for a supermenu.
	(setWindowFrameForAttachingToRect:): call sizeToFit	only if cell's 
	frame changed.
	
2003-03-24  Adam Fedor  <fedor@gnu.org>

	* Merge from 0.8.5 branch

2003-03-23 Serg Stoyan <stoyan@on.com.ua>
	* Source/NSMenuView.m: Removed horizontal menu related code.
	(setHorizontal:): Removed.
	(isHorizontal:): Removed.
	(_addLeftBorderOffsetToRect): Removed isHorizontal parameter.
	(setMenu:): Place [self setNeedsSizing: YES] before [self update].
	(update): Removed title view removal, because it's not always known 
	owner of menu at this point. Remove title view creating.
	(sizeToFit:): Reformatting.
	(innerRect:): Idem.
	(setWindowFrameForAttachingToRect:onScreen:preferredEdge:popUpSelectedItem:):
	Title view removal code placed here, because this is only place where
	non-titled menu can appear.
	(initWithFrame:): Removed comment about _leftBorderOffset for popups,
	because we use _leftBorderOffset for regular and popups now. Title view
	creating added.
	(rectOfItemAtIndex:): Removed comment about _leftBorderOffset for
	popups.
	(indexOfItemAtPoint:): Idem. Add left border offset for popups
	too. Correct calling of _addLeftBorderOffsetToRect.
	(setNeedsDisplayForItemAtIndex:): Idem.
	(rightMouseDown:): Ddded comment.

	* Headers/NSMenuView.h
	(setHorizontal:): Removed.
	(isHorizontal:): Removed.

2003-03-22  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Source/NSMenu.m ([NSMenu -display]): Added optimization of
	Michael Hanni to only resize menu view when actually displayed.
	([NSMenu -setTitle:]): Idem
	([NSMenu -sizeToFit:]): Fixed problem with jumping menus when items
	are added.
	([NSMenu -display:]): added optimization of Michael Hanni to resize 
	only once.  Also fixed race condition bug in getting menu location.
	([NSMenu -displayTransient]): Added optimization of M. Hanni, removed
	resetting position to (0, 0).

	* Source/NSMenuView.m (-initWithFrame:): Removed creation of titleView
	([NSMenuView -setMenu:]): call update to handle new situation
	([NSMenuView -update]): Removed call to _menu update, handle the
	adding/removing of the title view.  
	([NSMenuView -sizeToFit]): reformatted to conform to coding standard,
	handle missing titleView.
	([NSMenuView -setWindowFrameForAttachingToRect:onScreen:preferredEdge:popUpSelectedItem:]): 
	Reformatted to conform to coding standard.  Removed the code that
	removed the titleView.  That is handled by update.
	([NSMenuView -drawRect:]): Reformatted to conform to coding standards.
	([NSMenuWindowTitleView -init]): Reformatted to conform to coding
	standards.
	([NSMenuWindowTitleView -dealloc]): new method to prevent leaking
	the close button.
	([NSMenuWindowTitleView -titleSize]): Reformatted to conform to
	coding standard
	([NSMenuWindowTitleView -drawRect:]): idem
	([NSMenuWindowTitleView -mouseDown:]): idem
	([NSMenuWindowTitleView -createButton]): idem

2003-03-20  David Ayers  <d.ayers@inode.at>

	* Source/NSCell.m ([NSCell encodeWithCoder:]): Reinsert encoding
	of isContinuous to insure backward compatiblity of archives.

2003-03-20  Serg Stoyan <stoyan@on.com.ua>

	* Source/NSMenuView.m 
	(sizeToFit): Removed setting _leftBorderOffset to 0 for popup menus.
	Set menuBarHeight to title view height only if it's not popup menu.
	Added recalculation of key equivalent offset for popup menu.
	(setWindowFrameForAttachingToRect:onScreen:preferredEdge:popUpSelectedItem:):
	Remove title view. Take into account left top border while calculating 
	screenFrame.
	(drawRect:): Draw left top dark gray border for all types of menus
	with NSDrawTiledRects().
	
2003-03-19  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/NSMenu.h
	Removed method [_rightMouseDisplay:] as this is now private.
	* Source/NSMenu.m
	Implemented [popUpContextMenu:withEvent:forView:] using
	[_rightMouseDisplay:].
	* Source/NSApplication.m
	In [rightMouseDown:] use [popUpContextMenu:withEvent:forView:].
	* Source/NSMenu.m
	In [sendEvent:] use [popUpContextMenu:withEvent:forView:].

2003-03-19  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBitmapImageRep.m
	In [imageUnfilteredFileTypes] add the tiff entries always to the
	front of the list. As the standard GNUstep images are in this
	format, this will speed up image loading.
	* Headers/gnustep/gui/NSCell.h
	Removed ivar is_continuous, this is now handled by the action
	mask. Decreased size of the image_position ivar. Added two more
	subclass ivar to reuse the freed space. Flagged all methods that
	are new in MacOSX and added a few more of this.
	* Source/NSCell.m 
	Added new MacOSX methods [title], [setTitle:], [controlSize],
	[setControlSize:], [controlTint], [setControlTint:] and
	[highlightColorWithFrame:inView:]. Rewrote [isContinuous], 
	[setContinuous:] and [trackMouse:...untilMouseUp:] to work via the
	_action_mask. 

2003-03-18  Serg Stoyan <stoyan@on.com.ua>

	* Source/NSMenuView.m 
	([NSMenuTitleView titleSize]): Added.
	([NSMenuTitleView drawRect:]): Switch to using titleSize:. Declaration 
	of attr variable moved to class declaration.
	([NSMenuTitleView init]): Added to initialize attr variable.
	(sizeToFit): Count missed state image offset. Do not add padding when 
	there's no key equivalent. Handle situations when tile view wider than 
	menu items, when there's no menu items and so on. (Side efect: menu of 
	application in Gorm resizes correctly while changing title, adding
	shorcut etc.). Using [NSMenuTitleView titleSize] now for correct 
	determination	of menu title's text width.

2003-03-17  Serg Stoyan <stoyan@on.com.ua>

	* Source/NSMenuView.m 
	(sizeToFit): 15 extra pixels added only for submenus. Extra 
	_horizontalEdgePad removed. Made cleanup.
	(createButton): uses [NSButton setRefusesFirstResponder: YES] to avoid 
	drawing dotted rectangle.
	* Images/common_Close.tiff: Changed to look and feel like
	WindowMaker's close button.
	* Images/common_CloseH.tiff: ditto.
	* Images/common_3DArrowDown.tiff: Corrected position of light and 
	dark sides of triangle.

2003-03-17  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSControl.m
	Added method [acceptsFirstResponder], which asks the cell if it
	accepts first responder. Added [becomeFirstResponder] and
	[resignFirstResponder] that redraw if the cell may change apprearance.
	* Source/NSButton.m
	* Source/NSStepper.m
	Removed the method [acceptsFirstResponder] as NSControls version
	is now used.
	
2003-03-07  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Source/NSMenu.m: ([-_updateUserDefaults:]) Do not store location
	for attached menus.
	* Source/NSMenuView.m ([NSMenuWindowTitleView -drawRect:]):
	Centre drawing of title instead of using fixed offset.

2003-03-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMenu.m: ([-_updateUserDefaults:]) restore saved menu
	location functionality (was only working for torn off menus).
	* Source/NSWindow: ([-miniaturise:]) order the counterpart window
	in so that it gets drawn properly.

2003-03-06  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Source/NSMenuView.m: Added NSMenuTitleView (moved
	from NSMenu).
	([NSMenuView -detachSubmenu]): Removed setting highlighting.
	([NSMenuView -attachSubmenuForItemAtIndex:]) added logging.
	([NSMenuView -update]): Handle _titleView.
	([NSMenuView -sizeToFit]): Take titleView into account
	([NSMenuView -performActionWithHighlightingForItemAtIndex:]): 
	restore old highlighting.
	([NSMenuView -trackWithEvent:]): Rewritten.
	([NSMenuView -mouseDown:]): Only restore menu position
	when needed.
	([NSMenuView -rightMouseDown:theEvent]): On menus treat
	as ordinary mouse down to avoid rightclick menus on menus.

	* Source/NSMenu.m (NSView): Moved NSMenuWindowTitleView to
	NSMenuView.  Added comments. Added -_updateUserDefaults:,
	-_menuMoved: methods to track moving menus.
	Renamed -_setTornOff:  to -setTornOff:, -isFollowTransient to
	-isTransient.
	([NSMenu -initWithTitle:]): Remove some old comments, remove
	reference to titleView, listen to window move notification and
	enqueued move notification.
	([NSMenu -attachedMenu]): Adjusted for renamed ivar.
	([NSMenu -sizeToFit]): Remove references to titleView
	([NSMenu -setTornOff:]): Remove references to titleView,
	call update to NSMenuView instead.  
	([NSMenu -isPartlyOffScreen]): Do not depend in removed ivar.
	([NSMenu -_performMenuClose:]): adjust to renamed methods, will
	force synchronization of userdefaults.
	([NSMenu -displayTransient]): Removed references to _titleView,
	remember the highlighted index to restore with -closeTransient.
	([NSMenu -close]): remove references to _titleview, use methods instead
	of relying on ivars. added call to update on menu representation.
	([NSMenu -closeTransient]): Remove references to _titleView, restore
	highlighted index. Call update on menu representantation.
	([NSMenu -shiftOnScreen]): Rewrote to move in x and y direction
	simultanuously.
	([NSMenuWindowTitleView -acceptsFirstMouse:]): Removed useless 
	code to set menuview for itemCells.

	* Headers/gnustep/gui/NSMenuView.h: added ivar _titleView.
	(moved from NSMenu). 

	* Headers/gnustep/gui/NSMenu.h: Added NSMenuView protocol,
	added documentation to NSMenu class.  
	(MSMenu): Removed ivar _titleView, _isPartlyOffScreen, added
	ivar _oldHighlightedIndex.  Renamed method -isFollowTransient to
	-isTransient. Removed method -nestedCheckOffScreen

2003-03-05 17:07  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m (-drawGlyphsForGlyphRange:atPoint:):
	Use the focused view as the control view instead of the text
	container's text view (it might not have one).

2003-03-03 19:26  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-usedRectForTextContainer:): Don't add
	the extra line frag rect.

	* Source/NSTextView.m (-sizeToFit): Add the extra line frag rect
	when computing the size of the view.
	(-scrollRangeToVisible:): Reimplement using the new insertion point
	positioning methods.

2003-03-03 16:17  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m (-layoutGlyphsInLayoutManager:
	inTextContainer:startingAtGlyphIndex:previousLineFragmentRect:
	nextGlyphIndex:numberOfLineFragments:): Change type of a variable
	holding a character index to int (was char, would overflow and
	break things).

2003-03-03 14:52  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSTypesetter.h, Source/GSTypesetter.m: Removed
	-relayoutGlyphsInLayoutManager:glyphRange:lineFragmentRect:
	textContainer:previousLineFragmentRect:. It was broken by design,
	and a working soft invalidation system is now in place.

	* Headers/gnustep/gui/GSLayoutManager.h, Source/GSLayoutManager.m:
	Add and implement -typesetter and -setTypesetter:.

	* Source/GSTextStorage.m (-setAttributes:range:): Handle zero-length
	attribute changes correctly.

2003-03-02  Ludovic Marcotte <ludovic@Sophos.ca>

	* Source/NSComboBoxCell.m: Modified so that we no longer
	retain the dataSource. This would create a retain loop and
	prevent anything using it to be released properly.

2003-03-01  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTextView_actions.m
	Use method calls instead of some of the direct references to
	NSLayoutManager ivar. General clean up.
	* Source/NSApplication.m
	Added support to print a file in [finishLaunching]. Use safer way
	to call selector in [beginSheet:...contextInfo:].
	* Source/GSSlideView.m
	In [drawRect:]use the frame of the view, not the given rect.

2003-02-26 17:09  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m
	(-glyphRangeForBoundingRect:inTextContainer:): Fix the horizontal
	intersection checks.

2003-02-26 00:47  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-_generateRunsToCharacter:): Optimize
	the run structure by merging with an existing run instead of
	creating a new run under some circumstances.

2003-02-25 17:38  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m
	(-textStorage:edited:range:changeInLength:invalidatedRange:): Fix
	handling of trailing text containers when soft-invalidating.

2003-03-24  Adam Fedor  <fedor@gnu.org>

	* Version: 0.8.5

2003-03-24  Adam Fedor  <fedor@gnu.org>

	* Source/NSBox.m (-sizeToFit): Set frame to calculated size when
	content view has no subviews.

2003-03-18 17:54  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSFont.m, Source/NSStringDrawing.m,
	Headers/gnustep/gui/NSStringDrawing.h: Change to an implementation
	that uses the text system.

2003-03-07  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSWindow: ([-miniaturise:]) order the counterpart window
        in so that it gets drawn properly.

2003-03-04  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/gui/GMAppKit.h, GMArchiver.h, IMConnectors.h,
	IMCustomObject.h, IMLoading.h, NSNibConnector.h: Change #import to
	#include
	* Model/Controller.[h,m], GMAppKit.m, GMArchiveObjects.m,
	GMArchiver.m, IBClasses.[hm], IMConnectors.h, IMLoading.m,
	Translator.[hm], nib2gmodel.m, test.m: Idem.

	* Tools/gsnd/portaudio/pa_unix_oss/pa_unix_oss.c: Fixes for FreeBSD.

2003-02-24  Adam Fedor  <fedor@gnu.org>

	* Version: 0.8.4

2003-02-24 15:24  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-invalidateGlyphsForCharacterRange:
	changeInLength:actualCharacterRange:): Set the next character index
	correctly after the run-merge optimization.

2003-02-24 03:49  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-_glyphForCharacter:index:positions::):
	Fix handling of the case where the exact glyph is found during
	the binary search.

	* Source/NSLayoutManager.m (-drawBackgroundForGlyphRange:atPoint:):
	Check that a range has a background color before checking that there
	are rectangles for it (since ranges practically always have
	rectangles, and very rarely a background color).

2003-02-24 00:02  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSParagraphStyle.m: Implement -isEqual: and -hash.

2003-02-23 13:30  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow (-update): Don't redisplay the window.

2003-02-22  Benhur Stein <benhur@inf.ufsm.br>

	* Source/NSView.m (-displayIfNeededInRectIgnoringOpacity:): Disable
	and re-enable flushing here.
	(-displayRectIgnoringOpacity:): And here.
	* Source/NSWindow.m ([NSWindow -display]): Instead of here.
	([NSWindow -update]): And here.

2003-02-23 01:59  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m, Source/NSLayoutManager.m: Use num_linefrags
	to tell whether layout has started for a text container or not,
	instead of tracking the status separately.

2003-02-22 12:29  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSApplication.m (-sendEvent:):	Only bring up the main
	menu if the there is no window for the event.

	* Source/NSPopUpButton.m: Implement -menuForEvent: to always
	return nil to indicate that we don't have a context menu.

2003-02-22 02:34  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager.h: Declare
	-layoutManager:didCompleteLayoutForTextContainer:atEnd: so it's
	visible (to gcc and to delegate implementers).

	* Source/GSHorizontalTypesetter.m, Source/NSLayoutManager.m: Make
	sure the extra line frag is always set when we reach the end (ie.
	even after soft-invalidated layout information has been used up to
	the end).

2003-02-21 Serg Stoyan <stoyan@hologr.com>

	* Source/NSApplication.m (-activateIgnoringOtherApps:): Remove
	main menu display.
	(-sendEvent:): Check first if right button down.
	(-setMainMenu:): Don't set menu title. Remove menu display.
	* Source/NSMenu.m (-init): Default title is process name.
	(-initWithTitle:): Observe NSApplicationWillBecomeActiveNotification.
	(_showOnActivateApp:): New.
	(-display): Set geometry only if not set.
	(-setGeometry): New.

	* Source/NSPopUpButton.m (-mouseDown:): Send event to NSApp.

2003-02-19  Adam Fedor  <fedor@gnu.org>

	* Source/NSPrintOperation.m (-_print): Remove locale change (now
	handled correctly in backend stream context.

	* Source/NSScrollView.m (-initWithFrame:): Change default border
	to none.

2003-02-19 15:06  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m: Optimize run_for_glyph_index() by
	caching the last run. Optimize allocation of line frags.

	* Source/NSLayoutManager.m
	(-textStorage:edited:range:changeInLength:invalidatedRange:): Fix
	clearing of soft-invalidated information if there's an invalidation
	and we don't have layout past the invalidated range.

2003-02-19 03:09  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-_glyphForCharacter:index:positions::):
	Use binary search to find the index of the character in the run.

	(-setLocation:forStartOfGlyphRange:): Start the search for the line
	frag from the back, as the line frag we're searching will often
	be the last one (always with GSHorizontalTypesetter).

2003-02-19 00:31  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager.h,
	Source/GSHorizontalTypesetter.m, Source/GSLayoutManager.m: Optimize
	reuse of soft-invalidated layout a bit in a common case.

2003-02-19 00:10  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-invalidateGlyphsForCharacterRange:
	changeInLength:actualCharacterRange:): Correct the condition for
	splitting the initial run.

2003-02-18 21:24  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager.h, Source/GSLayoutManager.m:
	Add basic interface that lets the typesetter access soft-invalidated
	layout information.

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:): Use
	the soft-invalidated information to avoid rebuilding the layout
	(when possible).

	* Source/NSLayoutManager.m: Fix edge case in soft invalidation.

2003-02-18  Fred Kiefer <FredKiefer@gmx.de>

	* TextConverters/RTF/RTFProducer.m
	[colorTable] corrected the output of the colour table, by using a
	C array instead of an NSMutableArray.
	* TextConverters/RTF/RTFConsumer.m
	GSRTFcolorfg(), GSRTFcolorbg(), GSRTFlineSpace(),
	GSRTFspaceAbove() set the state of the context to changed, so that
	new attributes get used.

2003-02-18 18:03  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m, Source/NSLayoutManager.m: Implement
	handling of soft-invalidated line frags. Soft-invalidate layout
	information for glyphs after an edited range in NSLayoutManager.

2003-02-18 01:23  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m: Many minor cleanups and optimizations.
	Much commenting.

	* Source/GSHorizontalTypesetter.m (-layoutGlyphsInLayoutManager:
	inTextContainer:startingAtGlyphIndex:previousLineFragmentRect:
	nextGlyphIndex:numberOfLineFragments:): Determine the initial value
	for newParagraph correctly.

	* Source/NSLayoutManager.m
	(-textStorage:edited:range:changeInLength:invalidatedRange:): Don't
	invalidate all layout on each change. Now, all layout information
	for glyphs before the change will be reused. (Layout for glyphs
	after the change is still invalidated, until I finish the soft
	invalidation.)

	* Source/GSTextStorage.m (-setAttributes:range:): Call
	-edited:range:changeInLength: with the range that was changed (and
	not the range attributes could be merged for).

2003-02-17 21:25  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager.h,
	Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m (-invalidateGlyphsForCharacterRange:
	changeInLength:actualCharacterRange:): Set the prev pointer
	correctly when splitting a run. Add sanity checks to catch try
	to catch glyph structure corruption early.

	(-textStorage:edited:range:changeInLength:invalidatedRange:): Clean
	up layout invalidation.

2003-02-17 02:16  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager.h, Source/GSLayoutManager.m:
	Add some framework support for caching the last accessed run.

2003-02-17 02:08  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m (-rectArrayForGlyphRange:
	withinSelectedGlyphRange:inTextContainer:rectCount:,
	-_insertionPointRectForCharacterIndex:textContainer:,
	-drawGlyphsForGlyphRange:atPoint:): Optimize by using a binary
	instead of linear search for the line frag.

	More cleanups and comments.

2003-02-16 22:37  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m: Commenting and cleanups.
	(-glyphIndexForPoint:inTextContainer:fractionOfDistanceThroughGlyph:):
	Handle the case where the point is on a line, but not inside a line
	frag rect, better.

2003-02-16 17:48  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSHorizontalTypesetter.h,
	Source/GSHorizontalTypesetter.m: Store the line frags array as
	an ivar instead of allocating and freeing it everytime
	-layoutLineNewParagraph: is called.

2003-02-16 15:51  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m: Bring back the old implementation of
	-rulerMarkersForTextView:paragraphStyle:ruler:.

Sun Feb 16 14:54:50 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSSplitView.m ([-mouseDown:]): Corrected offset used in
	delegate calls.  For example, in a splitview with a single
	divider, the offset used was 1, while it should be 0.

2003-02-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMenu.m: Upon creation of bWindow, set its level to
	pop up window level, so right click brings up the menu above
	panels etc.

Sun Feb 16 04:13:46 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSSplitView.m ([-mouseDown:]): Fixed calling delegate
	method to constrain split position.  Patch By Enrico Sersale,
	with changes.

2003-02-16 04:14  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager.h, Source/GSLayoutManager.m:
	Add methods for setting and getting the extra line fragment
	information.

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:): Set
	the extra line fragment information as required.

	* Source/NSLayoutManager.m: Use the extra line fragment information
	to position the insertion point properly when it's placed after the
	last character in the text.

2003-02-15 18:22  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSTextView.h, Source/NSLayoutManager.m,
	Source/NSTextView.m: Change the way the text view is told about
	layout invalidation. Change NSTextView to update its state as
	late as possible before displaying, and make sure it's updated
	when it's resized.

2003-02-15 18:11  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSParagraphStyle.m ([NSMutableParagraphStyle
	-copyWithZone:]): Add calls to GSDebugAllocationAdd/
	GSDebugAllocationRemove when swizzling the class to keep the
	allocation counts valid.

2003-02-15 18:04  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSSpellChecker.m (-_launchSpellCheckerForLanguage:): Don't
	printf-expand the error message twice (might cause a crash if
	'language' contains a "%").

Sat Feb 15 13:26:03 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/gui/AppKit.h: Include NSRulerView.h
	and NSRulerMarker.h, reported missing by Benhur Stein.

2003-02-14 17:47  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSTextView.h, Source/NSTextView.m,
	Source/NSTextView_actions.m: Keep track of the original index of a
	sequence of moves in one dimension. Pass it to the layout manager
	when moving the insertion point to prevent drifting.

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:): Fix
	an edge case in tab handling. Also, if tabs occur and the paragraph
	style has no more tab stops, act as if there were tabs every 100
	points.

	* Source/NSLayoutManager.m (-characterIndexMoving:fromCharacterIndex:
	originalCharacterIndex:distance:): When moving vertically, return the
	index of the character nearest the target horizontally.

2003-02-13 01:01  Alexander Malmberg <alexander@malmberg.org>

	* TextConverters/RTF/rtfGrammer.y (rtfCharset): Treat unknown
	character sets as ANSI.
	TextConverters/RTF/rtfGrammer.tab.c,
	TextConverters/RTF/rtfGrammer.tab.h: Regenerate.

	* TextConverters/RTF/RTFConsumer.m: Fix handling of the indentation
	control words: \fi, \li, and \ri.
	(GSRTFmangleText): Set the paragraph style attribute to a copy of
	the working NSMutableParagraphStyle so later changes won't affect
	the attributes of this text.

2003-02-13 00:52  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:):
	Implement basic handling of tabs.

2003-02-12  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSSlideView.h
	* Source/GSSlideView.m
	Moved over from X11 backend.
	* Source/GNUmakefile
	Added new file GSSlideView.m.
	* Source/GSDisplayServer.m
	Use GSSlideView to implement image sliding.

2003-02-11 17:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSScrollView.m (-setBorderType:): Call -tile to make
	the change visible.

	* Source/NSBrowser.m (-_createColumn): Set the border of the created
	scroll view explicitly.

2003-02-11 16:33  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSAttributedString.m (-fixAttachmentAttributeInRange:):
	Update end index when a character is deleted.

	* Source/NSTextStorage.m (-processEditing): Make sure we always
	give a valid range and delta to the layout managers.

	* Source/NSTextView.m (-setSelectedRange:affinity:stillSelecting:):
	Clamp the selected range to the text storage's length.

2003-02-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBrowser.m: Rewrote and documented the ([-setPath:]) method
	to fix the distinction between absolute and relative paths and to
	improve performance somewhat.

2003-02-10 15:14  Alexander Malmberg <alexander@malmberg.org>

	Based on patches from Jeff Teunissen:

	* Source/NSWindow.m (GSAllWindows): Check that windowmaps isn't
	NULL before calling NSAllMapTableValues.

	* Source/NSScroller.m: Change size check so the knob and arrows are
	visible until there's absolutely no space left for them. Draw the
	knob slot with the window's background color when the knob isn't
	visible for consistency with OPENSTEP.

	* Source/NSApplication.m (-setApplicationIconImage:): Update all
	windows that have the old app icon as their mini window image so they
	use the new app icon.

2003-02-10 15:09  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m, Source/NSLayoutManager.m,
	Source/NSTextView.m: Many minor bug and behavior fixes to get the
	text system to work with several text containers attached to one
	layout manager.

2003-02-09 21:08  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m: Clean up old debugging code, whitespace,
	and error handling.
	(-_doLayout): Track next glyph index correctly if we have multiple
	text containers.

	* Source/NSLayoutManager.m (-rectArrayForGlyphRange:
	withinSelectedGlyphRange:inTextContainer:rectCount:,
	-_insertionPointRectForCharacterIndex:textContainer:): Fix handling of
	glyphs that aren't nominally spaced.

2003-02-09 18:34  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m (-breakLineByWordWrappingBefore:):
	Return correct index when breaking at a control glyph.

2003-02-09 18:02  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m, Source/NSLayoutManager.m: Add
	-_didInvalidateLayout method that is called whenever any layout
	information has been invalidated. Use it in NSLayoutManager to
	resize text views.

2003-02-09 15:23  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView_actions.m: Fix several movement actions (used
	to move from the wrong end of the selected range, or mixed glyphs
	and characters).

2003-02-09 14:48  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m: Make the main method reentrant
	by having it allocate a temporary instance to handle calls when
	it is already in use.

2003-02-09  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSColorList.m
	[_loadAvailableColorLists] check if a directory exists before
	looking for a colour list in it.

2003-02-08 22:56  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView_actions.m (-lowerBaseline:): Change the correct
	attribute.

	(-turnOffLigatures:, -useStandardLigatures:): Correct the attribute
	changes.

2003-02-08 22:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSFontInfo.m (-defaultLineHeightForFont),
	Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:): Improve
	calculation of line height and make it match the baseline calculation
	when typesetting.

2003-02-08 22:29  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSWindow.m (-sendEvent:): On right mouse down, check if
	the view that is hit has a pop-up menu, and if so, display it
	instead of sending the event to the view. Based on patch from
	Matt Rice.

2003-02-08 17:51  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSLayoutManager.h, Source/NSLayoutManager.m:
	Add -characterIndexMoving:fromCharacterIndex:originalCharacterIndex:
	distance: method.

	* Source/NSTextView.m: Keep track of the selection affinity.

	* Source/NSTextView_actions.m: Use the new method and affinity
	handling to reimplement the insertion point movement actions.

2003-02-07 17:47  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSTextStorage.m (-setAttributes:range:): Fix memory leak.

2003-02-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/libgnustep-gui.def: Regenerated
	* ColorPickers/GNUmakefile: add local library paths
	* Source/GSLayoutManager.m: Use rand() rather than random() as it
	is portable to mingw32.

Wed Feb  5 04:56:45 2003  Serg Stoyan <stoyan@hologr.com>
	
	* Source/NSMenuItemCell.m ([-drawKeyEquivalentWithFrame:inView:]): 
	Do not draw the key equivalent if we are owned by a popup, and are
	drawing the small popup image.
	
Wed Feb  5 04:42:16 2003  Serg Stoyan <stoyan@hologr.com>

	* Source/NSPrintOperation.m ([-_printOperationDidRun:success:
	contextInfo:]): Fixed calling the delegate method.

2003-02-03 02:49  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSLayoutManager.h, Source/NSLayoutManager.m:
	Add -insertionPointRectForCharacterIndex:inTextContainer: method.

	* Source/NSTextView.m (-updateInsertionPointStateAndRestartTimer:):
	Use it.

2003-02-02  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTextField.m
	Only accept first mouse when editable.
	
2003-02-02 02:31  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m, Source/NSTextView_actions.m: Clarify
	comments about user attribute changing now that I've figured out
	a way for it to work. Rewrite the actions to match.

2003-02-02  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSWindow.m
	Rewrote all the toolbar methods. Implemented [zoom:]. Extracted
	new method [_terminateBackendWindow] from [dealloc] and use it to
	implement one shot windows in the orderOut case of
	[orderWindow:relativeTo:]. Removed frame restriction from
	[setFrameFromString:]  as this gets done in
	[setFrame:display:]. Use [NSScreen visibleFrame] here and in
	[stringWithSavedFrame]. Implemented [cascadeTopLeftFromPoint:].
	Removed unused and empty methods [performHide:] and [performUnhide:].

2003-02-01 15:09  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-shouldChangeTextInRange:replacementString:):
	Allow changes even if we're not the first responder.

	(-didChangeText): If we're not the first responder, end the editing
	session.

2003-02-01 13:52  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:): Fix
	sign problem with descender.

Sat Feb  1 05:34:09 2003   Benhur Stein <benhur@inf.ufsm.br>, 
	                   Nicola Pero  <n.pero@mi.flashnet.it>

	The focus is now expected to have been locked on the control view
	before cell's drawXXXWithFrame:inView: and similar methods are
	called.  This makes drawing much more efficient.
	* Source/NSApplication.m ([NSAppIconView -setImage:]): Lock/unlock
	focus if it can draw.
	* Source/NSBrowser.m ([GSBrowserTitleCell
	-drawWithFrame:inView:]): Do not lock/unlock focus.
	([-displayColumn:]): Lock/unlock focus before drawing.
	([-doClick:]): Lock/unlock focus.
	* Source/NSBrowserCell.m ([-drawInteriorWithFrame:inView:]): Do
	not lock/unlock focus.
	* Source/NSButtonCell.m ([-drawWithFrame:inView:]): Do not
	lock/unlock focus.
	([-drawInteriorWithFrame:inView:]): Do not lock unlock focus.
	* Source/NSCell.m ([-drawInteriorWithFrame:inView:]): Do not
	lock/unlock focus.
	([-drawWithFrame:inView:]): Do not lock/unlock focus.
	([-performClick:]): Lock/unlock focus.
	* Source/NSComboBoxCell.m ([-_didClickInRect:ofView:]):
	Lock/unlock focus.
	* Source/NSControl.m ([-mouseDown:]): Lock/unlock focus.
	* Source/NSFormCell.m ([-drawWithFrame:inView:]): Do not
	lock/unlock focus.
	* Source/NSImageCell.m ([-drawInteriorWithFrame:inView:]): Do not
	lock/unlock focus.
	([-drawWithFrame:inView:]): Do not lock/unlock focus.
	* Source/NSMatrix.m ([-deselectAllCells]): Mark the cell as
	needing redisplay, but do not redraw immediately.
	([-_selectCell:atRow:column:]): Same change.
	([-setSelectionFrom:to:anchor:highlight:]): Same change.
	([-highlightCell:atRow:column:]): Lock/unlock focus.
	([-_mouseDownNonListMode:]): Lock/unlock focus, flush window,
	select cell better.
	([-mouseDown:]): Lock/unlock focus; removed 2 flush windows.
	([-performKeyEquivalent:]): Lock/unlock focus; flush window.
	([-_altModifier:]): Added a displayIfNeeded call.
	([-keyDown:]): Same change.
	([-_move:]): Always deselect all cells in before selecting new
	ones.  Do not display cell immediately, but mark it for redisplay.
	Removed a few flush windows.  Commented out unclear code.
	([-_shiftModifier:]): Lock/unlock focus.
	([-_setState:highlight:startIndex:endIndex:]): Do not flush the
	window.
	([_setState:highlight:startIndex:endIndex:]): Do not display the
	cell directly; mark it as needing redisplay.
	([-drawCellAtRow:column:]): Do not lock/unlock focus.
	([-highlightCell:atRow:column:]): Do not lock/unlock focus.
	([-_drawCellAtRow:column:]): Do not lock/unlock focus.
	* Source/NSMenuItemCell.m
	([-drawBorderAndBackgroundWithFrame:inView:]): Do not lock/unlock
	focus.
	([-drawInteriorWithFrame:inView:]): Do not lock/unlock focus.
	* Source/NSOutlineView.m
	([-editColumn:columnIndexrow:rowIndexwithEvent:theEventselect:flag]):
	Lock/unlock focus.
	* Source/NSPopUpButtonCell.m ([-drawInteriorWithFrame:inView:]):
	Do not lock/unlock focus.
	* Source/NSScroller.m ([-trackScrollButtons:]): Lock/unlock focus.
	* Source/NSSlider.m ([-mouseDown:]): Lock/unlock focus.
	([-trackKnob:knobRect:]): Lock/unlock focus.
	* Source/NSSliderCell.m ([-drawInteriorWithFrame:inView:]): Do not
	lock/unlock focus.
	* Source/NSStepper.m ([-mouseDown:]): Lock/unlock focus.
	* Source/NSStepperCell.m ([-drawInteriorWithFrame:inView:]): Do
	not lock/unlock focus.
	([-highlight:highlightupButton:upButtonwithFrame:frameinView:
	controlView]): Do not lock/unlock focus.
	* Source/NSTextFieldCell.m ([-drawInteriorWithFrame:inView:]): Do
	not lock/unlock focus.
	* Source/NSTableHeaderCell.m ([-drawInteriorWithFrame:inView:]):
	Do not lock/unlock focus.
	([-drawWithFrame:inView:]): Do not lock/unlocks focus.
	* Source/NSTableHeaderView.m ([-drawRect:]): Do not lock/unlock
	focus while drawing.
	([-mouseDown:]): Lock/unlock focus.
	* Source/NSWindow.m ([NSMiniWindowView -setImage:, -setTitle:]):
	Lock focus if can draw rather than checking _window != nil.
	
2003-02-01 03:26  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-removeTextContainerAtIndex:): Set
	textcontainers to NULL after freeing it. Clean up some other
	malloc-stuff.

	* Source/NSTextContainer.m (-replaceLayoutManager:): Remove the
	containers from the correct layout manager.

2003-01-31  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/GSDisplayServer.h
	New interface [restrictWindow:toImage:].
	* Source/GSDisplayServer.m
	Empty implementation for this.
	
2003-01-31 23:20  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-_generateGlyphsForRun:at:): Add
	handling of NSAttachmentCharacter.

2003-01-31 21:59  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager.h,
	Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m: Implement [GSLayoutManager
	-setAttachmentSize:forGlyphRange:].

	* Source/NSLayoutManager.m (-drawGlyphsForGlyphRange:atPoint:):
	Implement drawing of attachments.

	* Headers/gnustep/gui/NSFont.h: Add GSAttachmentGlyph to mark
	attachments in a glyph context.

	* Source/GSHorizontalLayoutManager.m: Cleanups and comments.
	(-layoutLineNewParagraph:): Rewrite line height and baseline
	handling. Implement typesetting of attachments.

	* Headers/gnustep/gui/NSTextAttachment.h: Add documentation.

	* Source/NSTextAttachment.m (-cellFrameForTextContainer:
	proposedLineFragment:glyphPosition:characterIndex:): Return the
	correct position.

Thu Jan 30 16:31:16 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GNUmakefile (NSMenuItem.m_FILE_FLAGS): Use -Wno-protocol
	when compiling NSMenuItem.m

Thu Jan 30 16:19:56 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* TextConverters/RTF/RTFConsumer.m
	([RTFConsumer +parseData:documentAttributes:]): Method removed.
	([RTFConsumer +parseFile:documentAttributes:]): Method removed.
	([RTFDConsumer +parseData:documentAttributes:class:]): New method,
	replacing +parseData:documentAttribute:.

Thu Jan 30 05:12:21 2003  Serg Stoyan <stoyan@hologr.com>

	* Headers/gnustep/gui/NSMenuItem.h: NSMenuItem protocol conforms
	to NSObject protocol.
	* Source/NSBundleAdditions.m ([-instantiateObject:]): Added
	missing cast.
	* Source/NSImage.m ([-dissolveToPoint:fromRect:fraction:]): Added
	missing variable initializer.
	([-_bestRep:withBpsMatch:]): The same.
	* Source/NSImageRep.m ([-drawAtPoint:]): Added missing variable
	initializer.
	* Source/NSSplitView.m ([-mouseDown:]): The same.
	* Source/NSStringDrawing.m (drawRun): Fixed compiler warning.
	* Source/NSTableHeaderCell.m ([-setHighlighted:flag]): New method.
	* Source/NSTableHeaderView.m ([-drawRect:]): Removed calls to
	setBackgroundColor:.
	([-mouseDown:]): Use setHighlighted:, not setBackgroundColor:, to
	highlight a header cell.
	* Source/NSTableView.m ([-mouseDown:]): Added missing variable
	initializer.
	* Headers/gnustep/gui/NSView.h: Added declaration of
	lockFocusInRect:
	* Source/NSView.m ([-lockFocusInRect:]): Added missing variable
	initializer.
	* Source/NSWindow.m: Include NSToolbar.h
	
Thu Jan 30 04:55:12 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/gui/NSToolbar.h: Declaration of GNUstepPrivate
	category moved here from NSToolbar.m.
	* Source/NSToolbar.m: Removed GNUstepPrivate category @interface.
	* Source/NSWindow.m ([-setToolbar:]): Added missing cast.
	
Thu Jan 30 04:39:47 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSWindowController.m ([-dealloc]): Release the window, do
	not autorelease it.

Thu Jan 30 03:57:42 2003  Serg Stoyan <stoyan@hologr.com>
	
	* Source/NSMenuView.m ([-sizeToFit]): Removed the additional 17
	pixels from menu view title size, they have no reason to be used,
	and don't look good.

Thu Jan 30 02:55:17 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSScrollView.m ([-scrollPageDown:], [-scrollPageUp:]): Do
	not mark rulers as needing redisplay.
	([-scrollWheel:]): Do not scroll header view; do not mark rulers as
	needing redisplay.

Thu Jan 30 02:51:49 2003  Benhur Stein <benhur@inf.ufsm.br>
	
	* Source/NSScrollView.m ([-_doScroll:]): Do not scroll header
	view; do not mark rulers as needing redisplay.
	([-reflectScrolledClipView:]): Mark the rulers as needing
	redisplay.  Do not constrain the scrollpoint of the header view.

2003-01-29 21:14  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-setTextStorage:): Tell our text
	containers about the change.

	* Source/NSTextContainer.m (-setLayoutManager:): Tell our text view
	about the change.

	* Source/NSTextView.m: Guard in a few places where _layoutManager
	might be nil.

2003-01-29 16:01  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:): Place
	baseline higher (in relation to the line height).

	* Source/NSLayoutManager.m (-textStorage:edited:range:changeInLength:
	invalidatedRange:): Fix selection range adjustment when the entire
	selection is removed.

2003-01-29 01:40  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSTextView.h, Source/NSTextView.m: Implement
	basic drawing of insertion point.

2003-01-28  Fred Kiefer <FredKiefer@gmx.de>

	* TextConverters/RTF/RTFConsumer.m
	In [copyWithZone:] use mutable copy of prargraph style.
	
2003-01-28 23:29  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-setConstrainedFrameSize:) Fix calculation of
	the effective minimum size.

	(-sizeToFit): Use maximum x and y of used rect to calculate size, not
	the used rect's own size.

2003-01-28 22:54  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m (-textStorage:edited:range:changeInLength:
	invalidatedRange:): Add code to adjust the selected range after each
	change.

2003-01-28 22:20  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m (-initWithFrame:textContainer:): Make the
	default text container inset (2,0).

2003-01-28 20:02  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter: Set proper used rect for line frag
	rects.

	* Source/GSLayoutManager.m (-usedRectForTextContainer:): Return sane
	value if there are no line frag rects in the text container.

2003-01-28 17:55  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSLayoutManager.m (-layoutLineNewParagraph:): Try to make
	sure each container gets at least one line frag rect.

	* Source/NSTextView: Avoid making calls to the layout manager with
	invalid arguments.

2003-01-28 17:40  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSHorizontalTypesetter.m, Source/GSLayoutManager.m:
	Whitespace cleanups and comments.

	* Source/NSLayoutManager.m: (-rectArrayForGlyphRange:
	withinSelectedGlyphRange:inTextContainer:rectCount:): Give better
	error message for an invalid glyph range.

2003-01-27 16:13  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m (-setHyphenationFactor:): Fix format
	string.

	* Source/NSTextView.m (-mouseDown:): Handle empty text views.
	(-drawRect:): Always draw glyphs' backgrounds (even when not drawing
	the text view's background).

Mon Jan 27 04:01:32 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSScroller.m ([-mouseDown:]): When the knob slot if
	clicked, do not set the new float value and send the action if the
	float value has not changed.
	
Mon Jan 27 03:16:22 2003  Benhur Stein <benhur@inf.ufsm.br>

	Patch with minor changes by Nicola:
	* Source/NSScroller.m ([-testPart:]): The point to test is now
	assumed to be in the window's coordinates.
	([-mouseDown:], [-trackScrollButtons:]): Updated calls to
	-testPart:.
	([-drawArrow:highlight:]): Highlight the cell according to the
	argument.
	([-trackKnob:]): Do not set the new float value and send the
	action if the float value has not changed.
	
Mon Jan 27 01:21:11 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GSLayoutManager.m (GET_GLYPH): Removed argument, and
	updated all callers, to get it to compile.

2003-01-27 00:01  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m (-drawBackgroundForGlyphRange:atPoint:):
	Draw background for the selected range.

2003-01-26 21:16  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m
	(-textStorage:edited:range:changeInLength:invalidatedRange:): Tell
	the text views to resize when their text has changed.

2003-01-26 21:08  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m
	(-glyphIndexForPoint:inTextContainer:fractionOfDistanceThroughGlyph:):
	Try harder to always return a valid glyph index.

2003-01-26 20:41  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSTextView.h: Don't use protocol forward
	declarations.

2003-01-26 20:35  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextView.m: Make sure the typing attributes are always
	a mutable dictionary we can modify.

2003-01-26 20:30  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSCell.m: Add missing includes.

2003-01-26 20:24  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSMenu.h: Add missing class declaration
	so the header is self-contained.

2003-01-26 19:17  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSFontInfo.h, Headers/gnustep/gui/NSFont.h,
	Headers/gnustep/gui/NSLayoutManager.h, Headers/gnustep/gui/NSText.h,
	Headers/gnustep/gui/NSTextContainer.h,
	Headers/gnustep/gui/NSTextStorage.h,
	Headers/gnustep/gui/NSTextView.h, Source/GNUmakefile,
	Source/GSFontInfo.m, Source/GSTextStorage.m, Source/NSFont.m,
	Source/NSLayoutManager.m, Source/NSParagraphStyle.m,
	Source/NSSecureTextField.m, Source/NSText.m,
	Source/NSTextContainer.m, Source/NSTextStorage.m,
	Source/NSTextView.m, Headers/gnustep/gui/GSHorizontalTypesetter.h,
	Headers/gnustep/gui/GSLayoutManager.h,
	Headers/gnustep/gui/GSLayoutManager_internal.h,
	Headers/gnustep/gui/GSTypesetter.h, Source/GSHorizontalTypesetter.m,
	Source/GSLayoutManager.m, Source/GSTypesetter.m,
	Source/NSTextView_actions.m: Merge in text-system-branch with the new
	implementation of the text system.

2002-12-13 02:00  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSText.h, Headers/gnustep/gui/NSTextView.h,
	Source/NSText.m, Source/NSTextView.m: Moved ivars from NSText to
	NSTextView. Added or updated documentation for many methods. Marked
	primitive and non-openstep methods.

	* Source/GSHorizontalTypesetter.m, Source/GSLayoutManager.m,
	Source/GSTextStorage.m, Source/NSTextContainer.m,
	Source/NSTextStorage.m: Cleaned up includes.

2002-12-01 13:27  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m: Clean ups. Remove some old stuff. Add
	some more comments.

2002-11-26 16:37  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSTypesetter.h, Source/GSTypesetter.m,
	Source/GSHorizontalTypesetter.m: Remove
	-baselineOffsetInLayoutManager:glyphIndex: method. Cleanups. Changed
	to conform to coding standards.

2002-11-26 16:29  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSLayoutManager.m: Changed to conform to coding
	standards. Cleanups.

2002-11-26 15:41  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSLayoutManager_internal.h,
	Source/GSLayoutManager.m: Changed to conform to coding standards.
	Cleanups. Moved some more NSTextView references to NSLayoutManager.

	Use _run_cache_attributes::, _run_copy_attributes::, and
	_run_free_attributes: methods instead of functions.

	(-_run_cache_attributes::): Ask typesetter for font to use and call
	-substituteFontForFont:.

	* Source/NSLayoutManager.m: Moved NSTextView references here.

2002-11-26 12:52  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSFontInfo.h, Headers/gnustep/gui/NSFont.h,
	Source/GSFontInfo.m, Source/NSFont.m: Add proper handling of
	screen/printer fonts. Changes the backend GSFontInfo interface.

2002-11-24 20:58  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSMenu.h: Declare NSMutableArray.

2002-11-24 01:10  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSSpellChecker (-_launchSpellCheckerForLanguage:): Don't
	pass the error message through printf expansion twice.

2002-11-24 00:56  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSFontInfo.m (-defaultLineHeightForFont): Round the linegap
	to whole points.

2002-11-23 22:55  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSSecureTextField: Update to work with new text system.

2002-11-23 22:30  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/NSTextContainer.h,
	Headers/gnustep/gui/NSTextStorage.h Source/NSTextStorage.m: Use
	GSLayoutManager instead of NSLayoutManager in these classes.

2002-11-23 21:40  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSParagraphStyle ([NSMutableParagraphStyle -copyWithZone:]):
	Implement.

2002-11-23 21:31  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/gui/GSHorizontalTypesetter.h,
	Headers/gnustep/gui/GSLayoutManager.h,
	Headers/gnustep/gui/GSLayoutManager_internal.h,
	Headers/gnustep/gui/GSTypesetter.h, Source/GSHorizontalTypesetter.m,
	Source/GSLayoutManager.m, Source/GSTypesetter.m,
	Headers/gnustep/gui/NSLayoutManager.h, Source/GNUmakefile,
	Source/NSLayoutManager.m: Add the new text system.

2002-11-23 18:45  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSTextContainer: Implement -lineFragmentRectForProposedRect:
	sweepDirection:movementDirection:remainingRect:.

2003-01-26 18:54  Alexander Malmberg  <alexander@malmberg.org>

	* Headers/gnustep/gui/NSParagraphStyle.h,
	Headers/gnustep/gui/NSTextStorage.h, Source/NSParagraphStyle.m,
	Source/NSTextAttachment.m: Clean up the includes.

2003-01-26 18:46  Alexander Malmberg  <alexander@malmberg.org>

	* Headers/gnustep/gui/NSGraphics.h,
	Headers/gnustep/gui/NSGraphicsContext.h, Source/NSGraphicsContext,
	Source/NSWindow.m: Clean up some prototypes.

2003-01-20  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/gui/NSImage.m (NSImageCacheMore): New enum and ivar.
	* Source/NSImage.m (-setCacheMode:): New method.
	(-cacheMode): Idem.
	(-compositeToPoint:fromRect:operation:): If printing, composite from
	source image, not cache.
	(-dissolveToPoint:fromRect:fraction:): Idem.
	(-drawRepresentation:inRect:): Correct background rectfill for
	flipped views.
	(-bestRepresentationForDevice:): Rewrite. Close to being correct.

Tue Jan 21 00:39:52 2003  Serg Stoyan <stoyan@on.com.ua>

	* Source/NSMenu.m ([-performKeyEquivalent:]): Only perform the
	higlighting if the item is enabled.
	* Source/NSMenuView.m
	([-performActionWithHighlightingForItemAtIndex:]): Run the run
	loop for a fraction of a second before executing the action, so
	that the highlighted item is displayed.  Do not remove the
	highlighted item if a popup menu.
	* Source/NSPopUpButton.m ([-mouseDown:]): Leave the selection
	unchanged if the item which was selected is disabled.
	([-performKeyEquivalent:]): Mark the popup button as needing
	redisplay if the key equivalent is performed.
	
Mon Jan 20 00:37:39 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSWorkspace.m ([NSWorkspace +initialize]): Wrap in
	an exception handler so we are sure to release the lock.

2003-01-14  Adam Fedor  <fedor@gnu.org>

	* Source/NSSound.m ([NSSound +gsnd]): Rename daemon to gnustep_sndd
	* Tools/gsnd/GNUmakefile: Idem.

Thu Jan  9 05:17:22 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSApplication.m ([-_appIconInit]): If no app icon has
	been set, set GNUstep as the applicationIcon by calling
	setApplicationIconImage: so that the default image gets also
	registered with name NSApplicationIconImage.

2003-01-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTextView.m
	Changed all the internal methods ([replaceCharacterRange:withString:], 
	[setFont:range:], [setTextColor:range:], [setalignment:range:], 
	[replaceRange:withAttributedString:], [setAtrributes:range:]) not
	to call [shouldChangeTextInRange:replacementString:], so that they
	can be called for a non editable text view.
	Added this call to the methods: [insertText:], [transpose:],
	[changeColor:], [alignCenter:], [alignLeft:], [alignRight:],
	[alignJustified:], [readSelectionFromPasteboard:type:].
	* Source/NSCell.m
	In [selectWithFrame:...length:] removed duplicate setting of delegate.
	* Source/NSBrowserCell.m
	Use method calls in [initWithCoder:] to get fontification correct.
	* Source/NSClipView.m
	Use method calls in [initWithCoder:] so opaque flag is set
	correctly.

Tue Dec 31 16:30:32 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Model/GNUmakefile: Build gmodel bundle when GUI_LIB is gnu, not
	when it's not (Suggestion by Pete French <pete@twisted.org.uk>).

Mon Dec 30 18:29:41 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Model/GNUmakefile: Updated all checks for library-combo.

Sun Dec 29 12:27:35 2002  Gregory John Casamento  <greg_casamento@yahoo.com>

	* Headers/gnustep/gui/GSNibTemplates.h: Added declaration for
	class GSFontProxy.
	* Source/NSBundleAdditions.m: Added definition for class 
	GSFontProxy.  This class handles the fall back which is 
	necessary when unarchiving NSFont when the specified font is 
	unavailable.   Modified unarchiving code to use the new
	class when unarchiving.
	* Headers/gnustep/gui/NSToolbarItem.h: Corrected spelling of
	NSToolbarFlexibleSpaceItemIdentifier.
	* Source/NSToolbarItem.m: Did some initial work on the
	default toolbar items.
	* Source/externs.m: Corrected spelling of
	NSToolbarFlexibleSpaceItemIdentifier.
	
	
Sat Dec 28 01:42:40 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSWindow.m ([-_initBackendWindow:]): Fixed code resetting
	then restoring the drag types for a deferred window -- there was a
	small confusion where NSArray and NSCountedSet were used
	interchangeably, while they are not.  Drag&drop now works with
	deferred windows for me.

Wed Dec 25 17:01:51 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/gui/NSText.h ([-setFont:range:]): Declare.
	* Source/NSTextView.m ([-setFont:ofRange:]): Renamed to
	setFont:range:.
	* Source/NSText.m ([-setFont:range:]): New method.
	([-setFont:ofRange:]): Call the new method.

2002-12-23  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/NSComboBoxCell.h
	Removed unused ivars and added one to store the popup while open.
	* Source/NSComboBoxCell.m
	Moved popup positioning to GSComboWindow, rewrote popup size code
	to respect numberOfItems and to adopt the used matrix. New methods
	for the cell to popup interaction. 
	Corrected the encoding code of NSComboBoxCell. [objectValues] now
	correctly warns in the data source case. New method
	[stringValueAtIndex:]. Hack in [_didClick:] to get setting of
	values working. 
	
2002-12-22  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSToolbar.m: Added some of the code needed to add/remove
	toolbar items. 
		
2002-12-10  Adam Fedor  <fedor@gnu.org>

	* Source/NSView.m ([NSView -lockFocusInRect:]): Check for window iff
	not printing.
	([NSView -unlockFocusNeedsFlush:]): Idem.
	([NSView -displayIfNeededInRectIgnoringOpacity:]): Idem.
	([NSView -displayRectIgnoringOpacity:]): Idem.

2002-12-10  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSImageView.m
	Use [mouseDown:] instead of [mouseDragged:] to start dragging as
	the later only works when the view is not first responder.
	
2002-12-05  Adam Fedor  <fedor@gnu.org>

	* Source/GSSimpleLayoutManager.m ([GSSimpleLayoutManager
	-setNeedsDisplayForLineRange:inTextContainer:]): Make sure view
	exists before trying to get range (Solaris limitation).

2002-12-04  Adam Fedor  <fedor@gnu.org>

	* Source/GSSimpleLayoutManager.m ([GSSimpleLayoutManager
	-textStorage:edited:range:changeInLength:invalidatedRange:]): Make
	sure view exists before trying to get range (Solaris limitation).

	* Source/NSPrintOperation.m: Update for change in GSSetLocale.

2002-12-04  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/gui/DPSOperators.h (DPSPrintf): Remove inline
	attribute which caused compiler errors on FreeBSD (patch from Pete
	French <pete@twisted.org.uk>).

2002-12-05  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBitmapImageRep.m
	In [TIFFRepresentationUsingCompression:factor:] set extraSamples
	and correct compression type if 0.
	* Source/NSImageView.m
	Implement dragging of images.

2002-12-02  Adam Fedor  <fedor@gnu.org>

	* Model/GMAppKit.m, Model/GMArchiver.m, Model/IBClasses.m,
	Model/IMConnectors.m, Model/IMCustomObject.m, Model/IMLoading.m,
	Model/Translator.m: Include model headers from gnustep/gui
	not AppKit.
	* Model/GNUmakefile: Install headers in gnustep/gui

2002-11-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Model/IMConnectors.m: Update ivar setting code.

2002-11-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundleAdditions.m: Quick hack for setting ivars.

2002-11-27  Adam Fedor  <fedor@gnu.org>

	* Source/NSTabView.m ([NSTabView -selectedTabViewItem]): Check
	that the array count is > 0

2002-11-24  Adam Fedor  <fedor@gnu.org>

	* Tools/example.m: Include NSProcessInfo.h 

2002-11-24  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/NSSavePanel.h
	* Headers/gnustep/gui/NSOpenPanel.h
	* Source/NSSavePanel.m
	* Source/NSOpenPanel.m
	Added new MacOSX methods.

2002-11-24  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBezierPath.m
	Corrected [GSBezierPath appendBezierPath:] to check the class of
	the parameter and to keep the isFlat flag in sync.
	* TextConverters/RTF/RTFConsumer.m
	GSRTFregisterFont() handle fontnames with and without trailing ';'.
	* TextConverters/RTF/rtfGrammer.y
	Documented how to compile with recent bison releases.
	Removed one conflict and an unneeded terminal.
	Allow for additional blocks in font definition.
	* TextConverters/RTF/rtfGrammer.tab.h
	Regenerated with bison 1.35
	* TextConverters/RTF/rtfGrammer.tab.c
	Regenerated with bison 1.35 and corrected yyparse declaration.
	* TextConverters/RTF/rtfScanner.c
	Redefined GSRTFlex() without location parameter. Some cleanup
	against compiler warnings.
	
2002-11-21  Adam Fedor  <fedor@gnu.org>

	* Version: 0.8.3

2002-11-21  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSGraphicsContext.m
	Rewrote [GSSendBezierPath:] to send the full path to the
	backend. Code comes from [NSBezierPath _doPath].
	* Source/NSBezierPath.m
	Replaces [_doPath] with calls to [NSGraphicsContext
	GSSendBezierPath:]. 
	Added optimisation methods [appendBezierPath:] and
	[transformUsingAffineTransform:] on GSBezierPath.
	
2002-11-18  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSBundleAdditions.m: Added some logic in the initWithCoder
	method to handle different gorm file versions.  Even though there
	is only one version currently, we need this in place.
	* Headers/gnustep/gui/GSNibTemplates.h: Added #define for 
	GNUSTEP_NIB_VERSION.
	
2002-11-17  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSCell.m
	* Source/NSButtonCell.m
	* Source/NSMenuItemCell.m
	* Source/NSOutlineView.m
	* Source/NSPopUpButtonCell.m
	* Source/NSSplitView.m
	Removed unneeded includes.
	* Source/NSRulerView.m
	Rewrote [drawHashMarksAndLabelsInRect:] to use string drawing and
	bezier path code instead of direct PS operations.

2002-11-16  Frederic De Jaeger <dejaeger@free.fr>

	* Source/NSOpenGLPixelFormat.m, Source/NSOpenGLContext.m,
	  Source/NSOpenGLView.m, Headers/AppKit/NSOpenGL.h,
	  Headers/AppKit/NSOpenGLView.h: New files.
	* Source/Makefile: Updated accordingly.
	* Headers/AppKit/GSDisplayServer.h (glContextClass, 
	glPixelFormatClass): New methods.
	* Source/GSDisplayServer.m: Implement.

2002-11-15  Adam Fedor  <fedor@gnu.org>

	* Model/GMAppKit.m ([NSColor -encodeWithModelArchiver:]): Encode
	named colors.
	([NSColor +createObjectForModelUnarchiver:]): Decode them.

2002-11-13  Adam Fedor  <fedor@gnu.org>

	* Model/IMLoading.m ([GMModel -objects]): New.
	([GMModel -connections]): Idem.

2002-11-12  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/gui/AppKit.h: Add NSDocumentController.

	* Source/NSSavePanel.m ([NSSavePanel -ok:]): Display filename
	(with extension) if replacing.

2002-11-12 20:40  Alexander Malmberg  <alexander@malmberg.org>

	* Source/NSTableView (-setDataSource:): Allow nil data source.

2002-11-10  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSSimpleLayoutManager.m
	* Source/NSOutlineView.m
	Removed compiler warnings by correcting method names.
	* Source/NSBezierPath.m
	* Source/NSOpenPanel.m
	* Source/NSStringDrawing.m
	Corrected includes to speed up compilation.
	
2002-11-10  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSComboSupport.h
	* Source/GSComboSupport.m
	Removed files.
	* GNUmakefile
	Removed GSComboSupport.m
	* Source/NSComboBoxCell.m
	Moved all ComboBox code to here to make further changes easier.
	* Headers/gnustep/gui/NSSound.h:
	Prefixed all ivars with underscore
	* Source/NSSound.m
	Adopted to change in header and simplified [copyWithZone:] and 
	[initWithCoder:].
	
2002-11-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDocumentController.m: Don't try to store NSURL objects in
	defaults system.

2002-11-08  Adam Fedor  <fedor@gnu.org>

	* Source/NSSavePanel.m ([NSSavePanel -_shouldShowExtension:isDir:]): 
	Filter regular files also.

	* Source/NSMenu.m ([NSMenuPanel -canBecomeKeyWindow]): Return
	YES only if we are the main menu.
	* Source/NSWindow.m ([NSWindow -sendEvent:]) (FocusIn): If we are
	the main menu, try to find another window to become key.	

2002-11-07  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSCell.m
	in [initImageCell:] and [initTextCell:] set the default menu.
	In all [XXXValue] methods try to get the value from the objectValue
	first and use [stringValue] instead of accessing the contents directly.
	Removed AUTORELEASE calls from [attributedStringValue] and similar
	places. 
	In [cellSize] use [attributedStringValue] to get the string to size.
	In [drawInteriorWithFrame:inView:] use [attributedStringValue] to
	get the string to draw. This make the method [_drawText:inFrame:]
	obsolete for this class, but subclasses still use it.
	New method [_setupTextWithFrame:inView:editor:] with the common
	text view setup from [editWithFrame:inView:editor:delegate:event:]
	and [selectWithFrame:inView:editor:delegate:start:length:].
	Calls to [setFont:] and [setAlignment:] switch the cell to
	NSTextCellType.
	* Source/NSButtonCell.m
	Removed all direct usage of ivar _contents. Implemented
	[attributedAlternateTitle] and use this in [cellSize] and 
	[drawInteriorWithFrame:inView:].
	* Headers/gnustep/gui/NSDragging.h:
	Added some new MacOSX values to NSDragOperation and some new methods.
	
2002-11-06  Adam Fedor  <fedor@gnu.org>

	* Source/NSTableView.m ([NSTableView -drawRow:clipRect:]):Swapped
	sides of while statement && operator to check for _numberOfColumns
	first.
	([NSTableView -drawGridInClipRect:]): Idem.
	Also remove some unused variables.
	([NSTableView -mouseDown:]): Select the drag row if it's not currently
	selected. Simplify some code (do all selecting in one place).
	(-mouseDown2:): Remove commented out method.
	([NSTableView -draggingUpdated:sender]): scrollRowToVisible if we
	are dragging near edges of view.

2002-11-02  Lyndon Tremblay  <humasect@shaw.ca>

	* NSTableView.m ([NSTableView -columnAtPoint:]): Swapped sides of
	while statement && operator to check for _numberOfColumns first.

2002-11-01   Lyndon Tremblay <humasect@shaw.ca>

	* Source/NSBitmapImageRep.m ([NSBitmapImageRep -draw]): Cast
	argument 11 for NSDrawBitmap() to remove warning.

2002-11-04  Adam Fedor  <fedor@gnu.org>

	* Source/NSWorkspace.m ([NSWorkspace -_workspaceApplication]): 
	Change default to GWorkspace.

2002-11-02  Adam Fedor  <fedor@gnu.org>

	* Source/NSWindowController.m (-setDocument:): Remove window's
	setReleasedWhenClosed when doc is not nil.
	(-setWindow:): Idem.
	(Pointed out by Stefan Urbanek).

2002-11-02  Adam Fedor  <fedor@gnu.org>

	* Source/NSParagraphStyle.m (-compare:): Correct the comparision of
	NSTextTabs.
	* Source/NSScrollView.m (-tile:): Add a call to setNeedsDisplay.
	* Source/NSRulerMarker.h: Correct a mispelling in a method name 
        makerLocation to markerLocation.
	* Source/NSTextView.m: Idem.
        (-rulerView:didAddMarker:) Create a new NSTextTab corresponding
        to the marker.
        (-rulerView:handleMouseDown:) Ask rulerview to track a new
        marker, instead of simply adding a new marker
	* Source/NSRulerView.m: Remove some unused macros.
        (-_verifyReservedThicknessForMarkers, _rulerRect, _markersRect,
	-markerAtPoint:): New private.
	(-trackMarker:withMouseEvent:): Implement.
	(-mouseDown:) Track marker if click was on marker, or asks
	client to handle if click was on ruler area.
	* Source/NSRulerMarker.m: -trackMouse:adding:): Implement.
	(Patches from Benhur Stein <benhur@inf.ufsm.br>).

2002-11-01  Adam Fedor  <fedor@gnu.org>

	* Source/NSApplication.m (-finishLaunching): Instantiate an
	NSDocumentController if this is a doc-based app.
	(-targetForAction:): Check if NSDocumentController responds
	to action if this is a doc-based app.

	* Source/NSDocument.m (-close): Rewrite to deal with removing
	objects from array while enumerating.
	* Source/NSDocumentController.m (-closeAllDocuments): Idem.
	(-sharedDocumentController): Don't set ourselves as the app delegate.
	(-isDocumentBasedApplication): Method for NSApplication.

	* Source/NSWindow.m (-sendEvent:): Retain _lastView
	just in case it's a temporary view.	

2002-10-31  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSBundleAdditions.m: 
	+[loadNibFile:externalNameTable:withZone:]: Added logic
	to load .gorm directories and also maintained backwards compatibility
	with .gorm files.
	
2002-10-29  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSSplitView.m ([NSSplitView -resizeSubviewsWithOldSize:]):
	Move code from setFrame: & resizeWithOldSuperviewSize:
	to resizeSubviewsWithOldSize:.

	* Source/NSColorPanel.m ([NSColorPanel _initWithoutGModel]):
	make the window a little bit higher. Some ColorPickers would not fit.
	* ColorPickers/GSCMYKColorPicker.tiff:
	* ColorPickers/GSGrayColorPicker.tiff:
	* ColorPickers/GSHSBColorPicker.tiff:
	* ColorPickers/GSRGBColorPicker.tiff:
	resize so that the image fits within the NSButton. 
	(only blank area was removed)


2002-10-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/gui/GSMethodTable.h:
	* Headers/gnustep/gui/PSOperators.h:
	Add const qualifier to PSPrintf and PSWriteData argument types to
	match all other declatrations.
	* Headers/gnustep/gui/NSMenu.h: Add and document validation protocol.
	* Headers/gnustep/gui/NSMenuItem.h: Add some documentation and tidy.

2002-10-28  Adam Fedor  <fedor@gnu.org>

	* Source/NSTextView.m (-drawRect:): Don't draw insertion point
	when printing.

	* PrinterTypes/GSProlog.ps: New file.
	* Source/NSView.m (-_loadPrinterProlog): New.
	(beginPage:...): Use it.

2002-10-28  Adam Fedor  <fedor@gnu.org>

	* Source/NSScreen.m (-visibleFrame): Don't include dock
	with NexT/WindowMaker styles (patch from Stefan <urbanek@host.sk>).

2002-10-28  Adam Fedor  <fedor@gnu.org>

	* Source/NSPrintOperation.m (-cleanUpOperation): Order out print
	panel.
	(-_runOperation): Use autorelease pool around operation.
	(-init): Create a proper, unique temp print file.
	(-deliverResult): Implement for previewing, spooling.
	* Source/NSPrintPanel.m (-runModel): Don't order self out.
	(-_setStatusStringValue:) New private method.

2002-10-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTextField.m: ([-dealloc]) morph self to be an NSTextView
	so that when dealloc is re-called, any subclass dealloc methods
	don't get re-called.
	* Source/NSTableView.m: Memory leak fix added as suggested by
	Stefan Urbanek.  NOTE ... selection code looks very inefficient,
	perhaps we should look into whether it is worth optimising?

2002-10port-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSMenuView.m ([NSMenuView -trackWithEvent:]): 
	new tracking code. The menu feels snappier now (at least for me).
	
	* Source/NSColorWell.m ([-activate:], [-deactivate])
	register/unregister for NSColorPanelColorChangedNotification.
	([NSColorWell _takeColorFromPanel:]): new method to prevent endless
	loop when setting the well's color from the color panel.
	([NSColorWell -initWithCoder:]): register for NSColorPboardType.
	
	* Source/NSColorPanel.m ([NSColorPanel -_bottomWellAction:]):
	called when hitting one of the well at the bottom of the panel.
	Previous behaviour would not send a 
	NSColorPanelColorChangedNotification.
	([NSColorPanel -initWithCoder:]): update bottom wells construction to
	call _bottomWellAction: instead of takeColorFrom:.

2002-10-26  Adam Fedor  <fedor@gnu.org>

	* Source/NSOutlineView.m (-drawRow:clipRect:): Release imageCell
	(patch from Stefan <urbanek@host.sk>).

2002-10-25  Adam Fedor  <fedor@gnu.org>

	* Source/NSApplication.m: Remove some NSDebugLogs.

	* Source/NSDocument.m
	(-fileNameFromRunningSavePanelForSaveOperation:): Set directory to
	the currentDirectory if no fileName is set. Localize.
	(-fileAttributesToWriteToFile:ofType:saveOperation:): Stub implement.
	* Source/NSDocumentController.m: Document.
	(+sharedDocumentController): Proper allocation/init. Set ourselves
	as the application delegate if there isn't one already.
	(-init): Retrieve list of recent documents.
	(-reviewUnsavedDocumentsWithAlertTitle:cancellable:): Save
	current directory. Localize.
	(-currentDirectory): Rewrite according to docs.

	* Source/NSOpenPanel.m (-runModalForTypes:): Use nil for
	directory.
	* Source/NSSavePanel.m (_setupForDirectory:file:): Use
	current directory if nil, otherwise keep the old one.
	(-runModal): Pass nil for directory.

2002-10-25  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* configure.ac: fixed header/ldflags for freebsd.

2002-10-21  Adam Fedor  <fedor@gnu.org>

	* Source/GSFontInfo.m (+encodingForRegistry:encoding:): Remove.

Tue Oct 22 02:13:55 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Resources/GNUmakefile (string): Renamed to after-strings so 
	that it works with the new gnustep-make strings targets.

2002-10-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSView.m: Key view code ... complete rewrite to match
	MacOS-X implementation.  Fix coding bug in rewrite.
	* Source/NSTextField.m: don't use _nextKeyView
	* Source/NSMatrix.m: don't use _nextKeyView

Mon Oct 21 01:17:41 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSView.m ([-setNextKeyView:], [-setPreviousKeyView:]):
	Rewritten the way the next/previous key view chain is managed, to
	fix problem when a next/previous key view is replaced with a new
	one (Patch by Caba Conti modified).

2002-10-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/gui/NSComboBox.h: Add APPKIT_EXPORT and make layout
	a bit more consistent. 
	* Source/NSTextView.m: ([-dealloc]) remove unneeded RETAIN()
	Fixes for beugs reported by Caba Conti.

2002-10-18  Adam Fedor  <fedor@gnu.org>

	* Documentation/announce.texi: Fix grammer.

	* Try to fix focus interaction with WindowMaker.
	* Source/NSApplication.m ([NSIconWindow -canBecomeKeyWindow]):
	Revert 2002-10-08 change.
	(-appIconInit): Don't set input focus to app icon.
	(-_windowWillClose:): Idem.
	* Source/NSMenu.m: New class NSMenuPanel
	(_createWindow): Use it.
	* Source/NSWindow.m (-_lossOfKeyOrMainWindow): Make sure menu
	window doesn't get key except as a last resort.
	(-sendEvent: (GSAppKitWindowFocusIn)): Don't become key if app 
	is hidden.

	* Source/NSPanel.m (-sendEvent:): Same as change to NSWindow on
	2002-10-03.

	* Source/NSDocument.m (-init): Set default file type.

Tue Oct 15 02:36:32 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSApplication.m (initialize_gnustep_backend): Get the
	GSBackend class using NSClassFromString() rather than NSBundle's
	-classNamed: to make it more robust on platforms - eg MS Windows -
	which have unclear problems with dynamic loading.

2002-10-14  Adam Fedor  <fedor@gnu.org>

	* Version: 0.8.2
	* Documentation/news.texi: Update.

Mon Oct 14 02:24:45 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSSavePanel.m (browser:createRowsForColumn:inMatrix:):
	Fixed last change which had broken the GSFileBrowserHideDotFiles
	option.

2002-10-13  Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/GSNibTemplates.h: Added parentClassName member to 
	templates so that the parent of the custom class could be stored.
	* Source/NSBundleAdditions.m: Made necessary modfications to the
	template implementations to use the parent class name

2002-10-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSavePanel.m: ([--browser:createRowsForColumn:inMatrix:])
	Don't try to read .hidden file for processing unless it exists.
	* Source/DocMakefile: New makefile for building documentation
	without having to build binaries. Also add flag for macros template.
	* Source/GNUmakefile: Removed documentation building rules.
	* Documentation/GNUmakefile: Use DocMakefile
	* Source/NSWindow.m: Slight documentation update/addition.
	* Source/NSView.m: ditto.
	* Source/NSToolbar.m: ditto.
	* Source/NSTextView.m: ditto.
	* Source/NSMatrix.m: ditto.
	* Source/NSLayoutManager.m: ditto.

2002-10-11  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/gui/NSOpenPanel.h: Move comments to source file
	as autogsdoc.
	* Headers/gnustep/gui/NSSavePanel.h: Idem.
	* Source/NSOpenPanel.m: Document.
	* Source/NSSavePanel.m: Idem.

	* Source/NSBrowser.m: Change NSDebugLog to NSDebugLLog (or remove).
	* Source/NSButtonCell.m, Source/NSCell.m, Source/NSControl.m,
	Source/NSEvent.m, Source/NSFontManager.m, Source/NSFontPanel.m,
	Source/NSImageCell.m, Source/NSMatrix.m, Source/NSMenu.m,
	Source/NSMenuItem.m, Source/NSResponder.m, Source/NSRulerView.m,
	Source/NSScrollView.m, Source/NSSplitView.m, Source/NSStepper.m,
	Source/NSTableHeaderView.m, Source/NSWindow.m: Idem.

Fri Oct 11 15:10:42 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/gui/AppKit.h: Include AppKit/NSFileWrapper.h
	(Reported by Ludovic Marcotte <ludovic@Sophos.ca>).
	
Fri Oct 11 01:37:57 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* TextConverters/RTF/RTFConsumer.m ([RTFAttribute -currentFont]):
	If the font can't be found in the usual ways, try to get it as a
	composite font name like 'FontFamily-Face'
	(Patch by Georg Fleischmann <georg@vhf.de> modified).

Fri Oct 11 01:15:55 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSFont.m (getNSFont): If fontWithName:size: returns nil,
	try various approximations to get a font.

Fri Oct 11 01:02:24 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	Patch by Georg Fleischmann <georg@vhf.de>:
	* Source/NSFont.m ([NSFont -initWithName:matrix:fix:]): Release
	self and return nil if the font info is nil.  This makes
	[NSFontManager -convertFont:...] work.
	
Thu Oct 10 19:56:29 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSScrollView.m ([-scrollPageUp:]): Implemented.
	([-scrollPageDown:]): Implemented.  ([-pageUp:]):
	Implemented. ([-pageDown:]): Implemented.  
	* Source/NSTextView.m ([-pageDown:]): Implemented.
	([-pageUp:]): Implemented.
	(Patch by David Ayers <d.ayers@inode.at>).
	
Thu Oct 10 19:16:40 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSFontManager.m ([NSFontManager -fontMenu:]): Use 't'
	as key equivalent for the font panel.
	(Patch by David Ayers <d.ayers@inode.at>).

2002-10-10  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBezierPath.m
	Handle seting of an empty dash in [setLineDash:count:phase:]. 
	[_doPath] now always sends the dash pattern, even when empty.

2002-08-30  Georg Fleischmann
	
	* Source/NSWindow.m ([-constrainFrameRect]): Move window inside
	  screen, if window top is below screen.

2002-10-09  Adam Fedor  <fedor@gnu.org>

	* Source/NSApplication (hide:): Don't setinputfocus to the
	icon window.
	* Source/NSWindow.m (-sendEvent:) (GSAppKitWindowFocusIn): 
	If we're not visible, don't try to become main/key.

2002-10-08  Adam Fedor  <fedor@gnu.org>

	* Fix window focus problems.
	* Source/NSApplication.m ([NSIconWindow -canBecomeKeyWindow]): 
	return YES.
	(-finishLaunching): Don't make main menu key.
	([NSApplication -deactivate]): Don't setinputfocus to the
	icon window.

	* Add Quartz-like interface and overridable passing of
	colorspaces and fonts to backend.
	* Headers/gnustep/gui/NSFont.h (_fontRef): New ivar.
	* Source/NSFont (-fontRef): New method.
	(GSSetFont): Use it.
	* Source/GSFontInfo (-matrix): New method.
	* Headers/gnustep/gui/GSFusedSilica.h: New header
	* Headers/gnustep/gui/GSFusedSilicaContext.h: Idem.
	* GSFusedSilica.m: New file.
	* GSFusedSilicaContext.m: Idem.

Tue Oct  8 19:15:24 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSSecureTextField.m: Mostly rewritten.  Main changes -
	NSCoding protocol methods moved to the cell; implemented encoding;
	do not share the secure text field globally, just create one each
	time; create the secure text field in setupFieldEditorAttributes:
	and removed most other hacks.  Init methods of the secure text
	view rewritten to be simpler.  Do not register the secure text
	view for services.  Should no longer crash with the new internals.
	* Headers/gnustep/gui/NSSecureTextField.h: Prefix ivars with
	underscore.  Add setEchosBullets: and echosBullets methods to 
	the textfield as well as the cell.
	
Tue Oct  8 18:46:45 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSTextContainer.m ([-replaceLayoutManager:]): Retain the
	layout manager, then release it at the end; refresh the layout
	manager cached by the textview; do not set the layout manager's
	text storage manually.
	* Source/NSTextStorage.m ([-removeLayoutManager:]): Set the
	argument's text storage to nil before removing it from the array.
	
2002-10-08  Gregory John Casamento <greg_casamento@yahoo.com>

	* Headers/GSNibTemplates.h: Added new template class.
	* Source/NSBundleAdditions.m: Added implementation for new template
	class.  Improved some of the existing classes.

2002-10-08  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/NSButtonCell.h
	Adoped the enums NSButtonType and NSBezelStyle to the new MacOSX names.
	* Source/NSButtonCell.m
	[setButtonType:] use those new names. Corrected [cellAttribute:]
	and [setCellAttribute:] to use the right tests. [performClick:]
	now play the sound, if provided.
	
2002-10-07  Adam Fedor  <fedor@gnu.org>

	* Source/NSBrowser.m (-frameOfColumn:, -tile): Change distance
	between columns from 1 to 2. (Patch from Serg Stoyan
	<stoyan@hologr.com>)

	* Source/NSGraphicsContext.m (-GSSetFillColorspace:):Take
	void * argument 
	(-GSSetStrokeColorspace:): Idem.
	(-GSSetFont:): Idem.

2002-10-06  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSBundleAdditions.m: Implemented the following classes:
	NSWindowTemplate, NSViewTemplate, NSControlTemplate, NSTextTemplate,
	NSTextViewTemplate, NSMenuTemplate, GSClassSwapper.   These classes
	are used to allow the .gorm files to have placeholders for custom
	classes defined by the developer.   This is similar to the approach
	used in OPENSTEP 4.2/Mach and MOSX.
	* Headers/gnustep/gui/NSNibLoading.h: Removed declarations for classes
	which should be considered private to GNUstep.	
	* Headers/gnustep/gui/GSNibTemplates.h: Moved GSNibContainer,
	GSNibItem, GSCustomView here.   Added declarations for new template
	classes.
	
2002-10-04  Adam Fedor  <fedor@gnu.org>

	* Source/NSBrowser.m: Implement non-separated columns.
	(-setSeparatesColumns:): Remove borders if not separated.
	(-setTitled:): Return without chaging if we are not separated.
	(-frameOfColumn:): Compute properly with{out} separation.
	(-tile): Idem.
	(-initWithFrame:): Set maxVisibleColumns to 3.
	(-drawRect:): Draw properly with{out} separation.
	(Patch from Serg Stoyan <stoyan@hologr.com>).

2002-10-03  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/gui/NSWindow.h: New _lastView ivar.
	* Source/NSWindow.m (-sendEvent:): Use it instead of _lastDragView
	to remember mouseDown view.

2002-10-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSWorkspace.m: ([-getInfoForFile:application:type:])
	Make an exception for directories without file extensions ... never
	return plain type for them even if apps claim to open them.

Wed Oct  2 11:26:21 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSTextView.m
	([-shouldChangeTextInRange:replacementString:]): Immediately
	return NO if not editable; do not send out textShouldBeginEditing:
	and textDidBeginEditingNotification unless the textview is already
	first responder (Patch by David Ayers <d.ayers@inode.at>).

2002-10-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSWorkspace.m: ([-getInfoForFile:application:type:])
	Try to return a plain file type for directories which are openable
	by some app.

2002-10-01  Adam Fedor  <fedor@gnu.org>

	* Tools/gsnd/portaudio/pa_unix_oss/pa_unix_oss.c
	(PaHost_WatchDogProc): usleep can have a void return (Modified
	patch from Charles Philip Chan).

	* Source/NSBrowserCell.m (-drawInteriorWithFrame:inView:): 
	Use NSCompositeSourceOver.

Tue Oct  1 17:07:25 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GSSimpleLayoutManager.h (_lineLayoutInformation): Renamed
	to _lineLayoutInfo.
	* Source/GSSimpleLayoutManager.m: Updated for change.

Tue Oct  1 16:58:36 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSTextView.m ([NSTextView -moveToEndOfLine:]): Fixed
	moving to the end of 'one before the last' line.
	([NSTextView -moveToEndOfParagraph:]): Idem.

Tue Oct  1 16:40:29 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GSSimpleLayoutManager.m
	([-glyphIndexForPoint:inTextContainer:fractionOfDistanceThroughGlyph:]):
	Fix the insertion point positioning when clicking beyond the last
	character of a line in an NSTextView, or before the first one;
	special care to be used for the last line in the textview
	(Originated by a patch by David Ayers <d.ayers@inode.at>, modified
	by me).

2002-09-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFont.m: Rewrote code dealing with creation and destruction
	of font objects to remove holes in the original caching scheme and to
	optimimise font creation/destruction somewhat.  All font objects
	should now be handled by the cache, no matter how they are created.

2002-09-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFont.m: Replace caching code which never released fonts
	with a cache which only holds fonts as long as something is using them.

2002-09-26  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/gnustep/gui/NSBrowserCell.h
	Removed all references to coding.
	* Source/NSBundleAdditions.m
	Moved add on methods.
	* Source/NSImage.m
	Moved method [NSBundle pathForImageResource:] to here.
	* Source/NSSound.m
	Moved method [NSBundle pathForSoundResource:] to here.
	* Source/NSButton.m
	Removed the coder methods as they were just super calls. 
	
Wed Sep 25 03:37:27 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/gui/NSInterfaceStyle.h: Put include guards in
	the canonical form, by swapping them with #ifndef STRICT_OPENSTEP;
	this arrangement is more efficient when the file is included
	multiple times with GCC.

Wed Sep 25 03:30:35 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/gui/GSGuiPrivate.h: Redefine both _() and
	NSLocalizedString() to be wrappers for GSGuiLocalizedString()
	(Idea from Stefan Urbanek <urbanek@host.sk>).
	* Source/NSApplication.m: Use _() and NSLocalizedString()
	everywhere for localized strings, instead of
	GSGuiLocalizedString().  (NSAppKitUncaughtExceptionHandler):
	Small rearrangement of code to make it easier for make_strings
	to parse localization calls.
	* Source/NSDocument.m: Include GSGuiPrivate.h, and localize strings
	(from a patch by Stefan Urbanek <urbanek@host.sk>).
	* Resources/GNUmakefile: Completely rewritten to use
	resource-set.make to install the files; added experimental
	'strings' target which runs make_strings and updates the
	Localizable.strings files.
	* Resources/English.lproj/Localizable.strings: Updated using make
	strings.
	* Resources/Italian.lproj/Localizable.strings: Updated using make
	strings, then manually updated all translations; added missing ones.

Tue Sep 24 16:32:30 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	After discussions with David Ayers:
	* Source/NSCell.m ([-editWithFrame:inView:editor:delegate:event:]):
	Do not perform an immediate display of the textfield.
	([-selectWithFrame:inView:editor:delegate:start:length:]): Idem.
	* Source/NSTextField.m ([-becomeFirstResponder]): If the text
	field accepts first responder status, select its text.
	([-mouseDown:]): If not selectable, pass the mouse down to super.
	If selectable, and _text_object is not nil, pass the mouse down to
	the _text_object.  Else, try to get first responder status, and
	to start editing.

Tue Sep 24 03:29:55 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSSplitView.m: Cache the default notification center for
	the whole class.
	* Source/NSTextStorage.m: Idem.
	
Tue Sep 24 03:14:12 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSTextField.m ([-dealloc]): Implemented (Reported missing
	by David Ayers).
	* Source/NSDrawer.m ([-dealloc]): Remove the delegate from the
	notification center.
	* Source/NSMatrix.m ([-dealloc]): Idem.
	* Source/NSSplitView.m ([-dealloc]): Idem.
	* Source/NSTableView.m ([-dealloc]): Idem.
	* Source/NSTextStorage.m ([-dealloc]): Idem.
	* Source/NSWindow.m ([-dealloc]): Idem.
	* Source/NSToolbar.m ([GSToolbarButton -dealloc]): New method.
	([NSToolbar -dealloc]): New method.

Mon Sep 23 15:23:23 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSApplication.m (initialize_gnustep_backend): Improved
	error messages.  Try to be as descriptive and verbose as possible
	about what exactly went wrong when loading the backend fails.

2002-09-22  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBrowser.m
	Removed unused ivar _numberOfRows from NSBrowserColumn. 
	Made GSBrowserTitleCell a subclass of NSTableHeaderCell.
	Corrected [scrollColumnToVisible:], so that the column becomes
	visible but not always last. Adopted [scrollViaScroller:] to this
	change. Inlined most private methods and optimized the
	code. Reorganized [_performLoadOfColumn:] to remove code
	duplication. Set the title of a column here and not each time
	when drawing. 
	
2002-09-22 16:33  Alexander Malmberg  <alexander@malmberg.org>

	* Source/NSTextView.m (-initWithFrame:textContainer:): Set
	uses_font_panel and uses_ruler to NO while initializing	and back
	to YES when we're done.

2002-09-22 16:26  Alexander Malmberg  <alexander@malmberg.org>

	* Source/NSFontPanel.m (-init): Set sane defaults _before_ trying
	to set values for the current font.

	Move code to select a certain size in the size browser to
	-_trySelectSize:. Update the size in the preview and the browser
	when the size text field changes.

	Mark private variables and constants as static.

2002-09-22 01:23  Alexander Malmberg  <alexander@malmberg.org>

	* Headers/gnustep/gui/NSView.h, Source/NSPanel.m, Source/NSText.m,
	Source/NSTextField.m, Source/NSView.m, Source/NSWindow.m: Add
	-needsPanelToBecomeKey method to NSView and override it to return
	YES in NSText and NSTextField. Use it in NSPanel to handle
	becomesKeyOnlyIfNeeded properly.

2002-09-21 18:54  Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSOutlineView.m corrected preprocessor error messages.
	* Source/NSToolbar.m corrected preprocessor error messages.
	
2002-09-21 17:48  Alexander Malmberg  <alexander@malmberg.org>

	* Source/NSFontPanel.m (-_familySelectionChanged:, score_difference):
	If an exact match for the wanted weight and traits can't be found,
	score all faces in the new family and select the one that differs
	the least.

2002-09-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile: Set flags to generate documentation using
	templates.

2002-09-18  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSSplitView.m ([NSSplitView -initWithCoder:]):
	set _never_displayed_before to YES.
	* Source/NSFont.m: rearrange the last change to make
	it look like other classes' initWithCoder/encodeWithCoder
	* Source/NSTextView.m: do not call _blink directly
	(suggested by Nicola Pero).
	* Source/NSButtonCell.m 
	([NSButtonCell -drawInteriorWithFrame:inView:]):
	if the button is NSImageOnly, draw the dotted frame at
	the right location.
	
2002-09-16 19:28  Alexander Malmberg  <alexander@malmberg.org>

	* Source/NSFont (+initialize, -initWithCoder:, -encodeWithCoder:):
	Encode and decode matrixExplicitlySet, and guess its value when
	loading old encoded objects.

2002-09-16 19:05  Alexander Malmberg  <alexander@malmberg.org>

	* Source/NSWindow.m (-close): Retain and release self to make sure
	it isn't deallocated until we're done.

2002-09-15  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSStringDrawing.m 
	drawRun() now correctly flags that it wants some temporary memory
	allocated. The old behaviour resulted in a memory leak.
	* Headers/gnustep/gui/NSBrowser.h
	Declare new MacOSX method [drawTitleOfColumn:inRect:]. Removed
	unused ivar _browserCellClass. Replaced ivar _titleCell with a
	static variable used for all browsers.
	* Source/NSBrowser.m
	Use _lastColumnLoaded instead of _lastVisibleColumn  in
	[selectAll:]. Implemented MacOSX [drawTitleOfColumn:inRect:]. 
	Optimized [matrixInColumn:] and use it where suitable.
	Moved calls to [_adjustMatrixOfColumn:] inside of
	[_performLoadOfColumn:].
	
2002-09-15  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSMenuView.m:
	New private method [NSMenuView -_itemCell] in newly created
	GNUstepPrivate category.
	* Source/NSMenu.m:
	Add GNUstepPrivate interface of NSMenuView.
	[NSMenu -_setOwnedByPopUp:]: update itemCells' menuView
	(fix NSPopUpButtonCell-decoding problem).
	* Source/NSPopUpButtonCell.m 
	([NSPopUpButtonCell -synchronizeTitleAndSelectedItem]):
	Fix "mouseUp outside of menu" problem. Now the previous
	selected item stay selected.
	([NSPopUpButtonCell -initWithCoder:]):
	Set the selectedItem properly.
	

2002-09-15 13:17  Alexander Malmberg  <alexander@malmberg.org>

	* Source/NSImage.m (compositeToPoint:fromRect:operation:,,
        dissolveToPoint:fromRect:fraction:): Don't un-flip coordinates
        when drawing in flipped views.

2002-09-14 13:35  Alexander Malmberg  <alexander@malmberg.org>

	* Source/NSFontPanel.m: Break -browser:selectRow:inColumn: into
	three selection changed methods and set them as the action of the
	respective browser.

Fri Sep 13 09:36:06 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/gui/NSNibDeclarations.h: Added include guards.

2002-09-11  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSText.m ([NSText -initWithCoder:]): 
	Retain the decoded background color.
	
	* Source/NSTextView.m : 
	multiple location: don't ignore textContainer's inset
	([NSTextView -initWithCoder:])
	([NSTextView -encodeWithCoder:])
	Encode caret color, textContainer's size and whether the 
	textContainer has widthTracksTextView or heightTracksTextView set.
	([NSTextView -sizeToFit]) Change width (height) only if
	is_horizontally_resizable (is_vertically_resizable).
	([NSTextView -scrollRangeToVisible:]) scrolls to the first char of 
	the range.
	([NSTextView -invalidateTextContainerOrigin]): Don't ignore inset,
	set the origin so that the justification is preserved even if the
	textContainer's width is larger that the textview's width.
	([NSTextView -updateInsertionPointStateAndRestartTimer:]):
	update and place the insertion point properly.
	([NSTextView -moveDown:]) & ([NSTextView -moveUp:]):
	Don't ignore inset. Make insertion point visible.
	
	* Source/NSTextField.m ([NSTextField -acceptsFirstResponder:]):
	responds NO if the editing is still in progrss.
	
	* Source/NSLayoutManager.m 
	([NSLayoutManager -drawBackgroundForGlyphRange:atPoint:]): 
	Don't ignore textContainer's inset.

	* Source/GSSimpleLayoutManager.m
	Replaced [-drawLinesInLineRange:] with
	[-drawLinesInLineRange:atPoint:].
	Replaced [-drawSelectionAsRangeNoCaret:] with
	[-drawSelectionAsRangeNoCaret:atPoint:].
	Those replacements make it easier to take inset into account.
	([-lineFragmentUsedRectForGlyphAtIndex:effectiveRange:])
	([-locationForGlyphAtIndex:])
	([-boundingRectForGlyphRange:inTextContainer:])
	([-rectForCharacterIndex:])
	([-setNeedsDisplayForLineRange:inTextContainer:]):
	Various fixes.
	([-textStorage:edited:range:changeInLength:invalidatedRange:])
	Update insertion point if needed (useful when alignment changes).
	([-rebuildForRange:delta:inTextContainer:]):
	Update layout mechanism.

	* Source/NSCell.m
	([NSCell -highlight:withFrame:inView:]):
	Ask the control to draw the background if we are not opaque.
	([NSCell -editWithFrame:inView:editor:delegate:event:]):
	([NSCell -selectWithFrame:inView:editor:delegate:start:length:]):
	([NSCell -endEditing:]):
	instantiate (and remove) the textview so that it can be scrolled.
	
2002-09-09  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Switch to disaple gsnd.

2002-09-07  Adam Fedor  <fedor@gnu.org>

	* Source/NSBrowser.m: Convert comments for gsdoc.
	(-selectRow:inColumn:): Call delegate -browser:selectRow:inColumn:.
	(-setPath:): Call delegate -browser:selectCellWithString:inColumn:.
	(-doClick:): Do not call the above methods.
	(-initWithCoder:): Set _isLoaded to NO.
	* Source/NSSavePanel.m (-_browser:selectCellWithString:inColumn): 
	Rename from -browser:selectCellWithString:inColumn.
	(_setupForDirectory:file:) Use it.
	* Source/NSOpenPanel.m (-browser:selectCellWithString:inColumn):
	Remove.

	* Source/NSWindow.m ([NSWindow -performClose:]): Don't close
	if a modal session is going and we aren't the modal window.

2002-09-07  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSApplication.m
	Release the invocation in [detachDrawingThread:toTarget:withObject:] 
	not in the helper method. (Patch by David Ayers <d.ayers@inode.at>).
	* Headers/gnustep/gui/NSPasteboard.h
	* Source/externs.m
	Define NSHTMLPboardType.
	* Headers/gnustep/gui/GSTextConverter.h
	Define protocol for method [classForFormat:producer:].
	* Headers/gnustep/gui/NSTextAttachment.h
	Moved NSAttributedString text attachment method declarations to here.
	* Headers/gnustep/gui/NSAttributedString.h
	Define new MacOSX methods.
	* Source/NSAttributedString.m
	Implemented [textFileTypes], [textPasteboardTypes],
	[textUnfilteredFileTypes], [textUnfilteredPasteboardTypes].
	* Source/NSMenu.m
	* Source/NSTextView.m
	Corrected includes.
	
2002-09-06  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/gui/NSPrintInfo.h: Add print option.
	* Source/NSPrintOperation.m ([-_printPaginateWithInfo:knowsRange:): 
	Use it.
	(-_rectForPage:info:xpage:ypage:): Correct xpage/ypage calc.
	(-_adjustPagesFirst:last:info:): Likewise.
	* Source/NSStringDrawing.m (setupSpecialRun): Set base.

	* Source/NSSound.m (-getDataFromFileAtPath:): Use
	fileSystemRepresentation.
	* Source/NSView.m (-beginPage:label:bBox:fonts:): Use
